import { Router } from '@angular/router';
import { Location, LocationStrategy, PathLocationStrategy } from '@angular/common';
import { HttpClient, HttpClientModule, HTTP_INTERCEPTORS } from '@angular/common/http';
import { forkJoin, of, BehaviorSubject, throwError, Subject, interval, EMPTY } from 'rxjs';
import { map, take, tap, switchMap, catchError } from 'rxjs/operators';
import { Injectable, NgModule, defineInjectable, inject } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const DATASUS_ROUTE_HOME = '';
/** @type {?} */
const DATASUS_ROUTE_ERROR_BACKEND = 'erro-comunicacao-servidor';
/** @type {?} */
const DATASUS_ROUTE_FORBIDDEN = 'sem-permissao';
/** @type {?} */
const DATASUS_ROUTE_CHOOSE_PROFILE = 'escolha-perfil';
/** @type {?} */
const DATASUS_ROUTE_RELEASE_NOTES = 'versao';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Atalho para `window.location.href`
 * @param {?} url URL que redirecionado
 * @return {?}
 */
function redirectTo(url) {
    ((/** @type {?} */ (window))).location.href = url;
}
/**
 * Atalho para comparar Objetos.
 * @param {?=} obj1 Objeto 1 de comparação
 * @param {?=} obj2 Objeto 2 de comparação
 * @return {?}
 */
function compareObjects(obj1 = {}, obj2 = {}) {
    if (typeof obj1 !== typeof obj2) {
        return false;
    }
    if (obj1 === obj2) {
        return true;
    }
    /** @type {?} */
    const o1 = obj1 || {};
    /** @type {?} */
    const o2 = obj2 || {};
    if (typeof o1 !== 'object' || typeof o2 !== 'object') {
        return false;
    }
    /**
     * @param {?} o
     * @return {?}
     */
    function fnLength(o) {
        return Object.keys(o).length;
    }
    if (fnLength(o1) !== fnLength(o2)) {
        return false;
    }
    return Object.keys(o1).every((/**
     * @param {?} key
     * @return {?}
     */
    (key) => compareObjects(o1[key], o2[key])));
}
/**
 * Atalho para comparar objeto em lista
 * @param {?} __0
 * @return {?}
 */
function checkObjectInList({ list, obj }) {
    return list.some((/**
     * @param {?} item
     * @return {?}
     */
    (item) => compareObjects(item, obj)));
}
/**
 * Metodo de verificação de intervalo dia, mes e ano
 * @param {?} startDate Data inicio
 * @param {?} stopDate Data fim
 * @param {?} incrementMode Tipo `('days' | 'months' | 'years')`
 * @return {?}
 */
function intervalDates(startDate, stopDate, incrementMode) {
    if (startDate > stopDate) {
        return [];
    }
    /**
     * @return {?}
     */
    function countYears() {
        return Math.ceil((+stopDate - +startDate + 31622400000) / 31622400000);
    }
    /**
     * @return {?}
     */
    function countMounths() {
        return Math.ceil(((+stopDate + 2678400000) - +startDate) / 2678400000);
    }
    /**
     * @return {?}
     */
    function countDays() {
        return Math.ceil(((+stopDate + 86400000) - +startDate) / 86400000);
    }
    /** @type {?} */
    const incrementMap = {
        /**
         * \@todo precisar melhoarar o algoritimo
         */
        days: (/**
         * @return {?}
         */
        () => {
            /** @type {?} */
            let day = startDate.getDate();
            return new Array(countDays()).fill(undefined).map((/**
             * @return {?}
             */
            () => new Date(startDate.getFullYear(), startDate.getMonth(), day++)));
        }),
        months: (/**
         * @return {?}
         */
        () => {
            /** @type {?} */
            let month = startDate.getMonth();
            return new Array(countMounths()).fill(undefined).map((/**
             * @return {?}
             */
            () => new Date(startDate.getFullYear(), month++)));
        }),
        years: (/**
         * @return {?}
         */
        () => {
            /** @type {?} */
            let year = startDate.getFullYear();
            return new Array(countYears()).fill(undefined).map((/**
             * @return {?}
             */
            () => new Date(year++)));
        }),
    };
    /** @type {?} */
    const dateArray = incrementMap[incrementMode]();
    return dateArray;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Atalho para `encodeURIComponent()`
 * @param {?} uri Algo que precisa de ser codificado
 * @return {?}
 */
function urlEncode(uri) {
    return encodeURIComponent(uri);
}
/**
 * Atalho para `decodeURIComponent()`
 * @param {?} uri Algo que precisa de ser decodificado
 * @return {?}
 */
function urlDecode(uri) {
    return decodeURIComponent(uri);
}
/**
 * Atalho para codificar em base64 usando UTF-8
 * @param {?} str Texto a ser codificado
 * @return {?}
 */
function base64Encode(str) {
    return btoa(urlEncode(str)
        .replace(/%([0-9A-F]{2})/g, (/**
     * @param {?} _
     * @param {?} char
     * @return {?}
     */
    (_, char) => String.fromCharCode(parseInt('0x' + char, 16)))));
}
/**
 * Atalho para decodificar um texto em UTF-8 na codificação base64
 * @param {?} base64 Texto a ser decodificado
 * @return {?}
 */
function base64Decode(base64) {
    return urlDecode(atob(base64)
        .split('')
        .map((/**
     * @param {?} char
     * @return {?}
     */
    char => '%' + ('00' + char.charCodeAt(0).toString(16)).slice(-2)))
        .join(''));
}
/**
 * Atalho para decodificar um texto em UTF-8 na codificação base64
 * Retornando um TypedArray: Uint8Array
 * @param {?} base64 Texto a ser decodificado
 * @return {?}
 */
function base64DecodeToTypedArray(base64) {
    /** @type {?} */
    const binaryString = base64Decode(base64);
    /** @type {?} */
    const binaryLen = binaryString.length;
    /** @type {?} */
    const bytes = new Uint8Array(binaryLen);
    for (let i = 0; i < binaryLen; i++) {
        bytes[i] = binaryString.charCodeAt(i);
    }
    return bytes;
}
/**
 * Atalho para decodificar um texto em UTF-8 na codificação base64
 * Retornando um Blob
 * @param {?} base64 Texto a ser decodificado
 * @param {?} contentType Mime type do Blob
 * @return {?}
 */
function base64DecodeToBlob(base64, contentType) {
    contentType = contentType || 'application/octet-stream';
    return new Blob([base64DecodeToTypedArray(base64)], { type: contentType });
}
/**
 * Atalho para para converter uma string em objeto Blob
 * Retornando um Blob
 * @param {?} str Texto a ser decodificado
 * @param {?} contentType Mime type do Blob
 * @return {?}
 */
function stringToBlob(str, contentType) {
    contentType = contentType || 'application/octet-stream';
    return new Blob([stringToTypedArray(str)], { type: contentType });
}
/**
 * Atalho para decodificar um texto em TypedArray
 * Retornando um TypedArray: Uint8Array
 * @param {?} str Texto a ser decodificado
 * @return {?}
 */
function stringToTypedArray(str) {
    /** @type {?} */
    const binaryLen = str.length;
    /** @type {?} */
    const bytes = new Uint8Array(binaryLen);
    for (let i = 0; i < binaryLen; i++) {
        bytes[i] = str.charCodeAt(i);
    }
    return bytes;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const CONFIG_ENV_JSON_PATH = '/config/env.json';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Serviço responsável por trazer as configurações
 * de `/config/env.json`
 * (local das configurações por ambiente.)
 */
class ConfigService {
    /**
     * Inicializador da classe
     * @param {?} httpClient Cliente para as requisiçõe HTTP
     */
    constructor(httpClient) {
        this.httpClient = httpClient;
        /**
         * Cache das configurações
         */
        this.cache = new Map();
    }
    /**
     * Registra nas configurações para fins de cache
     * qual aplicação em questão
     * @param {?} name Nome da aplicação
     * @param {?} version Versão da aplicação
     * @return {?}
     */
    registerApp(name, version) {
        console.log('%cRegistrando aplicação: %s (%s)', 'color: #fafafa; background: #424242', name, version);
        this.appKey = `app:${name}|version:${version}`;
    }
    /**
     * Retorna um `Observable`. Se assinado vai
     * trazer todas as configurações em
     * um objeto só
     * @return {?}
     */
    getAll() {
        if (this.cache.has(this.appKey)) {
            return of(this.cache.get(this.appKey));
        }
        else {
            return this.httpClient.get(CONFIG_ENV_JSON_PATH).pipe(take(1), tap((/**
             * @param {?} config
             * @return {?}
             */
            (config) => this.cache.set(this.appKey, config))));
        }
    }
    /**
     * Retorna um `Observable`. Se assinado vai
     * trazer a configuração selecionada
     * @param {?} property Propriedade da configuração a ser retornada no `Observable`
     * @return {?}
     */
    get(property) {
        return this.getAll().pipe(map((/**
         * @param {?} config
         * @return {?}
         */
        (config) => (/** @type {?} */ (config[property]))))).pipe(take(1));
    }
    /**
     * Retorna um `Observable`. Se assinado vai
     * trazer as configurações selecionadas
     * em uma lista
     * @param {?} properties Lista de propriedades da configuração a serem retornadas no `Observable`
     * @return {?}
     */
    getList(properties) {
        return forkJoin(properties.map((/**
         * @param {?} property
         * @return {?}
         */
        (property) => this.get(property)))).pipe(take(1));
    }
}
ConfigService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
ConfigService.ctorParameters = () => [
    { type: HttpClient }
];
/** @nocollapse */ ConfigService.ngInjectableDef = defineInjectable({ factory: function ConfigService_Factory() { return new ConfigService(inject(HttpClient)); }, token: ConfigService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Atalho otimizado para recuperar e
 * inserir coisas no `window.localStorage`
 */
class LocalStorage {
    /**
     * Insere informação no `window.localStorage`
     * @param {?} key Chave que será utilizada
     * @param {?} value Valor que vai ser inserido
     * @return {?}
     */
    static setItem(key, value) {
        try {
            ((/** @type {?} */ (window))).localStorage.setItem(key, JSON.stringify(value));
        }
        catch (e) {
            console.error(e);
        }
    }
    /**
     * Recupera o valor no `window.localStorage`
     * @param {?} key Chave do valor que será recuperado
     * @return {?}
     */
    static getItem(key) {
        try {
            return JSON.parse(((/** @type {?} */ (window))).localStorage.getItem(key));
        }
        catch (e) {
            console.error(e);
            return null;
        }
    }
    /**
     * Remove o valor no `window.localStorage`
     * @param {?} key Chave do valor que será removido
     * @return {?}
     */
    static removeItem(key) {
        try {
            ((/** @type {?} */ (window))).localStorage.removeItem(key);
        }
        catch (e) {
            console.error(e);
        }
    }
    /**
     * Verifica se existe valor no `window.localStorage`
     * @param {?} key Chave do valor que será verificada
     * @return {?}
     */
    static hasItem(key) {
        try {
            /** @type {?} */
            const value = LocalStorage.getItem(key);
            return !!value;
        }
        catch (e) {
            console.error(e);
            return false;
        }
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const STORAGE_KEY_PERFIS = '×DATASUS·Perfis';
/** @type {?} */
const STORAGE_KEY_PERFIL_SELECIONADO = '×DATASUS·Perfil selecionado';
/** @type {?} */
const STORAGE_KEY_ESFERA_SELECIONADA = '×DATASUS·Esfera selecionada';
/** @type {?} */
const HTTP_HEADER_PERFIL = 'cz-aphrodite-de-peixes';
/** @type {?} */
const HTTP_HEADER_ESFERA = 'cz-milo-de-escopiao';
/** @type {?} */
const HTTP_HEADER_ESFERA_ATUACAO = 'cz-mu-de-aries';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Serviço que tem os atalhos para acessar
 * informações como perfil e esfera
 */
class SecurityService {
    /**
     * @param {?} location
     * @param {?} router
     * @param {?} httpClient
     * @param {?} configService
     */
    constructor(location, router, httpClient, configService) {
        this.location = location;
        this.router = router;
        this.httpClient = httpClient;
        this.configService = configService;
        this.perfis$ = new BehaviorSubject([]);
        this.perfilSelecionado$ = new BehaviorSubject(null);
        this.esferaSelecionada$ = new BehaviorSubject(null);
    }
    /**
     * @return {?}
     */
    requestProfiles() {
        return this.configService.getList([
            'backendUrl',
            'clientId',
        ]).pipe(switchMap((/**
         * @param {?} configs
         * @return {?}
         */
        (configs) => {
            /** @type {?} */
            const backendUrl = configs[0];
            /** @type {?} */
            const clientId = configs[1];
            console.log('[SecurityService::requestProfiles] Vamos recuperar os perfis', backendUrl, clientId);
            return this.httpClient.get(`${backendUrl}/acesso/sistema/${clientId}/perfil`).pipe(take(1), tap((/**
             * @param {?} profiles
             * @return {?}
             */
            (profiles) => {
                console.log('[SecurityService::requestProfiles] Perfis e suas esferas', profiles);
                this.setPerfis(profiles);
            })));
        })));
    }
    /**
     * @param {?=} forceRedirectToHome
     * @return {?}
     */
    navigateToChooseProfile(forceRedirectToHome = false) {
        /** @type {?} */
        const returnPath = forceRedirectToHome
            ? DATASUS_ROUTE_HOME
            : (this.location.path(true) || DATASUS_ROUTE_HOME);
        /** @type {?} */
        const route = [`/${DATASUS_ROUTE_CHOOSE_PROFILE}`];
        if (!!returnPath) {
            /** @type {?} */
            const ignoreRoutes = [
                DATASUS_ROUTE_CHOOSE_PROFILE,
                DATASUS_ROUTE_FORBIDDEN,
                DATASUS_ROUTE_ERROR_BACKEND,
            ];
            /** @type {?} */
            const ignoreRoutesFiltered = ignoreRoutes.filter((/**
             * @param {?} ignoreRoute
             * @return {?}
             */
            (ignoreRoute) => !returnPath.includes(ignoreRoute)));
            if (ignoreRoutes.length === ignoreRoutesFiltered.length) {
                route.push({ returnPath });
            }
        }
        console.log('[SecurityService::navigateToChooseProfile]', route);
        this.router.navigate(route);
    }
    /**
     * @param {?} __0
     * @return {?}
     */
    chooseProfileAndNavigate({ returnPath, perfil, esfera }) {
        console.log('[SecurityService::chooseProfileAndNavigate]', perfil, esfera);
        this.setPerfilSelecionado(perfil);
        if (esfera) {
            this.setEsferaSelecionada(esfera);
        }
        else {
            this.clearEsferaSelecionada();
        }
        console.log('[SecurityService::chooseProfileAndNavigate] go to %s', '/' + (returnPath || ''));
        this.router.navigate(['/' + (returnPath || '')]);
    }
    /**
     * Limpa os dados de perfil e esfera
     * @return {?}
     */
    clear() {
        this.clearPerfis();
        this.clearPerfilSelecionado();
        this.clearEsferaSelecionada();
    }
    /**
     * Limpa a lista de perfis
     * @return {?}
     */
    clearPerfis() {
        LocalStorage.removeItem(this.key(STORAGE_KEY_PERFIS));
        this.perfis$.next([]);
    }
    /**
     * Verifica se tem lista de perfis
     * @return {?}
     */
    hasPerfis() {
        return !!(LocalStorage.getItem(this.key(STORAGE_KEY_PERFIS)) || []).length;
    }
    /**
     * Recupera a lista de perfis
     * @return {?}
     */
    getPerfis() {
        this.perfis$.next(LocalStorage.getItem(this.key(STORAGE_KEY_PERFIS)) || []);
        return this.perfis$.asObservable();
    }
    /**
     * Salva a lista de perfis
     * @param {?} perfis Lista de perfis
     * @return {?}
     */
    setPerfis(perfis) {
        LocalStorage.setItem(this.key(STORAGE_KEY_PERFIS), this.decoratePerfis(perfis));
        this.perfis$.next(perfis);
    }
    /**
     * Limpa o perfil selecionado
     * @return {?}
     */
    clearPerfilSelecionado() {
        LocalStorage.removeItem(this.key(STORAGE_KEY_PERFIL_SELECIONADO));
        this.perfilSelecionado$.next(null);
        this.clearEsferaSelecionada();
    }
    /**
     * Verifica se tem perfil selecionado
     * @return {?}
     */
    hasPerfilSelecionado() {
        return this.hasDescricao(this.getStoredPerfilSelecionado());
    }
    /**
     * Recupera o observable do perfil selecionado
     * @return {?}
     */
    getPerfilSelecionado() {
        this.perfilSelecionado$.next(this.getStoredPerfilSelecionado());
        return this.perfilSelecionado$.asObservable();
    }
    /**
     * Recupera o perfil selecionado armazenada
     * @return {?}
     */
    getStoredPerfilSelecionado() {
        return LocalStorage.getItem(this.key(STORAGE_KEY_PERFIL_SELECIONADO));
    }
    /**
     * Salva o perfil selecionado
     * @param {?} perfil Perfil selecionado
     * @return {?}
     */
    setPerfilSelecionado(perfil) {
        LocalStorage.setItem(this.key(STORAGE_KEY_PERFIL_SELECIONADO), this.decoratePerfil(perfil));
        this.perfilSelecionado$.next(perfil);
        this.clearEsferaSelecionada();
    }
    /**
     * Limpa a esfera selecionada
     * @return {?}
     */
    clearEsferaSelecionada() {
        LocalStorage.removeItem(this.key(STORAGE_KEY_ESFERA_SELECIONADA));
        this.esferaSelecionada$.next(null);
    }
    /**
     * Verifica se tem esfera selecionada
     * @return {?}
     */
    hasEsferaSelecionada() {
        return this.hasDescricao(this.getStoredEsferaSelecionada());
    }
    /**
     * Recupera o observable da esfera selecionada
     * @return {?}
     */
    getEsferaSelecionada() {
        this.esferaSelecionada$.next(this.getStoredEsferaSelecionada());
        return this.esferaSelecionada$.asObservable();
    }
    /**
     * Recupera a esfera selecionada armazenada
     * @return {?}
     */
    getStoredEsferaSelecionada() {
        return LocalStorage.getItem(this.key(STORAGE_KEY_ESFERA_SELECIONADA));
    }
    /**
     * Salva a esfera selecionada
     * @param {?} esfera Esfera selecionada
     * @return {?}
     */
    setEsferaSelecionada(esfera) {
        LocalStorage.setItem(this.key(STORAGE_KEY_ESFERA_SELECIONADA), this.decorateEsfera(esfera));
        this.esferaSelecionada$.next(esfera);
    }
    /**
     * @private
     * @param {?} perfis
     * @return {?}
     */
    decoratePerfis(perfis) {
        /** @type {?} */
        const perfisWithDecoratedEsferas = (perfis || []).map((/**
         * @param {?} perfil
         * @return {?}
         */
        (perfil) => this.decoratePerfil(perfil)));
        return perfisWithDecoratedEsferas;
    }
    /**
     * @private
     * @param {?} perfil
     * @return {?}
     */
    decoratePerfil(perfil) {
        /** @type {?} */
        const perfilWithDecoratedEsferas = Object.assign({}, perfil);
        perfilWithDecoratedEsferas.esferas = this.decorateEsferas(perfilWithDecoratedEsferas.esferas);
        return perfilWithDecoratedEsferas;
    }
    /**
     * @private
     * @param {?} esferas
     * @return {?}
     */
    decorateEsferas(esferas) {
        /** @type {?} */
        const esferasDecorated = (esferas || []).map((/**
         * @param {?} esfera
         * @return {?}
         */
        (esfera) => this.decorateEsfera(esfera)));
        return esferasDecorated;
    }
    /**
     * @private
     * @param {?} esfera
     * @return {?}
     */
    decorateEsfera(esfera) {
        /** @type {?} */
        const esferaDecorated = Object.assign({}, esfera);
        esferaDecorated.esferaAtuacaoList = this.extractList(esfera.esferaAtuacao);
        esferaDecorated.descricaoEsferaAtuacaoList = this.extractList(esfera.descricaoEsferaAtuacao);
        return esferaDecorated;
    }
    /**
     * @private
     * @param {?=} source
     * @return {?}
     */
    extractList(source = '') {
        return (source || '').replace(/\/$/, '').split('/').filter((/**
         * @param {?} item
         * @return {?}
         */
        (item) => !!item));
    }
    /**
     * @private
     * @param {?} item
     * @return {?}
     */
    hasDescricao(item) {
        return (!!item && !!item.descricao);
    }
    /**
     * @private
     * @param {?} key
     * @return {?}
     */
    key(key) {
        return `${key} @ ${this.configService.appKey}`;
    }
}
SecurityService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
SecurityService.ctorParameters = () => [
    { type: Location },
    { type: Router },
    { type: HttpClient },
    { type: ConfigService }
];
/** @nocollapse */ SecurityService.ngInjectableDef = defineInjectable({ factory: function SecurityService_Factory() { return new SecurityService(inject(Location), inject(Router), inject(HttpClient), inject(ConfigService)); }, token: SecurityService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AuthService {
    /**
     * @param {?} location
     * @param {?} httpClient
     * @param {?} configService
     * @param {?} securityService
     */
    constructor(location, httpClient, configService, securityService) {
        this.location = location;
        this.httpClient = httpClient;
        this.configService = configService;
        this.securityService = securityService;
        this.gettingOut$ = new Subject();
    }
    /**
     * Retorna o Observable com a URL de saida do sistema
     * @return {?}
     */
    gettingOutEvent() {
        return this.gettingOut$.asObservable();
    }
    /**
     * Retorna o Observable se está logado ou não
     * @return {?}
     */
    isAuthenticated() {
        return this.configService.get('backendUrl').pipe(switchMap((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => {
            console.log('[AuthService::isAuthenticated] Vamos verificar se já está autenticado', backendUrl);
            /** @type {?} */
            const request$ = this.httpClient.get(`${backendUrl}/oauth/verify`).pipe(take(1), catchError((/**
             * @param {?} error
             * @return {?}
             */
            (error) => {
                if (error.code === 401) {
                    console.warn('[AuthService::isAuthenticated] Não está autenticado');
                }
                else if (error.code === 403) {
                    console.warn('[AuthService::isAuthenticated] Acesso proíbido cadastrado');
                }
                else {
                    console.warn('[AuthService::isAuthenticated] Ops, erro na verificação', error);
                }
                return throwError(error);
            })), map((/**
             * @param {?} result
             * @return {?}
             */
            (result) => {
                console.log('[AuthService::isAuthenticated] Acessou a URL do backend de boa!', result);
                if (!result) {
                    throw result;
                }
                return result;
            })));
            return request$;
        })));
    }
    /**
     * Retorna o nome completo do usuário autorizado
     * @return {?}
     */
    getUser() {
        console.log('[AuthService::getUser] Vamos buscar os dados do usuário ...');
        if (this.user) {
            console.log('[AuthService::getUser] ... Pegou do cache!');
            return of(this.user);
        }
        console.log('[AuthService::getUser] ... Vai pegar o backend ...');
        return this.isAuthenticated().pipe(switchMap((/**
         * @param {?} isAutenticated
         * @return {?}
         */
        (isAutenticated) => {
            if (!isAutenticated) {
                console.log('[AuthService::getUser] ... Não está autenticado!');
                return throwError(null);
            }
            console.log('[AuthService::getUser] ... Está autenticado, pode pegar lá!');
            return this.configService.get('backendUrl').pipe(switchMap((/**
             * @param {?} backendUrl
             * @return {?}
             */
            (backendUrl) => this.httpClient.get(`${backendUrl}/acesso/usuario`).pipe(tap((/**
             * @param {?} usuario
             * @return {?}
             */
            (usuario) => this.user = usuario))))));
        })));
    }
    /**
     * Efetua o logout do sistema
     * @return {?}
     */
    logout() {
        this.configService.get('backendUrl').subscribe((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => {
            /** @type {?} */
            const logoutUrl = `${backendUrl}/logout`;
            console.log('[AuthService::logout] Redirecionando para deslogar:', logoutUrl);
            this.getOut(logoutUrl);
        }));
    }
    /**
     * @return {?}
     */
    login() {
        this.configService.getList([
            'backendUrl',
            'frontendUrl',
        ]).subscribe((/**
         * @param {?} configs
         * @return {?}
         */
        (configs) => {
            /** @type {?} */
            const backendUrl = configs[0];
            /** @type {?} */
            const returnPath = this.location.path(true) || '';
            /** @type {?} */
            const frontendUrl = urlEncode(`${configs[1]}${returnPath}`);
            /** @type {?} */
            const autorizeUrl = `${backendUrl}/oauth/authorize?redirect_uri=${frontendUrl}`;
            console.log('[AuthService::redirectToAuthorize] Redirecionando para autorizar:', autorizeUrl);
            this.getOut(autorizeUrl);
        }));
    }
    /**
     * @param {?} url
     * @return {?}
     */
    getOut(url) {
        this.gettingOut$.next(url);
        this.user = null;
        this.securityService.clear();
        setTimeout((/**
         * @return {?}
         */
        () => redirectTo(url)), 1000);
    }
    /**
     * @return {?}
     */
    cookie() {
        return this.configService.get('backendUrl').pipe(switchMap((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => this.httpClient.get(`${backendUrl}/cookie`, {
            responseType: 'text'
        }).pipe(take(1)))));
    }
}
AuthService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root',
            },] }
];
/** @nocollapse */
AuthService.ctorParameters = () => [
    { type: Location },
    { type: HttpClient },
    { type: ConfigService },
    { type: SecurityService }
];
/** @nocollapse */ AuthService.ngInjectableDef = defineInjectable({ factory: function AuthService_Factory() { return new AuthService(inject(Location), inject(HttpClient), inject(ConfigService), inject(SecurityService)); }, token: AuthService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AuthGuard {
    /**
     * @param {?} router
     * @param {?} authService
     */
    constructor(router, authService) {
        this.router = router;
        this.authService = authService;
    }
    /**
     * @param {?} next
     * @param {?} state
     * @return {?}
     */
    canActivate(next, state) {
        try {
            console.log('[AuthGuard::canActivate]');
            return this.isAuthenticatedOrExit();
        }
        catch (error) {
            console.warn('[AuthGuard::canActivate] catch error', error);
            return false;
        }
    }
    /**
     * @param {?} route
     * @param {?} segments
     * @return {?}
     */
    canLoad(route, segments) {
        try {
            console.log('[AuthGuard::canLoad]');
            return this.isAuthenticatedOrExit();
        }
        catch (error) {
            console.warn('[AuthGuard::canLoad] catch error', error);
            return false;
        }
    }
    /**
     * @private
     * @return {?}
     */
    isAuthenticatedOrExit() {
        return this.authService.isAuthenticated().pipe(catchError((/**
         * @param {?} error
         * @return {?}
         */
        (error) => {
            if (error.code === 401) {
                console.log('[AuthGuard::isAuthenticatedOrExit] Não está autenticado (status: 401)');
                this.authService.login();
            }
            else if (error.code === 403) {
                console.log('[AuthGuard::isAuthenticatedOrExit] Acesso proíbido cadastrado (status: 403)');
                this.router.navigate([`/${DATASUS_ROUTE_FORBIDDEN}`]);
            }
            else {
                console.warn('[AuthGuard::isAuthenticatedOrExit] Ops, erro na verificação', error);
                this.router.navigate([`/${DATASUS_ROUTE_ERROR_BACKEND}`]);
            }
            return throwError(false);
        })), tap((/**
         * @param {?} result
         * @return {?}
         */
        (result) => {
            if (!result) {
                console.log('[AuthGuard::isAuthenticatedOrExit] Não está autenticado (status: 200)');
                this.authService.login();
            }
            console.log('[AuthGuard::isAuthenticatedOrExit] Está autentidado (status: 200)');
        })));
    }
}
AuthGuard.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
AuthGuard.ctorParameters = () => [
    { type: Router },
    { type: AuthService }
];
/** @nocollapse */ AuthGuard.ngInjectableDef = defineInjectable({ factory: function AuthGuard_Factory() { return new AuthGuard(inject(Router), inject(AuthService)); }, token: AuthGuard, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SecurityGuard {
    /**
     * @param {?} router
     * @param {?} securityService
     */
    constructor(router, securityService) {
        this.router = router;
        this.securityService = securityService;
    }
    /**
     * @param {?} next
     * @param {?} state
     * @return {?}
     */
    canActivate(next, state) {
        try {
            console.log('[SecurityGuard::canActivate]');
            return this.checkRoles();
        }
        catch (error) {
            console.warn('[SecurityGuard::canActivate] catch error', error);
            return false;
        }
    }
    /**
     * @param {?} route
     * @param {?} segments
     * @return {?}
     */
    canLoad(route, segments) {
        try {
            console.log('[SecurityGuard::canLoad]');
            return this.checkRoles();
        }
        catch (error) {
            console.warn('[SecurityGuard::canLoad] catch error', error);
            return false;
        }
    }
    /**
     * @private
     * @return {?}
     */
    checkRoles() {
        if (this.securityService.hasPerfilSelecionado()) {
            console.log('[SecurityGuard::checkRoles] Já tem perfil selecionado');
            return true;
        }
        return this.securityService.requestProfiles().pipe(catchError((/**
         * @param {?} error
         * @return {?}
         */
        (error) => {
            console.warn('[SecurityGuard::checkRoles] Erro', error);
            this.router.navigate([`/${DATASUS_ROUTE_FORBIDDEN}`]);
            return throwError(false);
        })), switchMap((/**
         * @param {?} perfis
         * @return {?}
         */
        (perfis) => {
            this.securityService.setPerfis(perfis);
            if (!perfis || !perfis.length) {
                console.warn('[SecurityGuard::checkRoles] Sem perfis');
                this.router.navigate([`/${DATASUS_ROUTE_FORBIDDEN}`]);
                return of(false);
            }
            if (perfis.length > 1) {
                console.log('[SecurityGuard::checkRoles] Mais de um perfil, vai para a tela de seleção');
                this.securityService.navigateToChooseProfile();
                return of(false);
            }
            /** @type {?} */
            const perfil = perfis[0];
            if (!perfil.esferas || !perfil.esferas.length) {
                console.warn('[SecurityGuard::checkRoles] Perfil sem esferas', perfil);
                this.router.navigate([`/${DATASUS_ROUTE_FORBIDDEN}`]);
                return of(false);
            }
            if (perfil.esferas.length > 1) {
                console.log('[SecurityGuard::checkRoles] Mais de uma esfera para o perfil, vai para a tela de seleção');
                this.securityService.navigateToChooseProfile();
                return of(false);
            }
            /** @type {?} */
            const esfera = perfil.esferas[0];
            this.securityService.setPerfilSelecionado(perfil);
            this.securityService.setEsferaSelecionada(esfera);
            return of(true);
        })));
    }
}
SecurityGuard.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
SecurityGuard.ctorParameters = () => [
    { type: Router },
    { type: SecurityService }
];
/** @nocollapse */ SecurityGuard.ngInjectableDef = defineInjectable({ factory: function SecurityGuard_Factory() { return new SecurityGuard(inject(Router), inject(SecurityService)); }, token: SecurityGuard, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PathGuard {
    /**
     * @param {?} httpClient
     * @param {?} router
     * @param {?} location
     * @param {?} configService
     * @param {?} securityService
     */
    constructor(httpClient, router, location, configService, securityService) {
        this.httpClient = httpClient;
        this.router = router;
        this.location = location;
        this.configService = configService;
        this.securityService = securityService;
        this.defaultPathExceptHome = [
            DATASUS_ROUTE_ERROR_BACKEND,
            DATASUS_ROUTE_FORBIDDEN,
            DATASUS_ROUTE_CHOOSE_PROFILE,
        ];
    }
    /**
     * @param {?} next
     * @param {?} state
     * @return {?}
     */
    canActivate(next, state) {
        try {
            console.log('[PathGuard::canActivate]');
            /** @type {?} */
            const path = state.url;
            return this.checkFunctionalities(this.location.normalize(path));
        }
        catch (error) {
            console.warn('[PathGuard::canActivate] catch error', error);
            return false;
        }
    }
    /**
     * @param {?} route
     * @param {?} segments
     * @return {?}
     */
    canLoad(route, segments) {
        try {
            console.log('[PathGuard::canLoad]');
            /** @type {?} */
            const path = segments.map((/**
             * @param {?} segment
             * @return {?}
             */
            (segment) => segment.path)).join('/');
            return this.checkFunctionalities(this.location.normalize(`/${path}`));
        }
        catch (error) {
            console.warn('[PathGuard::canLoad] catch error', error);
            return false;
        }
    }
    /**
     * @private
     * @param {?} path
     * @return {?}
     */
    checkFunctionalities(path) {
        console.log('[PathGuard::checkFunctionalities]', path);
        if (path === DATASUS_ROUTE_HOME) {
            console.log('[PathGuard::checkFunctionalities] é a home');
            return true;
        }
        /** @type {?} */
        const filteredPaths = this.defaultPathExceptHome.filter((/**
         * @param {?} defaultPath
         * @return {?}
         */
        (defaultPath) => path.includes(this.location.normalize(defaultPath)))) || [];
        if (!!filteredPaths.length) {
            console.log('[PathGuard::checkFunctionalities] é uma das rotas padrões', filteredPaths);
            return true;
        }
        if (!this.securityService.hasPerfilSelecionado()) {
            console.log('[PathGuard::checkFunctionalities] Não tem perfil selecionado');
            return false;
        }
        /** @type {?} */
        const perfil = this.securityService.getStoredPerfilSelecionado();
        // const cacheKey = `×DATASUS·Funcionalidades:${perfil.sigla} @ ${this.configService.appKey}`;
        // if (LocalStorage.hasItem(cacheKey)) {
        //   return this.checkList(LocalStorage.getItem(cacheKey), path);
        // }
        return this.configService.getList([
            'backendUrl',
            'clientId',
        ]).pipe(switchMap((/**
         * @param {?} configs
         * @return {?}
         */
        (configs) => {
            /** @type {?} */
            const backendUrl = configs[0];
            /** @type {?} */
            const clientId = configs[1];
            console.log('[PathGuard::checkFunctionalities] Vamos recuperar as funcionalidades', backendUrl, clientId, perfil.sigla);
            /** @type {?} */
            const request$ = this.httpClient.get(`${backendUrl}/acesso/sistema/${clientId}/perfil/${perfil.sigla}/funcionalidade`).pipe(take(1), catchError((/**
             * @param {?} error
             * @return {?}
             */
            (error) => {
                console.warn('[PathGuard::checkFunctionalities] Erro', error);
                this.router.navigate([`/${DATASUS_ROUTE_FORBIDDEN}`]);
                return throwError(of(false));
            })), 
            // tap(
            //   (funcionalidades: FuncionalidadeModel[]) => LocalStorage.setItem(cacheKey, funcionalidades)
            // ),
            switchMap((/**
             * @param {?} funcionalidades
             * @return {?}
             */
            (funcionalidades) => this.checkList(funcionalidades, path))));
            return request$;
        })));
    }
    /**
     * @private
     * @param {?} funcionalidade
     * @param {?} path
     * @return {?}
     */
    checkPath(funcionalidade, path) {
        if (!funcionalidade) {
            return false;
        }
        if (funcionalidade.bloqueado) {
            return false;
        }
        /** @type {?} */
        const pathFuncionalidade = this.location.normalize(funcionalidade.path);
        // Funcionalidade com parãmetro?
        // (Ex.: "rota/com/param/:id", "caminho/da/rota/:x/com/outro/param/:y" ou "caminho/:x/:y/feio")
        if (pathFuncionalidade.includes('/:')) {
            /** @type {?} */
            const regex = /\:[^/\W]*\/?/g;
            /** @type {?} */
            const terms = pathFuncionalidade.split(regex) || [];
            if (!terms.length) {
                return false;
            }
            return terms
                .filter((/**
             * @param {?} term
             * @return {?}
             */
            (term) => !!term))
                .every((/**
             * @param {?} term
             * @return {?}
             */
            (term) => path.includes(term)));
        }
        // Rota cadastrada é exatamente a mesma cadastrada para acessar?
        return pathFuncionalidade === path;
    }
    /**
     * @private
     * @param {?} funcionalidades
     * @param {?} path
     * @return {?}
     */
    checkList(funcionalidades, path) {
        // console.log('[PathGuard::checkFunctionalities] Funcionalidades', funcionalidades);
        if (!funcionalidades || !funcionalidades.length) {
            console.warn('[PathGuard::checkFunctionalities] Sem funcionalidades');
            this.router.navigate([`/${DATASUS_ROUTE_FORBIDDEN}`]);
            return of(false);
        }
        /** @type {?} */
        const filtered = funcionalidades.filter((/**
         * @param {?} funcionalidade
         * @return {?}
         */
        (funcionalidade) => this.checkPath(funcionalidade, path))) || [];
        if (filtered.length <= 0) {
            return throwError('Você não tem permissão para acessar.');
        }
        console.log('[PathGuard::checkFunctionalities] Achou a funcionalidade');
        return of(true);
    }
}
PathGuard.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
PathGuard.ctorParameters = () => [
    { type: HttpClient },
    { type: Router },
    { type: Location },
    { type: ConfigService },
    { type: SecurityService }
];
/** @nocollapse */ PathGuard.ngInjectableDef = defineInjectable({ factory: function PathGuard_Factory() { return new PathGuard(inject(HttpClient), inject(Router), inject(Location), inject(ConfigService), inject(SecurityService)); }, token: PathGuard, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Atalho otimizado para recuperar e
 * inserir coisas no `window.sessionStorage`
 */
class SessionStorage {
    /**
     * Insere informação no `window.sessionStorage`
     * @param {?} key Chave que será utilizada
     * @param {?} value Valor que vai ser inserido
     * @return {?}
     */
    static setItem(key, value) {
        try {
            ((/** @type {?} */ (window))).sessionStorage.setItem(key, JSON.stringify(value));
        }
        catch (e) {
            console.error(e);
        }
    }
    /**
     * Recupera o valor no `window.sessionStorage`
     * @param {?} key Chave do valor que será recuperado
     * @return {?}
     */
    static getItem(key) {
        try {
            return JSON.parse(((/** @type {?} */ (window))).sessionStorage.getItem(key));
        }
        catch (e) {
            console.error(e);
            return null;
        }
    }
    /**
     * Remove o valor no `window.sessionStorage`
     * @param {?} key Chave do valor que será removido
     * @return {?}
     */
    static removeItem(key) {
        try {
            ((/** @type {?} */ (window))).sessionStorage.removeItem(key);
        }
        catch (e) {
            console.error(e);
        }
    }
    /**
     * Verifica se existe valor no `window.sessionStorage`
     * @param {?} key Chave do valor que será verificada
     * @return {?}
     */
    static hasItem(key) {
        try {
            /** @type {?} */
            const value = SessionStorage.getItem(key);
            return !!value;
        }
        catch (e) {
            console.error(e);
            return false;
        }
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Monta para o envelope padrão da paginação os
 * parâmetros de número da página
 * e tamanho da página
 * @see PageableRequestModel
 * @param {?} config
 *  withPageEvent: Evento do Paginador
 *  to: component Componente que contenha o atributo `pageSize`
 *  changingPageSizeDefaultTo: Valor padrão para o atributo `pageSize`: **10** itens por página.
 * @return {?}
 */
function requestItemsParams(config) {
    /** @type {?} */
    let pageNumber = 1;
    config.to.pageSize = config.changingPageSizeDefaultTo || 10;
    if (config.withPageEvent) {
        pageNumber = (config.withPageEvent.pageIndex || 0) + 1;
        config.to.pageSize = config.withPageEvent.pageSize || config.to.pageSize;
    }
    /** @type {?} */
    const sort = {};
    if (config.withSort && !!config.withSort.direction) {
        sort.sortField = config.withSort.active;
        sort.sortType = (/** @type {?} */ (config.withSort.direction.toUpperCase()));
    }
    return Object.assign({ pageSize: config.to.pageSize, pageNumber }, sort);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// tslint:disable
/**
 * @param {?} s
 * @return {?}
 */
function SHA256(s) {
    /** @type {?} */
    const chrsz = 8;
    /**
     * @param {?} x
     * @param {?} y
     * @return {?}
     */
    function safe_add(x, y) {
        /** @type {?} */
        const lsw = (x & 0xFFFF) + (y & 0xFFFF);
        /** @type {?} */
        const msw = (x >> 16) + (y >> 16) + (lsw >> 16);
        return (msw << 16) | (lsw & 0xFFFF);
    }
    /**
     * @param {?} X
     * @param {?} n
     * @return {?}
     */
    function S(X, n) { return (X >>> n) | (X << (32 - n)); }
    /**
     * @param {?} X
     * @param {?} n
     * @return {?}
     */
    function R(X, n) { return (X >>> n); }
    /**
     * @param {?} x
     * @param {?} y
     * @param {?} z
     * @return {?}
     */
    function Ch(x, y, z) { return ((x & y) ^ ((~x) & z)); }
    /**
     * @param {?} x
     * @param {?} y
     * @param {?} z
     * @return {?}
     */
    function Maj(x, y, z) { return ((x & y) ^ (x & z) ^ (y & z)); }
    /**
     * @param {?} x
     * @return {?}
     */
    function Sigma0256(x) { return (S(x, 2) ^ S(x, 13) ^ S(x, 22)); }
    /**
     * @param {?} x
     * @return {?}
     */
    function Sigma1256(x) { return (S(x, 6) ^ S(x, 11) ^ S(x, 25)); }
    /**
     * @param {?} x
     * @return {?}
     */
    function Gamma0256(x) { return (S(x, 7) ^ S(x, 18) ^ R(x, 3)); }
    /**
     * @param {?} x
     * @return {?}
     */
    function Gamma1256(x) { return (S(x, 17) ^ S(x, 19) ^ R(x, 10)); }
    /**
     * @param {?} m
     * @param {?} l
     * @return {?}
     */
    function core_sha256(m, l) {
        /** @type {?} */
        const K = new Array(0x428A2F98, 0x71374491, 0xB5C0FBCF, 0xE9B5DBA5, 0x3956C25B, 0x59F111F1, 0x923F82A4, 0xAB1C5ED5, 0xD807AA98, 0x12835B01, 0x243185BE, 0x550C7DC3, 0x72BE5D74, 0x80DEB1FE, 0x9BDC06A7, 0xC19BF174, 0xE49B69C1, 0xEFBE4786, 0xFC19DC6, 0x240CA1CC, 0x2DE92C6F, 0x4A7484AA, 0x5CB0A9DC, 0x76F988DA, 0x983E5152, 0xA831C66D, 0xB00327C8, 0xBF597FC7, 0xC6E00BF3, 0xD5A79147, 0x6CA6351, 0x14292967, 0x27B70A85, 0x2E1B2138, 0x4D2C6DFC, 0x53380D13, 0x650A7354, 0x766A0ABB, 0x81C2C92E, 0x92722C85, 0xA2BFE8A1, 0xA81A664B, 0xC24B8B70, 0xC76C51A3, 0xD192E819, 0xD6990624, 0xF40E3585, 0x106AA070, 0x19A4C116, 0x1E376C08, 0x2748774C, 0x34B0BCB5, 0x391C0CB3, 0x4ED8AA4A, 0x5B9CCA4F, 0x682E6FF3, 0x748F82EE, 0x78A5636F, 0x84C87814, 0x8CC70208, 0x90BEFFFA, 0xA4506CEB, 0xBEF9A3F7, 0xC67178F2);
        /** @type {?} */
        const HASH = new Array(0x6A09E667, 0xBB67AE85, 0x3C6EF372, 0xA54FF53A, 0x510E527F, 0x9B05688C, 0x1F83D9AB, 0x5BE0CD19);
        /** @type {?} */
        const W = new Array(64);
        /** @type {?} */
        let a;
        /** @type {?} */
        let b;
        /** @type {?} */
        let c;
        /** @type {?} */
        let d;
        /** @type {?} */
        let e;
        /** @type {?} */
        let f;
        /** @type {?} */
        let g;
        /** @type {?} */
        let h;
        /** @type {?} */
        let T1;
        /** @type {?} */
        let T2;
        m[l >> 5] |= 0x80 << (24 - l % 32);
        m[((l + 64 >> 9) << 4) + 15] = l;
        for (let i = 0; i < m.length; i += 16) {
            a = HASH[0];
            b = HASH[1];
            c = HASH[2];
            d = HASH[3];
            e = HASH[4];
            f = HASH[5];
            g = HASH[6];
            h = HASH[7];
            for (let j = 0; j < 64; j++) {
                if (j < 16) {
                    W[j] = m[j + i];
                }
                else {
                    W[j] = safe_add(safe_add(safe_add(Gamma1256(W[j - 2]), W[j - 7]), Gamma0256(W[j - 15])), W[j - 16]);
                }
                T1 = safe_add(safe_add(safe_add(safe_add(h, Sigma1256(e)), Ch(e, f, g)), K[j]), W[j]);
                T2 = safe_add(Sigma0256(a), Maj(a, b, c));
                h = g;
                g = f;
                f = e;
                e = safe_add(d, T1);
                d = c;
                c = b;
                b = a;
                a = safe_add(T1, T2);
            }
            HASH[0] = safe_add(a, HASH[0]);
            HASH[1] = safe_add(b, HASH[1]);
            HASH[2] = safe_add(c, HASH[2]);
            HASH[3] = safe_add(d, HASH[3]);
            HASH[4] = safe_add(e, HASH[4]);
            HASH[5] = safe_add(f, HASH[5]);
            HASH[6] = safe_add(g, HASH[6]);
            HASH[7] = safe_add(h, HASH[7]);
        }
        return HASH;
    }
    /**
     * @param {?} str
     * @return {?}
     */
    function str2binb(str) {
        /** @type {?} */
        const bin = Array();
        /** @type {?} */
        const mask = (1 << chrsz) - 1;
        for (let i = 0; i < str.length * chrsz; i += chrsz) {
            bin[i >> 5] |= (str.charCodeAt(i / chrsz) & mask) << (24 - i % 32);
        }
        return bin;
    }
    /**
     * @param {?} string
     * @return {?}
     */
    function Utf8Encode(string) {
        string = string.replace(/\r\n/g, '\n');
        /** @type {?} */
        let utftext = '';
        for (let n = 0; n < string.length; n++) {
            /** @type {?} */
            const c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if ((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
        }
        return utftext;
    }
    /**
     * @param {?} binarray
     * @return {?}
     */
    function binb2hex(binarray) {
        /** @type {?} */
        const hex_tab = '0123456789abcdef';
        /** @type {?} */
        let str = '';
        for (let i = 0; i < binarray.length * 4; i++) {
            str += hex_tab.charAt((binarray[i >> 2] >> ((3 - i % 4) * 8 + 4)) & 0xF) +
                hex_tab.charAt((binarray[i >> 2] >> ((3 - i % 4) * 8)) & 0xF);
        }
        return str;
    }
    s = Utf8Encode(s);
    return binb2hex(core_sha256(str2binb(s), s.length * chrsz));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// tslint:disable
/**
 * Força um download
 * @see https://github.com/sdouara13/ng-download/blob/master/ng-download.js
 * @param {?} data Blob | Uint8Array | string
 * @param {?} fileName string
 * @param {?=} mimeType string
 * @return {?}
 */
function download(data, fileName, mimeType) {
    /** @type {?} */
    var self = window;
    /** @type {?} */
    var // this script is only for browsers anyway...
    defaultMime = "application/octet-stream";
    /** @type {?} */
    var // this default mime also triggers iframe downloads
    mimeType = mimeType || defaultMime;
    /** @type {?} */
    var payload = data;
    /** @type {?} */
    var url = !fileName && !mimeType && payload;
    /** @type {?} */
    var anchor = document.createElement("a");
    /** @type {?} */
    var toString = (/**
     * @param {?} a
     * @return {?}
     */
    function (a) { return String(a); });
    /** @type {?} */
    var myBlob = (self.Blob || self['MozBlob'] || self['WebKitBlob'] || toString);
    /** @type {?} */
    var fileName = fileName || "download";
    /** @type {?} */
    var blob;
    /** @type {?} */
    var reader;
    myBlob = myBlob.call ? myBlob.bind(self) : Blob;
    if (String(this) === "true") { //reverse arguments, allowing download.bind(true, "text/xml", "export.xml") to act as a callback
        payload = [payload, mimeType];
        mimeType = payload[0];
        payload = payload[1];
    }
    if (url && url.length < 2048) { // if no filename and no mime, assume a url was passed as the only argument
        fileName = url.split("/").pop().split("?")[0];
        anchor.href = url; // assign href prop to temp anchor
        if (anchor.href.indexOf(url) !== -1) { // if the browser determines that it's a potentially valid url path:
            // if the browser determines that it's a potentially valid url path:
            /** @type {?} */
            var ajax = new XMLHttpRequest();
            ajax.open("GET", url, true);
            ajax.responseType = 'blob';
            ajax.onload = (/**
             * @param {?} e
             * @return {?}
             */
            function (e) {
                download(e.target['response'], fileName, defaultMime);
            });
            setTimeout((/**
             * @return {?}
             */
            function () { ajax.send(); }), 0); // allows setting custom ajax headers using the return:
            return ajax;
        } // end if valid url?
    } // end if url?
    //go ahead and download dataURLs right away
    if (/^data\:[\w+\-]+\/[\w+\-]+[,;]/.test(payload)) {
        if (payload.length > (1024 * 1024 * 1.999) && myBlob !== toString) {
            payload = dataUrlToBlob(payload);
            mimeType = payload.type || defaultMime;
        }
        else {
            return navigator.msSaveBlob ? // IE10 can't do a[download], only Blobs:
                navigator.msSaveBlob(dataUrlToBlob(payload), fileName) :
                saver(payload); // everyone else can save dataURLs un-processed
        }
    } //end if dataURL passed?
    blob = payload instanceof myBlob ?
        payload :
        new myBlob([payload], { type: mimeType });
    /**
     * @param {?} strUrl
     * @return {?}
     */
    function dataUrlToBlob(strUrl) {
        /** @type {?} */
        var parts = strUrl.split(/[:;,]/);
        /** @type {?} */
        var type = parts[1];
        /** @type {?} */
        var decoder = parts[2] == "base64" ? atob : decodeURIComponent;
        /** @type {?} */
        var binData = decoder(parts.pop());
        /** @type {?} */
        var mx = binData.length;
        /** @type {?} */
        var i = 0;
        /** @type {?} */
        var uiArr = new Uint8Array(mx);
        for (i; i < mx; ++i)
            uiArr[i] = binData.charCodeAt(i);
        return new myBlob([uiArr], { type: type });
    }
    /**
     * @param {?} url
     * @param {?=} winMode
     * @return {?}
     */
    function saver(url, winMode = false) {
        if ('download' in anchor) { //html5 A[download]
            anchor.href = url;
            anchor.setAttribute("download", fileName);
            anchor.className = "download-js-link";
            anchor.innerHTML = "downloading...";
            anchor.style.display = "none";
            document.body.appendChild(anchor);
            setTimeout((/**
             * @return {?}
             */
            function () {
                anchor.click();
                document.body.removeChild(anchor);
                if (winMode === true) {
                    setTimeout((/**
                     * @return {?}
                     */
                    function () { self.URL.revokeObjectURL(anchor.href); }), 250);
                }
            }), 66);
            return true;
        }
        // handle non-a[download] safari as best we can:
        if (/(Version)\/(\d+)\.(\d+)(?:\.(\d+))?.*Safari\//.test(navigator.userAgent)) {
            url = url.replace(/^data:([\w\/\-\+]+)/, defaultMime);
            if (!window.open(url)) { // popup blocked, offer direct download:
                if (confirm("Displaying New Document\n\nUse Save As... to download, then click back to return to this page.")) {
                    location.href = url;
                }
            }
            return true;
        }
        //do iframe dataURL download (old ch+FF):
        /** @type {?} */
        var f = document.createElement("iframe");
        document.body.appendChild(f);
        if (!winMode) { // force a mime that will download:
            url = "data:" + url.replace(/^data:([\w\/\-\+]+)/, defaultMime);
        }
        f.src = url;
        setTimeout((/**
         * @return {?}
         */
        function () { document.body.removeChild(f); }), 333);
    } //end saver
    if (navigator.msSaveBlob) { // IE10+ : (has Blob, but not a[download] or URL)
        return navigator.msSaveBlob(blob, fileName);
    }
    if (self.URL) { // simple fast and modern way using Blob and URL:
        saver(self.URL.createObjectURL(blob), true);
    }
    else {
        // handle non-Blob()+non-URL browsers:
        if (typeof blob === "string" || blob.constructor === toString) {
            try {
                return saver("data:" + mimeType + ";base64," + self.btoa(blob));
            }
            catch (y) {
                return saver("data:" + mimeType + "," + encodeURIComponent(blob));
            }
        }
        // Blob but not URL support:
        reader = new FileReader();
        reader.onload = (/**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            saver(this.result);
        });
        reader.readAsDataURL(blob);
    }
    return true;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Serviço responsável por trazer os dominios
 * de `/dominio/`, `/dominio/itens` ou `/dominio/{nome-do-dominio}`
 */
class DominioService {
    /**
     * Inicializador da classe
     * @param {?} httpClient Cliente para as requisiçõe HTTP
     * @param {?} configService Serviço responsável por trazer as configurações do sistema
     */
    constructor(httpClient, configService) {
        this.httpClient = httpClient;
        this.configService = configService;
        /**
         * Cache dos dominios
         */
        this.domainsCache = [];
        this.domainsItensCache = [];
        this.domainCache = new Map();
    }
    /**
     * Retorna um `Observable`. Se assinado vai
     * trazer todas os dominios em
     * um objeto só
     * @return {?}
     */
    getAll() {
        if (this.domainsCache.length > 0) {
            return of(this.domainsCache);
        }
        else {
            return this.configService.get('backendUrl').pipe(switchMap((/**
             * @param {?} backendUrl
             * @return {?}
             */
            (backendUrl) => this.httpClient.get(`${backendUrl}/dominio/todos`).pipe(take(1), tap((/**
             * @param {?} domainList
             * @return {?}
             */
            (domainList) => this.domainsCache = domainList))))));
        }
    }
    /**
     * Retorna um `Observable`. Se assinado vai
     * trazer o dominio selecionada
     * @param {?} domainName Nome do dominio a ser retornado no `Observable`
     * @return {?}
     */
    get(domainName) {
        if (this.domainCache.has(domainName)) {
            return of(this.domainCache.get(domainName));
        }
        else {
            return this.configService.get('backendUrl').pipe(switchMap((/**
             * @param {?} backendUrl
             * @return {?}
             */
            (backendUrl) => this.httpClient.get(`${backendUrl}/dominio/${domainName}`).pipe(take(1), tap((/**
             * @param {?} domain
             * @return {?}
             */
            (domain) => this.domainCache.set(domainName, domain)))))));
        }
    }
    /**
     * Retorna um `Observable`. Se assinado vai
     * trazer os dominios selecionadas
     * em uma lista
     * @param {?} domainNames Lista de nome dos dominios a serem retornados no `Observable`
     * @return {?}
     */
    getList(domainNames) {
        return forkJoin(domainNames.map((/**
         * @param {?} domainName
         * @return {?}
         */
        (domainName) => this.get(domainName)))).pipe(take(1));
    }
    /**
     * Retorna um `Observable`. Se assinado vai
     * trazer os nomes de todos os dominios
     * em uma lista
     * @return {?}
     */
    getItemNames() {
        if (this.domainsItensCache.length > 0) {
            return of(this.domainsItensCache);
        }
        else {
            return this.configService.get('backendUrl').pipe(switchMap((/**
             * @param {?} backendUrl
             * @return {?}
             */
            (backendUrl) => this.httpClient.get(`${backendUrl}/dominio/`).pipe(take(1), tap((/**
             * @param {?} domainNames
             * @return {?}
             */
            (domainNames) => this.domainsItensCache = domainNames))))));
        }
    }
}
DominioService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
DominioService.ctorParameters = () => [
    { type: HttpClient },
    { type: ConfigService }
];
/** @nocollapse */ DominioService.ngInjectableDef = defineInjectable({ factory: function DominioService_Factory() { return new DominioService(inject(HttpClient), inject(ConfigService)); }, token: DominioService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NotificacaoService {
    /**
     * @param {?} httpClient
     * @param {?} configService
     */
    constructor(httpClient, configService) {
        this.httpClient = httpClient;
        this.configService = configService;
    }
    /**
     * @param {?=} intervalSeconds
     * @param {?=} intervalConditional
     * @return {?}
     */
    getIntervalNonReceivedCounter(intervalSeconds = 10, intervalConditional = (/**
     * @return {?}
     */
    () => true)) {
        return interval(intervalSeconds * 1000).pipe(switchMap((/**
         * @return {?}
         */
        () => !intervalConditional() ? EMPTY :
            this.configService.get('backendUrl').pipe(switchMap((/**
             * @param {?} backendUrl
             * @return {?}
             */
            (backendUrl) => this.httpClient.get(`${backendUrl}/notificacao/quantidade-mensagens-novas`).pipe(take(1))))))));
    }
    /**
     * @return {?}
     */
    getNotifications() {
        return this.configService.get('backendUrl').pipe(switchMap((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => this.httpClient.get(`${backendUrl}/notificacao/`).pipe(take(1)))));
    }
    /**
     * @param {?} id
     * @return {?}
     */
    getDetails(id) {
        return this.configService.get('backendUrl').pipe(switchMap((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => this.httpClient.get(`${backendUrl}/notificacao/${id}/texto-detalhado`, {
            responseType: 'text'
        }).pipe(take(1)))));
    }
    /**
     * @param {?} data
     * @return {?}
     */
    send(data) {
        return this.configService.get('backendUrl').pipe(switchMap((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => this.httpClient.post(`${backendUrl}/notificacao/`, data).pipe(take(1)))));
    }
    /**
     * @param {?} ids
     * @return {?}
     */
    remove(ids) {
        return this.configService.get('backendUrl').pipe(switchMap((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => this.httpClient.delete(`${backendUrl}/notificacao/`, {
            params: {
                ids: ids.map((/**
                 * @param {?} id
                 * @return {?}
                 */
                (id) => id + ''))
            }
        }).pipe(take(1)))));
    }
    /**
     * @param {?} notificationId
     * @param {?} actionId
     * @return {?}
     */
    performAction(notificationId, actionId) {
        return this.configService.get('backendUrl').pipe(switchMap((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => this.httpClient.delete(`${backendUrl}/notificacao/${notificationId}/acao/${actionId}`).pipe(take(1)))));
    }
}
NotificacaoService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NotificacaoService.ctorParameters = () => [
    { type: HttpClient },
    { type: ConfigService }
];
/** @nocollapse */ NotificacaoService.ngInjectableDef = defineInjectable({ factory: function NotificacaoService_Factory() { return new NotificacaoService(inject(HttpClient), inject(ConfigService)); }, token: NotificacaoService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
class BaseService {
    /**
     * @param {?} httpClient
     * @param {?} configService
     */
    constructor(httpClient, configService) {
        this.httpClient = httpClient;
        this.configService = configService;
    }
    /**
     * @protected
     * @template T
     * @param {?} endpoint
     * @return {?}
     */
    baseDelete(endpoint) {
        return this.configService.get('backendUrl').pipe(switchMap((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => this.httpClient.delete(`${backendUrl}/${this.sanitizeEndpoint(endpoint)}`).pipe(take(1)))));
    }
    /**
     * @protected
     * @template T
     * @param {?} endpoint
     * @return {?}
     */
    baseGet(endpoint) {
        return this.configService.get('backendUrl').pipe(switchMap((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => this.httpClient.get(`${backendUrl}/${this.sanitizeEndpoint(endpoint)}`).pipe(take(1)))));
    }
    /**
     * @protected
     * @template T
     * @param {?} endpoint
     * @param {?} params
     * @return {?}
     */
    baseGetWithParams(endpoint, params) {
        return this.configService.get('backendUrl').pipe(switchMap((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => this.httpClient.get(`${backendUrl}/${this.sanitizeEndpoint(endpoint)}`, { params: params }).pipe(take(1)))));
    }
    /**
     * @protected
     * @template T
     * @param {?} endpoint
     * @return {?}
     */
    baseGetCached(endpoint) {
        /** @type {?} */
        const cacheKey = `÷${endpoint} @ ${this.configService.appKey}`;
        if (SessionStorage.hasItem(cacheKey)) {
            return of((/** @type {?} */ (SessionStorage.getItem(cacheKey))));
        }
        return this.baseGet(endpoint).pipe(tap((/**
         * @param {?} data
         * @return {?}
         */
        (data) => SessionStorage.setItem(cacheKey, data))));
    }
    /**
     * @protected
     * @param {?} endpoint
     * @return {?}
     */
    baseGetText(endpoint) {
        return this.configService.get('backendUrl').pipe(switchMap((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => this.httpClient.get(`${backendUrl}/${this.sanitizeEndpoint(endpoint)}`, {
            responseType: 'text'
        }).pipe(take(1)))));
    }
    /**
     * @protected
     * @template T
     * @param {?} endpoint
     * @return {?}
     */
    baseHead(endpoint) {
        return this.configService.get('backendUrl').pipe(switchMap((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => this.httpClient.head(`${backendUrl}/${this.sanitizeEndpoint(endpoint)}`).pipe(take(1)))));
    }
    /**
     * @protected
     * @template T
     * @param {?} endpoint
     * @param {?} callback
     * @return {?}
     */
    baseJsonp(endpoint, callback) {
        return this.configService.get('backendUrl').pipe(switchMap((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => this.httpClient.jsonp(`${backendUrl}/${this.sanitizeEndpoint(endpoint)}`, callback).pipe(take(1)))));
    }
    /**
     * @protected
     * @template T
     * @param {?} endpoint
     * @return {?}
     */
    baseOptions(endpoint) {
        return this.configService.get('backendUrl').pipe(switchMap((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => this.httpClient.options(`${backendUrl}/${this.sanitizeEndpoint(endpoint)}`).pipe(take(1)))));
    }
    /**
     * @protected
     * @template T
     * @param {?} endpoint
     * @param {?} data
     * @return {?}
     */
    basePatch(endpoint, data) {
        return this.configService.get('backendUrl').pipe(switchMap((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => this.httpClient.patch(`${backendUrl}/${this.sanitizeEndpoint(endpoint)}`, data).pipe(take(1)))));
    }
    /**
     * @protected
     * @template T
     * @param {?} endpoint
     * @param {?} data
     * @return {?}
     */
    basePost(endpoint, data) {
        return this.configService.get('backendUrl').pipe(switchMap((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => this.httpClient.post(`${backendUrl}/${this.sanitizeEndpoint(endpoint)}`, data).pipe(take(1)))));
    }
    /**
     * @protected
     * @param {?} files
     * @param {?} fileNames
     * @return {?}
     */
    basePostFile(files, fileNames) {
        /** @type {?} */
        const formData = new FormData();
        files.forEach((/**
         * @param {?} file
         * @param {?} index
         * @return {?}
         */
        (file, index) => formData.set(fileNames[index], file, file.name)));
        return this.configService.getList(['backendUrl', 'clientId']).pipe(switchMap((/**
         * @param {?} configs
         * @return {?}
         */
        (configs) => this.httpClient.post(`${configs[0]}/arquivo/sistema/${configs[1]}/upload`, formData, { responseType: 'text' }).pipe(take(1)))));
    }
    /**
     * @protected
     * @param {?} files
     * @param {?} fileNames
     * @return {?}
     */
    basePublicPostFile(files, fileNames) {
        console.log('%c[!] BaseService.basePublicPostFile(): Vc está usando um método temporário para atender um singelo felino', 'color: #ff6; background-color: #424242; font-size: 1.2em');
        /** @type {?} */
        const formData = new FormData();
        files.forEach((/**
         * @param {?} file
         * @param {?} index
         * @return {?}
         */
        (file, index) => formData.set(fileNames[index], file, file.name)));
        return this.configService.getList(['backendUrl', 'clientId']).pipe(switchMap((/**
         * @param {?} configs
         * @return {?}
         */
        (configs) => this.httpClient.post(`${configs[0]}/public/arquivo/sistema/${configs[1]}/upload`, formData, { responseType: 'text' }).pipe(take(1)))));
    }
    /**
     * @protected
     * @template T
     * @param {?} endpoint
     * @param {?} data
     * @return {?}
     */
    basePut(endpoint, data) {
        return this.configService.get('backendUrl').pipe(switchMap((/**
         * @param {?} backendUrl
         * @return {?}
         */
        (backendUrl) => this.httpClient.put(`${backendUrl}/${this.sanitizeEndpoint(endpoint)}`, data).pipe(take(1)))));
    }
    /**
     * @private
     * @param {?} endpoint
     * @return {?}
     */
    sanitizeEndpoint(endpoint) {
        return endpoint.trim().replace(/^\//, '');
    }
}
BaseService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
BaseService.ctorParameters = () => [
    { type: HttpClient },
    { type: ConfigService }
];
/** @nocollapse */ BaseService.ngInjectableDef = defineInjectable({ factory: function BaseService_Factory() { return new BaseService(inject(HttpClient), inject(ConfigService)); }, token: BaseService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DominioModel {
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DominioItemModel {
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ErrorModel {
    /**
     * @param {?} message
     * @param {?} code
     * @param {?} data
     */
    constructor(message, code, data) {
        this.message = message;
        this.code = code;
        this.data = data;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PerfilModel {
    constructor() {
        this.esferas = [];
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class EsferaModel {
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class UsuarioModel {
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NotificacaoModel {
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
class PageableRequestModel {
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
class PageableResponseModel {
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ErrorInterceptor {
    /**
     * @param {?} request
     * @param {?} next
     * @return {?}
     */
    intercept(request, next) {
        return next.handle(request).pipe(catchError(this.handleHttpError.bind(this)));
    }
    /**
     * @private
     * @param {?} response
     * @return {?}
     */
    handleHttpError(response) {
        try {
            console.warn('[ErrorInterceptor::handleHttpError] message: "%s", status: %d', response.message, response.status);
            /** @type {?} */
            const okButHasSomeError = (/**
             * @param {?} error
             * @return {?}
             */
            (error) => {
                console.error('[ErrorInterceptor::okButHasSomeError] Algo errado na hora de montar o retorno.', error);
                console.warn('[ErrorInterceptor::okButHasSomeError] Verifique o tipo do retorno se bate com o que vem do backend.');
                return 'Erro ao montar o retorno.';
            });
            /** @type {?} */
            const badRequest = (/**
             * @param {?} error
             * @return {?}
             */
            (error) => {
                console.error('[ErrorInterceptor::badRequest] Erro negocial da API!', error);
                /** @type {?} */
                let messages = ['Erro de API'];
                if (error instanceof Array) {
                    messages = error.map((/**
                     * @param {?} e
                     * @return {?}
                     */
                    (e) => e.message ?
                        e.message : 'Erro de API: '.concat(e.error ? e.error : 'desconhecido')));
                }
                return messages.join('\n');
            });
            /** @type {?} */
            const unauthorized = (/**
             * @param {?} error
             * @return {?}
             */
            (error) => {
                console.error('[ErrorInterceptor::accessDennied] Sem autorização, sai fora do sistema!', error);
                return 'Sem autorização!';
            });
            /** @type {?} */
            const forbidden = (/**
             * @param {?} error
             * @return {?}
             */
            (error) => {
                console.error('[ErrorInterceptor::forbidden] Proibido!', error);
                return 'Você não tem permissão.';
            });
            /** @type {?} */
            const notFound = (/**
             * @param {?} error
             * @return {?}
             */
            (error) => {
                console.error('[ErrorInterceptor::notFound] Erro de não encontrado!', error);
                return 'Nenhum resultado encontrado.';
            });
            /** @type {?} */
            const methodNotAllowed = (/**
             * @param {?} error
             * @return {?}
             */
            (error) => {
                console.error('[ErrorInterceptor::methodNotAllowed] Método HTTP não existe!', error);
                console.warn('[ErrorInterceptor::methodNotAllowed] Verifique o método da requisição bate com o que está registrado no backend.');
                return 'Problema com a requisição.';
            });
            /** @type {?} */
            const internalServerError = (/**
             * @param {?} error
             * @return {?}
             */
            (error) => {
                console.error('[ErrorInterceptor::internalServerError] Erro interno no servidor!', error);
                // TODO tratamento temporário dessa mensagens que vem encapsuladas dentro de outra...
                /** @type {?} */
                const workaround = this.workaroundOnMessage((error.message || '') + '');
                return workaround.message || 'Erro interno no servidor!';
            });
            /** @type {?} */
            const requestFail = (/**
             * @param {?} error
             * @return {?}
             */
            (error) => {
                console.error('[ErrorInterceptor::serviceNotAvailable] Falhou o request!', error);
                return ':( Xii...! Serviço indisponível, tente novamente em alguns minutos.';
            });
            /** @type {?} */
            const statusPreprocessor = (/**
             * @param {?} originalStatus
             * @param {?} originalError
             * @return {?}
             */
            (originalStatus, originalError) => {
                // TODO tratamento temporário dessa mensagens que vem encapsuladas dentro de outra...
                if (!originalError) {
                    return originalStatus;
                }
                /** @type {?} */
                const workaround = this.workaroundOnMessage((originalError.message || '') + '');
                return workaround.status || originalStatus;
            });
            /** @type {?} */
            const errorMapping = {
                // 0×× Non state
                0: requestFail,
                // 1×× Informational
                // 100 Continue
                // 101 Switching Protocols
                // 102 Processing
                // 2×× Success
                200: okButHasSomeError,
                // 200 OK
                // 201 Created
                // 202 Accepted
                // 203 Non-authoritative Information
                // 204 No Content
                // 205 Reset Content
                // 206 Partial Content
                // 207 Multi-Status
                // 208 Already Reported
                // 226 IM Used
                // 3×× Redirection
                // 300 Multiple Choices
                // 301 Moved Permanently
                // 302 Found
                // 303 See Other
                // 304 Not Modified
                // 305 Use Proxy
                // 307 Temporary Redirect
                // 308 Permanent Redirect
                // 4×× Client Error
                400: badRequest,
                // 400 Bad Request
                401: unauthorized,
                // 401 Unauthorized
                // 402 Payment Required
                403: forbidden,
                // 403 Forbidden
                404: notFound,
                // 404 Not Found
                405: methodNotAllowed,
                // 405 Method Not Allowed
                // 406 Not Acceptable
                // 407 Proxy Authentication Required
                // 408 Request Timeout
                // 409 Conflict
                // 410 Gone
                // 411 Length Required
                // 412 Precondition Failed
                // 413 Payload Too Large
                // 414 Request-URI Too Long
                // 415 Unsupported Media Type
                // 416 Requested Range Not Satisfiable
                // 417 Expectation Failed
                // 418 I'm a teapot
                // 421 Misdirected Request
                // 422 Unprocessable Entity
                // 423 Locked
                // 424 Failed Dependency
                // 426 Upgrade Required
                // 428 Precondition Required
                // 429 Too Many Requests
                // 431 Request Header Fields Too Large
                // 444 Connection Closed Without Response
                // 451 Unavailable For Legal Reasons
                // 499 Client Closed Request
                // 5×× Server Error
                500: internalServerError,
            };
            if (response.status in errorMapping) {
                return throwError(new ErrorModel(errorMapping[response.status](response.error), statusPreprocessor(response.status, response.error), response));
            }
        }
        catch (e) {
            console.error(e, response);
        }
        return throwError(new ErrorModel(':( Ops! Algo inesperado aconteceu.', 0, response));
    }
    /**
     * @private
     * @param {?} message
     * @return {?}
     */
    workaroundOnMessage(message) {
        /** @type {?} */
        const result = {
            message: null,
            status: null,
        };
        /** @type {?} */
        const str = message.replace(/\n+/g, '');
        /** @type {?} */
        const regex = /status\s(\d*).*message":"(.*)"\W/gmi;
        /** @type {?} */
        let matches;
        while ((matches = regex.exec(str)) !== null) {
            if (matches.index === regex.lastIndex) {
                regex.lastIndex++;
            }
            matches.forEach((/**
             * @param {?} match
             * @param {?} groupIndex
             * @return {?}
             */
            (match, groupIndex) => {
                if (groupIndex === 1) {
                    result.status = match;
                }
                if (groupIndex === 2) {
                    result.message = match;
                }
            }));
        }
        return result;
    }
}
ErrorInterceptor.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */ ErrorInterceptor.ngInjectableDef = defineInjectable({ factory: function ErrorInterceptor_Factory() { return new ErrorInterceptor(); }, token: ErrorInterceptor, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AuthInterceptor {
    constructor() {
        this.termsWithoutCredentials = [
            CONFIG_ENV_JSON_PATH,
        ];
    }
    /**
     * @param {?} request
     * @param {?} next
     * @return {?}
     */
    intercept(request, next) {
        /** @type {?} */
        const authRequest = request.clone({
            withCredentials: this.canAppendCredentials(request.url)
        });
        // console.log('[AuthInterceptor::intercept] Injetando o withCredentials no request XHR', authRequest);
        return next.handle(authRequest);
    }
    /**
     * @private
     * @param {?} url
     * @return {?}
     */
    canAppendCredentials(url) {
        /** @type {?} */
        const filtered = this.termsWithoutCredentials.filter((/**
         * @param {?} term
         * @return {?}
         */
        (term) => url.includes(term)));
        return !filtered.length;
    }
}
AuthInterceptor.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */ AuthInterceptor.ngInjectableDef = defineInjectable({ factory: function AuthInterceptor_Factory() { return new AuthInterceptor(); }, token: AuthInterceptor, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SecurityInterceptor {
    /**
     * @param {?} securityService
     */
    constructor(securityService) {
        this.securityService = securityService;
    }
    /**
     * @param {?} request
     * @param {?} next
     * @return {?}
     */
    intercept(request, next) {
        /** @type {?} */
        const perfil = this.securityService.getStoredPerfilSelecionado() || new PerfilModel();
        /** @type {?} */
        const esfera = this.securityService.getStoredEsferaSelecionada() || new EsferaModel();
        /** @type {?} */
        let headers = request.headers;
        if (perfil.sigla) {
            headers = headers.set(HTTP_HEADER_PERFIL, perfil.sigla.toString());
        }
        if (esfera.sigla) {
            headers = headers.set(HTTP_HEADER_ESFERA, esfera.sigla.toString());
        }
        if (esfera.esferaAtuacao) {
            headers = headers.set(HTTP_HEADER_ESFERA_ATUACAO, esfera.esferaAtuacao);
        }
        // console.log('[SecurityInterceptor::intercept] Headers enviado', headers);
        return next.handle(request.clone({ headers }));
    }
}
SecurityInterceptor.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
SecurityInterceptor.ctorParameters = () => [
    { type: SecurityService }
];
/** @nocollapse */ SecurityInterceptor.ngInjectableDef = defineInjectable({ factory: function SecurityInterceptor_Factory() { return new SecurityInterceptor(inject(SecurityService)); }, token: SecurityInterceptor, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class CoreModule {
}
CoreModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    // Angular
                    HttpClientModule,
                ],
                providers: [
                    Location,
                    {
                        provide: LocationStrategy,
                        useClass: PathLocationStrategy,
                    },
                    {
                        provide: HTTP_INTERCEPTORS,
                        useClass: ErrorInterceptor,
                        multi: true
                    },
                    {
                        provide: HTTP_INTERCEPTORS,
                        useClass: AuthInterceptor,
                        multi: true
                    },
                    {
                        provide: HTTP_INTERCEPTORS,
                        useClass: SecurityInterceptor,
                        multi: true
                    },
                ],
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { DATASUS_ROUTE_HOME, DATASUS_ROUTE_ERROR_BACKEND, DATASUS_ROUTE_FORBIDDEN, DATASUS_ROUTE_CHOOSE_PROFILE, DATASUS_ROUTE_RELEASE_NOTES, AuthGuard, SecurityGuard, PathGuard, LocalStorage, SessionStorage, requestItemsParams, redirectTo, compareObjects, checkObjectInList, intervalDates, urlEncode, urlDecode, base64Encode, base64Decode, base64DecodeToTypedArray, base64DecodeToBlob, stringToBlob, stringToTypedArray, SHA256, download, AuthService, SecurityService, ConfigService, DominioService, NotificacaoService, BaseService, DominioModel, DominioItemModel, ErrorModel, PerfilModel, EsferaModel, UsuarioModel, NotificacaoModel, PageableRequestModel, PageableResponseModel, CoreModule, AuthInterceptor as ɵb, ErrorInterceptor as ɵa, SecurityInterceptor as ɵc };

//# sourceMappingURL=datasus-core.js.map