/**
 * Atalho otimizado para recuperar e
 * inserir coisas no `window.localStorage`
 */
export declare class LocalStorage {
    /**
     * Insere informação no `window.localStorage`
     * @param key Chave que será utilizada
     * @param value Valor que vai ser inserido
     */
    static setItem(key: string, value: any): void;
    /**
     * Recupera o valor no `window.localStorage`
     * @param key Chave do valor que será recuperado
     */
    static getItem(key: string): any;
    /**
     * Remove o valor no `window.localStorage`
     * @param key Chave do valor que será removido
     */
    static removeItem(key: string): void;
    /**
     * Verifica se existe valor no `window.localStorage`
     * @param key Chave do valor que será verificada
     */
    static hasItem(key: string): boolean;
}
