const file = process.argv[2];
const from = process.argv[3];
const to = process.argv[4];

function fsFail(error) {
  console.log('✗ Favor instalar o pacote fs-extra: npm install -D fs-extra');
  console.error(error);
  process.exit(1);
}

function replaceFail(error) {
  console.log('✗ Erro ao substituir');
  console.error(error);
  process.exit(1);
}

if (!file || !from || !to) {
  console.error('✗ Parametros incorretos. file: %s, from: %s, to: %s', file, from, to);
  process.exit(1);
}

console.log(`⚒ Substituir "${from}" para "${to}" no arquivo ${file} dentro da pasta dist`);

let fs;
try {
  fs = require("fs-extra");
  if (!fs) {
    throw 'Pacote fs-extra não encontrado';
  }
} catch(e) {
  fsFail(e);
}

fs.readFile(file, 'utf8', function (err, data) {
  if (err) {
    return replaceFail(err);
  }

  const regex = new RegExp(from, 'gm');
  var result = data.replace(regex, to);

  fs.writeFile(file, result, 'utf8', function (err) {
    if (err) {
      return replaceFail(err);
    }
    console.log('✔ Substituido com sucesso!\n\n');
  });
});
