// import { DateAdapter as MatDateAdapter } from '@angular/material/core';
import { NativeDateAdapter } from '@angular/material/core';

// tslint:disable-next-line: max-line-length
const regex: RegExp = /^(?:(?:31(\/|-|\.)(?:0?[13578]|1[02]))\1|(?:(?:29|30)(\/|-|\.)(?:0?[13-9]|1[0-2])\2))(?:(?:1[6-9]|[2-9]\d)?\d{2})$|^(?:29(\/|-|\.)0?2\3(?:(?:(?:1[6-9]|[2-9]\d)?(?:0[48]|[2468][048]|[13579][26])|(?:(?:16|[2468][048]|[3579][26])00))))$|^(?:0?[1-9]|1\d|2[0-8])(\/|-|\.)(?:(?:0?[1-9])|(?:1[0-2]))\4(?:(?:1[6-9]|[2-9]\d)?\d{2})$/;

export class DatePtAdapter extends NativeDateAdapter {

  protected locale = 'pt';

  parse(value: any): Date {
    try {
      // console.log('[Date "pt" Adapter] parse:', value);
      if (typeof value !== 'string') {
        return null;
      }

      if (!regex.test(value)) {
        return null;
      }

      if (value.length !== 10) {
        return null;
      }

      const regExExecution = regex.exec(value);
      const separator = regExExecution[4] || regExExecution[3] || regExExecution[2] || regExExecution[1]; // lançar! 🚀
      const values: number[] = value.split(separator).map((val: string) => +val);
      return new Date(values[2], values[1] - 1, values[0]);
    } catch (error) {
      console.error('[Date "pt" Adapter] error:', error);
    }
    return null;
  }
}
