import { Component, OnInit } from '@angular/core';
import { Router } from '@angular/router';

import { AuthService, ErrorModel, DATASUS_ROUTE_HOME } from '@datasus/core';
import { LayoutService } from '@datasus/layout';


@Component({
  selector: 'datasus-forbidden',
  templateUrl: './forbidden.component.html',
  styleUrls: ['./forbidden.component.scss']
})
export class ForbiddenComponent implements OnInit {

  constructor(
    private router: Router,
    private layoutService: LayoutService,
    private authService: AuthService,
  ) { }

  ngOnInit(): void {
    this.layoutService.off();

    this.authService.isAuthenticated().toPromise()
      .then(() => this.goToHome())
      .catch((error: ErrorModel) => {
        if (error.code === 401) {
          this.goToHome();
        }
      });
  }

  goToHome(): void {
    this.router.navigate([`/${DATASUS_ROUTE_HOME}`]);
  }

  getOut(): void {
    this.authService.logout();
  }

}
