import { Component, OnInit } from '@angular/core';
import { NgxMdService } from 'ngx-md';

import { LayoutService } from '@datasus/layout';

@Component({
  selector: 'datasus-release-notes',
  templateUrl: './release-notes.component.html',
  styleUrls: ['./release-notes.component.scss'],
})

export class ReleaseNotesComponent implements OnInit {


  constructor(
    private layoutService: LayoutService,
    private markdown: NgxMdService
  ) { }

  ngOnInit(): void {
    this.layoutService.off();

    this.markdown.renderer.paragraph = (text: string) => {

      const regex = /banco\s+de\s+dados.*c[oó]digo[\s+-]fonte/gmi;
      const regexInvertido = /c[oó]digo[\s+-]fonte.*banco\s+de\s+dados/gmi;

      if (regex.test(text) || regexInvertido.test(text)) {
        const regexBandoDados = /banco\s+de\s+dados\s*\((\s*x\s*)\)/gmi;
        const bancoDados = regexBandoDados.test(text) ? '✓' : '';
        const regexCodigoFonte = /c[oó]digo[\s+-]fonte\s*\((\s*x\s*)\)/gmi;
        const codigoFonte = regexCodigoFonte.test(text) ? '✓' : '';

        return `
          <div class="container flex">
            <div class="flex">
              Banco de dados:
              <span class="banco-dados">${bancoDados}</span>
            </div>
            <div class="flex">
              Codigo fonte:
              <span class="codigo-fonte">${codigoFonte}</span>
            </div>
          </div>`;
      }
      return `<p>${text}</p>`;
    };
  }

}
