import { FilterPipe } from './filter.pipe';

describe('FilterPipe', () => {
  let pipe: FilterPipe;

  beforeEach(() => {
      pipe = new FilterPipe();
  });

  it('Filtrando uma lista vazia', () => {
    expect(pipe.transform([])).toEqual([]);
    expect(pipe.transform(undefined)).toEqual([]);
    expect(pipe.transform(null)).toEqual([]);
  });

  it('Filtrando [0, "Úm", "dóIs", "trÊs"]', () => {
    const list = [0, 'Úm', 'dóIs', 'trÊs'];
    const filter = 'S';
    expect(pipe.transform(list, filter)).toEqual(['dóIs', 'trÊs']);
    expect(pipe.transform(list, filter)).toEqual(['dóIs', 'trÊs']);
  });

  it('Filtrando [{text: 0}, {text: "Úm"}, {text: "dóIs"}, {text: "trÊs"}]', () => {
    const list = [{text: 0}, {text: 'Úm'}, {text: 'dóIs'}, {text: 'trÊs'}];
    const filter = 'S';
    expect(pipe.transform(list, filter, 'text')).toEqual([{text: 'dóIs'}, {text: 'trÊs'}]);
    expect(pipe.transform(list, filter, 'text')).toEqual([{text: 'dóIs'}, {text: 'trÊs'}]);
  });
});
