import { Pipe, PipeTransform } from '@angular/core';

@Pipe({
  name: 'datasusNormalize'
})
export class NormalizePipe implements PipeTransform {

  transform(text: string): string {
    if (!text) {
        return '';
    }

    let i: string;
    let normalized = text.toLowerCase();
    const map = {
        a: '[àáâãäå]',
        e: '[èéêë]',
        i: '[ìíîï]',
        o: '[òóôõö]',
        u: '[ùúûűü]',
        y: '[ýÿ]',
        c: 'ç',
        n: 'ñ',
        '-': '–',
    };

    for (i in map) {
        if (map.hasOwnProperty(i)) {
            normalized = normalized.replace(new RegExp(map[i], 'img'), i);
        }
    }

    normalized = normalized.replace(/\s+/g, ' ');
    return normalized;
}

}
