import { Pipe, PipeTransform } from '@angular/core';
import { Observable, of as observableOf } from 'rxjs';
import { map } from 'rxjs/operators';

import { ConfigService } from '@datasus/core';

@Pipe({ name: 'datasusUrlDownload$' })
export class UrlDownloadPipe implements PipeTransform {

  constructor(
    private configService: ConfigService,
  ) { }

  transform(id: string): Observable<string> {
    if (!id) {
      return observableOf('');
    }

    return this.configService.getList(['backendUrl', 'clientId']).pipe(
      map(
        (configs: string[]) => `${configs[0]}/arquivo/sistema/${configs[1]}/id/${id}/download`
      )
    );
  }

}
