const log = (prefix, message) => `★ [mock proxy] ${(new Date()).toString()} ${prefix} ${message}`;

const newPath = (path, method, suffix) => {
  method = method || 'GET';
  suffix = suffix || '';
  return path.replace('?', '_')
    + suffix
    + (method !== 'GET' ? '-' + method.toLowerCase() : '')
    + '.json';
};

let first = true;

const PROXY_CONFIG = {
  '/mock/**': {
    target: 'http://localhost:4200',
    pathRewrite: function (path, req) {
      if (first) {
        console.log(
`
 __  __            _      _ _                 _       _
|  \\/  | ___   ___| | __ | (_) __ _  __ _  __| | ___ | |
| |\\/| |/ _ \\ / __| |/ / | | |/ _\` |/ _\` |/ _\` |/ _ \\| |
| |  | | (_) | (__|   <  | | | (_| | (_| | (_| | (_) |_|
|_|  |_|\\___/ \\___|_|\\_\\ |_|_|\\__, |\\__,_|\\__,_|\\___/(_)
                              |___/
`
        );
        first = false;
      }
      if (process.title.includes('--prod')) {
        console.error(log('💣 Erro!', 'Não pode usar mock em --prod'));
        console.log(
`
/\\  /\\                       |:.     %|:.               |
/ ;\\~"\`.       ,--------.     |:.     %|:.               |
( /  ) / \\      | *OPS!* |     |:.     %|:.               |
/~/     /#\\ \`.     "~~\\/~~~"     |:.     %|:.               |
/__|     "~" /~\\/~]               |:.     %|:.               |
\`/~~\`\\       \\@  @                |:.     %|:.               |
/_____\\    ;-.,_,/                |:.     %|:.               |
\` /~~~~|   -.___/                 |:.     %|:.               |
/____.--.   \\-.                 /:.     %/:.                "
\`/~~~|   \\   \\|        .____.~~:.____.~~:.                  \\
/____|        \\      /":.   %%/":.                           \\
\`  ,,!    /    \\    /:. /:. %/:. /:.                          \\
\\;\\   /~     '   |:. |:. %|:. |:.                           |
/ ~  /        '  |:. |:. %|:. |:.                          /
\\___/        @ } \`~~~^~~~-^~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   \\          ,
`
        );
        process.exit(1);
      }

      if (path.includes('.json')) {
        console.error(log('💣 Erro!', `Verifique se o caminho do mock existe: src${path}`));
        console.log(
`
                 .
                 .
                 .       :
                 :      .
        :..   :  : :  .
           ..  ; :: .
              ... .. :..
             ::: :...
         ::.:.:...;; .....
      :..     .;.. :;     ..
            . :. .  ;.
             .: ;;: ;.
            :; .BRRRV;
               YB BMMMBR
              ;BVIMMMMMt
        .=YRBBBMMMMMMMB
      =RMMMMMMMMMMMMMM;
    ;BMMR=VMMMMMMMMMMMV.
   tMMR::VMMMMMMMMMMMMMB:
  tMMt ;BMMMMMMMMMMMMMMMB.
 ;MMY ;MMMMMMMMMMMMMMMMMMV
 XMB .BMMMMMMMMMMMMMMMMMMM:
 BMI +MMMMMMMMMMMMMMMMMMMMi
.MM= XMMMMMMMMMMMMMMMMMMMMY
 BMt YMMMMMMMMMMMMMMMMMMMMi
 VMB +MMMMMMMMMMMMMMMMMMMM:
 ;MM+ BMMMMMMMMMMMMMMMMMMR
  tMBVBMMMMMMMMMMMMMMMMMB.
   tMMMMMMMMMMMMMMMMMMMB:
    ;BMMMMMMMMMMMMMMMMY
      +BMMMMMMMMMMMBY:
        :+YRBBBRVt;
`
        );
        process.exit(1);
      }

      let result = newPath(path, req.method);

      if (path[path.length -1] === '/') {
        result = newPath(path, req.method, 'index');
      }

      req.method = 'GET';

      console.log(log(req.method, `${path.replace('/mock', '[URL Back-end]')} ➟ src${result}`));
      return result;
    }
  }
}

module.exports = PROXY_CONFIG;
