import { Component, OnInit, Inject } from '@angular/core';
import { MAT_DIALOG_DATA, MatDialogRef } from '@angular/material/dialog';

import { EvoSdkService } from '../../services/evo-sdk.service';
import { AssinaturaDigitalDialogInputData } from '../../services/assinatura-digital-dialog.service';
import { SignAndSendResult } from '../../models/sign-and-send-result.model';

@Component({
  selector: 'datasus-assinatura-digital-sign-dialog',
  templateUrl: './assinatura-digital-sign-dialog.component.html',
  styleUrls: ['./assinatura-digital-sign-dialog.component.scss'],
  providers: [EvoSdkService]
})
export class AssinaturaDigitalSignDialogComponent implements OnInit {

  constructor(
    private matDialogRef: MatDialogRef<AssinaturaDigitalSignDialogComponent>,
    @Inject(MAT_DIALOG_DATA)
    private data: AssinaturaDigitalDialogInputData,
    private evoSdkService: EvoSdkService,
  ) { }

  statusMessage: string;
  ngOnInit(): void {
    // TODO Implementar o stepper que testa o SDK Desktop e o certificado
    //      e chama o serviço do EVO-SDK para assinar:
        //  this.evoSdkService.signAndSend(this.data.idArquivo, this.data.extraInfo);
  }

  close(): void {
    this.matDialogRef.close();
  }

  sign() : void {
    this.statusMessage = 'processing...';
    this.evoSdkService.signAndSend(this.data.idArquivo, {"stamp1":"valor1","stamp2":"valor2"}).subscribe(
      (result: SignAndSendResult) => {
        this.statusMessage = result.parameters.toString();
        console.log(result);
      },
      (error: any) => {
        this.statusMessage = ('ERROR: '+error)
        console.error('#########################################');
        console.error(error);
      },
    );
  }

}
