import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';
import { MatDialogModule } from '@angular/material/dialog';
import { MatButtonModule } from '@angular/material/button';
import { MatStepperModule } from '@angular/material/stepper';
import { MatCardModule } from '@angular/material/card';
import { MatIconModule } from '@angular/material/icon';
import { MatProgressBarModule } from '@angular/material/progress-bar';

import { CoreModule } from '@datasus/core';

import { EvoSdkService } from './services/evo-sdk.service';
import {
  AssinaturaDigitalSignDialogComponent,
} from './components/assinatura-digital-sign-dialog/assinatura-digital-sign-dialog.component';
import {
  AssinaturaDigitalTestDialogComponent,
} from './components/assinatura-digital-test-dialog/assinatura-digital-test-dialog.component';
import {
  AssinaturaDigitalPreviewDialogComponent,
} from './components/assinatura-digital-preview-dialog/assinatura-digital-preview-dialog.component';

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex-Layout
    FlexLayoutModule,
    // Angular Material
    MatDialogModule,
    MatButtonModule,
    MatStepperModule,
    MatCardModule,
    MatIconModule,
    MatProgressBarModule,
    // Datasus
    CoreModule,
  ],
  declarations: [
    // Pipes

    // Components
    AssinaturaDigitalSignDialogComponent,
    AssinaturaDigitalTestDialogComponent,
    AssinaturaDigitalPreviewDialogComponent,
  ],
  entryComponents: [
    AssinaturaDigitalSignDialogComponent,
    AssinaturaDigitalTestDialogComponent,
    AssinaturaDigitalPreviewDialogComponent,
  ],
  exports: [
    // Pipes

    // Components

  ],
  providers: [
    EvoSdkService,
  ]
})
export class ExternalsModule { }
