import { Component, Input } from '@angular/core';

@Component({
  selector: 'datasus-card-content',
  templateUrl: './card-content.component.html',
  styleUrls: ['./card-content.component.scss']

})

export class CardContentComponent {

  private elevationValue = 1;

  @Input() header: string;

  @Input() dir: ('ltr' | 'rtl') = 'ltr';

  @Input() noPadding: boolean;

  @Input() color: (
    'dusky' |
    'bright' |
    'primary' |
    'accent' |
    'warn' |
    'success' |
    'error'
  );

  @Input() colorVariant: ('' | 'light' | 'dark');

  @Input()
  get elevation(): number {
    return this.elevationValue;
  }
  set elevation(elevationValue: number) {
    this.elevationValue = +elevationValue;
  }

  getClass(): string {
    const classes: string[] = [];
    const colorVariant = this.colorVariant === 'light'
      ? 'Light'
      : (this.colorVariant === 'dark' ? 'Dark' : '');
    classes.push(
      !!this.color
      ? `background-${this.color}${colorVariant}`
      : ''
    );
    classes.push(
      this.elevationValue > 0
      ? `mat-elevation-z${this.elevationValue}`
      : `mat-elevation-z${Math.abs(this.elevationValue)}-upside-down`
    );
    return classes.join(' ');
  }

}
