import { Component, Inject, ViewChild, OnInit } from '@angular/core';
import { MatBottomSheetRef, MAT_BOTTOM_SHEET_DATA } from '@angular/material/bottom-sheet';
import { MatInput } from '@angular/material/input';

import { DialogPromptConfig } from '../../configs/dialog-prompt.config';


@Component({
  selector: 'datasus-dialog-prompt',
  templateUrl: './dialog-prompt.component.html',
  styleUrls: ['./dialog-prompt.component.scss']
})
export class DialogPromptComponent implements OnInit {

  @ViewChild(MatInput) input: MatInput;

  config: DialogPromptConfig;
  requiredError: boolean;

  constructor(
    private bottomSheetRef: MatBottomSheetRef<DialogPromptComponent>,
    @Inject(MAT_BOTTOM_SHEET_DATA) data: any,
  ) {
    this.config = data as DialogPromptConfig;
  }

  ngOnInit(): void {
    this.bottomSheetRef.afterOpened().subscribe(
      () => this.input.focus()
    );
  }

  closeMe(input: string): void {
    if (this.config.required && !input) {
      this.requiredError = true;
      this.input.focus();
      return;
    }
    this.requiredError = false;
    this.bottomSheetRef.dismiss(input);
  }
}
