import { ListAfterIndexPipe } from './list-after-index.pipe';

describe('ListAfterIndexPipe', () => {

  let pipe: ListAfterIndexPipe;

  beforeEach(() => {
      pipe = new ListAfterIndexPipe();
  });

  it(
    'Instancia o pipe',
    () => expect(pipe).toBeTruthy()
  );

  it(
    'Retorna [3] passando o indice 2 da lista [1,2,3]',
    () => expect(pipe.transform([1, 2, 3], 2)).toEqual([3])
  );

  it(
    'Retorna [] passando o indice 4 da lista [1,2,3]',
    () => expect(pipe.transform([1, 2, 3], 4)).toEqual([])
  );

  it(
    'Retorna [1,2,3] passando o indice 0 da lista [1,2,3]',
    () => expect(pipe.transform([1, 2, 3], 0)).toEqual([1, 2, 3])
  );

  it(
    'Retorna [1,2,3] passando o indice -1 da lista [1,2,3]',
    () => expect(pipe.transform([1, 2, 3], -1)).toEqual([1, 2, 3])
  );

  it(
    'Retorna [] passando o indice 0 da lista []',
    () => expect(pipe.transform([], 0)).toEqual([])
  );

});
