import { ListUntilIndexPipe } from './list-until-index.pipe';

describe('ListUntilIndexPipe', () => {

  let pipe: ListUntilIndexPipe;

  beforeEach(() => {
      pipe = new ListUntilIndexPipe();
  });

  it(
    'Instancia o pipe',
    () => expect(pipe).toBeTruthy()
  );

  it(
    'Retorna [1,2] passando o indice 2 da lista [1,2,3]',
    () => expect(pipe.transform([1, 2, 3], 2)).toEqual([1, 2])
  );

  it(
    'Retorna [1,2,3] passando o indice 4 da lista [1,2,3]',
    () => expect(pipe.transform([1, 2, 3], 4)).toEqual([1, 2, 3])
  );

  it(
    'Retorna [] passando o indice 0 da lista [1,2,3]',
    () => expect(pipe.transform([1, 2, 3], 0)).toEqual([])
  );

  it(
    'Retorna [] passando o indice -1 da lista [1,2,3]',
    () => expect(pipe.transform([1, 2, 3], -1)).toEqual([])
  );

  it(
    'Retorna [] passando o indice 0 da lista []',
    () => expect(pipe.transform([], 0)).toEqual([])
  );

});
