import { NgModule, ModuleWithProviders } from '@angular/core';
import { HttpClientModule } from '@angular/common/http';

import { WelcomeComponent } from './welcome.component';
import { WelcomeConfig } from './welcome.config';

@NgModule({
  imports: [
    HttpClientModule,
  ],
  declarations: [
    WelcomeComponent,
  ],
  exports: [
    WelcomeComponent,
  ],
  providers: [{
    provide: 'WelcomeConfig',
    useValue: ({} as WelcomeConfig)
  }]
})
export class WelcomeModule {

  /**
   * Criando o Módulo com suas configurações
   * @param welcomeConfig Configuração do welcome: URLs do Backend, do Authorization Server, etc...
   */
  public static forRoot(welcomeConfig: WelcomeConfig): ModuleWithProviders<WelcomeModule> {
    return {
      ngModule: WelcomeModule,
      providers: [{
        provide: 'WelcomeConfig',
        useValue: welcomeConfig
      }]
    };
  }
}
