import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { Routes, RouterModule } from '@angular/router';
import { FormsModule } from '@angular/forms';
import { MultiSelectModule } from 'primeng/multiselect';

import { guardsDefault } from '@datasus/commons';

import { MaterialModule } from '../material/material.module';
import { DatasusModule } from '../datasus/datasus.module';
import { DummyModule } from './dummy.module';
import { LazyComponent } from './lazy.component';
import { LazyResolver } from './lazy-resolver';
import { MultiSelectDirective } from './multi-select.directive';

const routes: Routes = [
  {
    path: '',
    component: LazyComponent,
    data: {
      layoutColor: 'success',
      layoutAnimation: false,
    },
    resolve: {
      teste: LazyResolver,
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
];

@NgModule({
  imports: [
    CommonModule,
    RouterModule.forChild(routes),
    FormsModule,
    MaterialModule,
    MultiSelectModule,
    DatasusModule,
    DummyModule,
  ],
  declarations: [
    LazyComponent,
    MultiSelectDirective,
  ],
})
export class LazyModule { }
