import { Directive, OnInit, Input, HostListener, Renderer2 } from '@angular/core';
import { MultiSelect } from 'primeng/multiselect';

type Option = any;

@Directive({
  selector: '[datasusMultiSelect]'
})
export class MultiSelectDirective implements OnInit {

  @Input() datasusMultiSelect: [MultiSelect, HTMLElement];

  private multiSelect: MultiSelect;
  private item: HTMLElement;

  constructor(
    private renderer: Renderer2
  ) {}

  @HostListener('click')
  onClick(): void {
    this.multiSelect.writeValue([]);
  }

  ngOnInit(): void {
    this.multiSelect = this.datasusMultiSelect[0];
    this.item = this.datasusMultiSelect[1];
    this.renderer.listen(
      this.item.parentElement,
      'keydown.enter',
      () => this.keyDownEnter(),
    );
  }

  private keyDownEnter(): void {
    this.item.click();
  }

}
