import { NgModule } from '@angular/core';

import { CoreModule } from '@datasus/core';
import { LayoutModule } from '@datasus/layout';
import { CommonsModule } from '@datasus/commons';
import { FormsModule } from '@datasus/forms';
import { ExternalsModule } from '@datasus/externals';

import * as packageJson from '../../package.json';

@NgModule({
  imports: [
    CoreModule,
    LayoutModule.forRoot({
      withGovBrBar: true,
      appName: 'DATASUS - Angular',
      appVersion: packageJson.version,
    }),
    CommonsModule.forRoot({
      welcomeText: 'Olá!',
      welcomeHtml: `
        <p class="mat-display-2 align-center">Este é o <strong>DATASUS - Angular</strong></p>
        <p class="mat-display-1 align-center">Projeto com os módulos do <code>@datasus</code></p>
      `,
    }),
    FormsModule,
    ExternalsModule,
  ],
  exports: [
    LayoutModule,
    CommonsModule,
    FormsModule,
    ExternalsModule,
  ],
})
export class DatasusModule { }
