/*==============================================================*/
/* Table: tb_area                                             */
/*==============================================================*/

-- DROP TABLE dbscodes.tb_area;

CREATE SEQUENCE dbscodes.sq_area_coseqarea;

CREATE TABLE dbscodes.tb_area
(
    co_seq_area bigint NOT NULL DEFAULT nextval('dbscodes.sq_area_coseqarea'::regclass),
    ds_area character varying(30) NOT NULL,
    CONSTRAINT pk_area PRIMARY KEY (co_seq_area)
);

COMMENT ON TABLE dbscodes.tb_area
    IS 'Registros das áreas do sistema.';

COMMENT ON COLUMN dbscodes.tb_area.co_seq_area IS 'Codigo de identificacão, gerador pela sequence: dbscodes.sq_area_coseqarea';
COMMENT ON COLUMN dbscodes.tb_area.ds_area
    IS 'Descrição da área.';
	
/*==============================================================*/
/* Table: tb_perfil                                             */
/*==============================================================*/

ALTER TABLE dbscodes.tb_perfil ADD COLUMN co_area bigint;
ALTER TABLE dbscodes.tb_perfil ADD COLUMN st_demanda_administrativa boolean not null default false;
ALTER TABLE dbscodes.tb_perfil ADD COLUMN st_demanda_judicial boolean not null default false;

COMMENT ON COLUMN tb_perfil.co_area IS
'Área no qual o perfil está relacionado. Chave estrangeira da tabela TB_AREA.CO_SEQ_AREA.';
COMMENT ON COLUMN tb_perfil.st_demanda_administrativa IS
'Indica se o perfil está atrelado a demanda administrativa.';
COMMENT ON COLUMN tb_perfil.st_demanda_judicial IS
'Indica se o perfil está atrelado a demanda judicial.';

ALTER TABLE dbscodes.tb_perfil 
	ADD CONSTRAINT fk_area_perfilarea 
	FOREIGN KEY (co_area) 
	REFERENCES dbscodes.tb_area (co_seq_area);