CREATE TABLE dbscodes.rl_usuario_unid_dispensadora
(
    co_usuario bigint NOT NULL,
    co_unidade_dispensadora bigint NOT NULL,
    CONSTRAINT pk_usuariouniddispensadora PRIMARY KEY (co_usuario, co_unidade_dispensadora)
);

COMMENT ON TABLE dbscodes.rl_usuario_unid_dispensadora IS 'Relacionamento entre usuário e unidade dispensadora.';
COMMENT ON COLUMN dbscodes.rl_usuario_unid_dispensadora.co_usuario IS 'Codigo de identificacão do Usuario, chave estrangeira para dbscodes.tb_usuario';
COMMENT ON COLUMN dbscodes.rl_usuario_unid_dispensadora.co_unidade_dispensadora IS 'Codigo de identificacão da Unidade Dispensadora, chave estrangeira para dbscodes.tb_unidade_dispensadora';

ALTER TABLE dbscodes.rl_usuario_unid_dispensadora ADD CONSTRAINT fk_usuario_usuunidispen FOREIGN KEY(co_usuario)
    REFERENCES dbscodes.tb_usuario(co_seq_usuario);
ALTER TABLE dbscodes.rl_usuario_unid_dispensadora ADD CONSTRAINT fk_uniddispen_usuunidispen FOREIGN KEY(co_unidade_dispensadora)
    REFERENCES dbscodes.tb_unidade_dispensadora(co_seq_unidade_dispensadora);
