CREATE SEQUENCE dbscodes.sq_planosaude_coseqplanosaude;
CREATE TABLE dbscodes.tb_plano_saude (
    co_seq_plano_saude BIGINT DEFAULT NEXTVAL('dbscodes.sq_planosaude_coseqplanosaude'::REGCLASS) NOT NULL CONSTRAINT pk_planosaude PRIMARY KEY, 
	ds_plano_saude CHARACTER VARYING(50) NOT NULL,
	tp_plano_saude CHARACTER VARYING(1 BYTE) NOT NULL,
	CONSTRAINT ck_planosaude_tpplanosaude CHECK (tp_plano_saude::text = 'I'::text OR tp_plano_saude::text = 'E'::text),
);
COMMENT ON TABLE dbscodes.tb_plano_saude
    IS 'Registros de plano de saúde';
COMMENT ON COLUMN dbscodes.tb_plano_saude.co_seq_plano_saude
    IS 'Codigo de identificacão do plano de saúde, gerado pela sequence: dbscodes.sq_planosaude_coseqplanosaude';
COMMENT ON COLUMN dbscodes.tb_plano_saude.ds_plano_saude
    IS 'Descrição do plano de saúde';
COMMENT ON COLUMN dbscodes.tb_plano_saude.tp_plano_saude
    IS 'Tipo de plano de saúde. I = Individual e E = Empresarial';