CREATE SEQUENCE dbscodes.sq_localjefaz_coseqlocaljefaz;
CREATE TABLE dbscodes.tb_local_jefaz (
    co_seq_local_jefaz BIGINT DEFAULT NEXTVAL('dbscodes.sq_localjefaz_coseqlocaljefaz'::REGCLASS) NOT NULL CONSTRAINT pk_localjefaz PRIMARY KEY, 
	ds_local_jefaz CHARACTER VARYING(50) NOT NULL,
	tp_local_jefaz CHARACTER VARYING(1 BYTE) NOT NULL,
	st_ativo BOOLEAN NOT NULL DEFAULT false,
	CONSTRAINT ck_localjefaz_tplocaljefaz CHECK (tp_local_jefaz::text = 'E'::text OR tp_local_jefaz::text = 'O'::text),
);
COMMENT ON TABLE dbscodes.tb_local_jefaz
    IS 'Registros de local jefaz';
COMMENT ON COLUMN dbscodes.tb_local_jefaz.co_seq_local_jefaz
    IS 'Codigo de identificacão do local jefaz, gerado pela sequence: dbscodes.sq_localjefaz_coseqlocaljefaz';
COMMENT ON COLUMN dbscodes.tb_local_jefaz.ds_local_jefaz
    IS 'Descrição do local jefaz';
COMMENT ON COLUMN dbscodes.tb_local_jefaz.tp_local_jefaz
    IS 'Tipo de local jefaz. E = Encaminhado e O = Orientado';
COMMENT ON COLUMN dbscodes.tb_local_jefaz.st_ativo
    IS 'Situação do local jefaz. False - inativo e True - ativo';
	