--Criação tabela tipo evento

CREATE SEQUENCE dbscodes.sq_tipoevento_coseqtipoevento;
CREATE TABLE dbscodes.tb_tipo_evento
(
   co_seq_tipo_evento BIGINT NOT NULL DEFAULT nextval('dbscodes.sq_tipoevento_coseqtipoevento'::regclass) CONSTRAINT pk_tipoevento PRIMARY KEY,
   ds_descricao CHARACTER VARYING(50),
);

COMMENT ON TABLE dbscodes.tb_tipo_evento IS 'Registros de tipo_eventos';
COMMENT ON COLUMN dbscodes.tb_tipo_evento.co_seq_tipo_evento IS 'Codigo de identificacão da tipo_evento, gerado pela sequence: dbscodes.sq_tipoevento_coseqtipoevento';
COMMENT ON COLUMN dbscodes.tb_tipo_evento.ds_descricao IS 'Descrição';

--Criação tabela evento
---ALTERADO NOME DAS FKs

CREATE SEQUENCE dbscodes.sq_evento_coseqevento;
CREATE TABLE dbscodes.tb_evento
(
   co_seq_evento BIGINT NOT NULL DEFAULT nextval('dbscodes.sq_evento_coseqevento'::regclass) CONSTRAINT pk_evento PRIMARY KEY,
   dt_evento TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
   dt_entrada TIMESTAMP NOT NULL,
   co_tipo_evento BIGINT NOT NULL CONSTRAINT fk_tipoevento_evento REFERENCES dbscodes.tb_tipo_evento(co_seq_tipo_evento),
   co_autor_demanda BIGINT NOT NULL CONSTRAINT fk_autordemanda_evento REFERENCES dbscodes.tb_autor_demanda(co_seq_autor_demanda)
);

COMMENT ON TABLE dbscodes.tb_evento IS 'Registros de eventos';
COMMENT ON COLUMN dbscodes.tb_evento.co_seq_evento IS 'Codigo de identificacão do evento, gerado pela sequence: dbscodes.sq_evento_coseqevento';
COMMENT ON COLUMN dbscodes.tb_evento.co_tipo_evento IS 'Codigo de identificacão do tipo do evento, chave estrangeira da tabela dbscodes.tb_tipo_evento';
COMMENT ON COLUMN dbscodes.tb_evento.co_autor_demanda IS 'Codigo de identificacão do auto da demanda, gerado pela sequence: dbscodes.tb_autor_demanda';
COMMENT ON COLUMN dbscodes.tb_evento.dt_entrada IS 'Data de entrada do evento';
COMMENT ON COLUMN dbscodes.tb_evento.dt_evento IS 'Data do evento';