--------------------------------------------------------
--  DDL for Table tb_protocolo_jefaz
--------------------------------------------------------

CREATE SEQUENCE dbscodes.sq_projef_cosqprojef;
CREATE SEQUENCE dbscodes.sq_projefcount_cosqprojefcount INCREMENT 1 START 100;

CREATE TABLE dbscodes.tb_protocolo_jefaz
(
  co_seq_protocolo_jefaz BIGINT NOT NULL DEFAULT nextval('dbscodes.sq_projef_cosqprojef'::REGCLASS),
  co_seq_protocolo_jefaz_count BIGINT NOT NULL DEFAULT nextval('dbscodes.sq_projefcount_cosqprojefcount'::REGCLASS),
  nu_ano CHARACTER VARYING(4) NOT NULL,
  no_login_usuario CHARACTER VARYING(50) NOT NULL,
  co_unidade_organizacional BIGINT NOT NULL,
  CONSTRAINT pk_protocolojefaz PRIMARY KEY (co_seq_protocolo_jefaz)
);

COMMENT ON TABLE  dbscodes.tb_protocolo_jefaz
  IS 'Registros dos protocolo jefaz';
COMMENT ON COLUMN dbscodes.tb_protocolo_jefaz.co_seq_protocolo_jefaz
  IS 'Código de identificacão do protocolo jefaz, gerado pela sequence: dbscodes.sq_projef_cosqprojef';
COMMENT ON COLUMN dbscodes.tb_protocolo_jefaz.co_seq_protocolo_jefaz_count
  IS 'Código Contador de identificacão do protocolo jefaz, gerado pela sequence: dbscodes.sq_projefcount_cosqprojefcount';
COMMENT ON COLUMN  dbscodes.tb_protocolo_jefaz.nu_ano
  IS 'Número do ano do protocolo jefaz';
COMMENT ON COLUMN  dbscodes.tb_protocolo_jefaz.no_login_usuario
  IS 'Nome do login usuário do protocolo jefaz';
COMMENT ON COLUMN  dbscodes.tb_protocolo_jefaz.co_unidade_organizacional
  IS 'Código da unidade organizacional do protocolo jefaz';

