package br.gov.datasus.scodes.acl.api;

import br.gov.datasus.scodes.acl.model.dto.FuncionalidadeDTO;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;

import java.util.List;

@RequestMapping(value = "/funcionalidade")
public interface FuncionalidadeApi {

    @GetMapping(value = "/sistema/{siglaSistema}", produces = MediaType.APPLICATION_JSON_VALUE)
    public ResponseEntity<List<FuncionalidadeDTO>> obterPorSistema(
        @PathVariable(name = "siglaSistema") String siglaSistema);

    @GetMapping(value = "/sistema/{siglaSistema}/perfil/{siglaPerfil}", produces = MediaType.APPLICATION_JSON_VALUE)
    public ResponseEntity<List<FuncionalidadeDTO>> obterPorSistemaPerfil(
        @PathVariable(name = "siglaSistema") String siglaSistema,
        @PathVariable(name = "siglaPerfil") String siglaPerfil);
}
