package br.gov.datasus.scodes.acl.api;

import br.gov.datasus.scodes.acl.model.dto.PerfilDTO;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;

import java.util.List;

@RequestMapping(value = "/perfil")
public interface PerfilApi {

    @GetMapping(value = "/sistema/{siglaSistema}", produces = MediaType.APPLICATION_JSON_VALUE)
    public ResponseEntity<List<PerfilDTO>> obterPorSistema(@PathVariable(name = "siglaSistema") String siglaSistema);

    @GetMapping(value = "/usuario/{idUsuario}/sistema/{siglaSistema}", produces = MediaType.APPLICATION_JSON_VALUE)
    public ResponseEntity<List<PerfilDTO>> obterPorUsuarioSistema(@PathVariable(name = "idUsuario") Long idUsuario,
                                                                  @PathVariable(name = "siglaSistema") String siglaSistema);
}
