package br.gov.datasus.scodes.acl.api;

import br.gov.datasus.api.core.pagination.PageableRequestModel;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.acl.model.dto.SistemaDTO;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;
import java.util.Optional;

@RequestMapping(value = "/sistema")
public interface SistemaApi {

    @GetMapping(produces = MediaType.APPLICATION_JSON_VALUE)
    public ResponseEntity<SistemaDTO> obterPorIdSigla(@RequestParam(name = "id", required = false) Optional<Long> id,
                                                      @RequestParam(name = "sigla", required = false) Optional<String> sigla);

    @PostMapping(value = "/paginado", produces = MediaType.APPLICATION_JSON_VALUE)
    public ResponseEntity<PageableResponseModel<SistemaDTO>> obterTodosPaginado(
        @Valid @RequestBody PageableRequestModel<?> pageableRequestModel);

    @GetMapping(value = "/usuario/{idUsuario}", produces = MediaType.APPLICATION_JSON_VALUE)
    public ResponseEntity<List<SistemaDTO>> obterSistemasUsuario(@PathVariable(name = "idUsuario") Long idUsuario);
}
