package br.gov.datasus.scodes.acl.controller;

import br.gov.datasus.scodes.acl.api.EsferaApi;
import br.gov.datasus.scodes.acl.model.dto.EsferaAtuacaoDTO;
import br.gov.datasus.scodes.acl.service.EsferaService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Api(tags = "Esfera")
@RequiredArgsConstructor
@RestController
public class EsferaController implements EsferaApi {
	private final EsferaService service;

	@ApiOperation(value = "Obter todas esferas por usuario e perfil de sistema")
	@Override
	public ResponseEntity<List<EsferaAtuacaoDTO>> obterPorUsuarioSistemaPerfil(
			@PathVariable(name = "idUsuario") Long idUsuario, @PathVariable(name = "siglaSistema") String siglaSistema,
			@PathVariable(name = "siglaPerfil") String siglaPerfil) {
		List<EsferaAtuacaoDTO> lista = service.obterPorUsuarioSistemaPerfil(idUsuario, siglaSistema, siglaPerfil);
		return ResponseEntity.ok(lista);
	}
}
