package br.gov.datasus.scodes.acl.controller;

import br.gov.datasus.scodes.acl.api.FuncionalidadeApi;
import br.gov.datasus.scodes.acl.model.dto.FuncionalidadeDTO;
import br.gov.datasus.scodes.acl.service.FuncionalidadeService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Api(tags = "Funcionalidade")
@RequiredArgsConstructor
@RestController
public class FuncionalidadeController implements FuncionalidadeApi {

	private final FuncionalidadeService service;

	@ApiOperation(value = "Obter todas funcionalidades de um sistema")
	@Override
	public ResponseEntity<List<FuncionalidadeDTO>> obterPorSistema(
			@PathVariable(name = "siglaSistema") String siglaSistema) {
		List<FuncionalidadeDTO> lista = service.obterPorSistema(siglaSistema);
		return ResponseEntity.ok(lista);
	}

	@ApiOperation(value = "Obter funcionalidades por perfil e sistema.")
	@Override
	public ResponseEntity<List<FuncionalidadeDTO>> obterPorSistemaPerfil(
			@PathVariable(name = "siglaSistema") String siglaSistema,
			@PathVariable(name = "siglaPerfil") String siglaPerfil) {
		List<FuncionalidadeDTO> lista = service.obterPorSistemaPerfil(siglaSistema, siglaPerfil);
		return ResponseEntity.ok(lista);
	}
}
