package br.gov.datasus.scodes.acl.controller;

import br.gov.datasus.scodes.acl.api.PermissaoApi;
import br.gov.datasus.scodes.acl.model.dto.PermissaoDTO;
import br.gov.datasus.scodes.acl.service.PermissaoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;

@Api(tags = "Permissao")
@RequiredArgsConstructor
@RestController
public class PermissaoController implements PermissaoApi {

	private final PermissaoService service;

	@ApiOperation(value = "Obter árvore de permissões.")
	@Override
	public ResponseEntity<PermissaoDTO> obterArvorePermissoes(@PathVariable(name = "siglaSistema") String siglaSistema,
                                                              @PathVariable(name = "siglaPerfil") String siglaPerfil) {
		PermissaoDTO permissao = service.obterArvorePermissoes(siglaSistema, siglaPerfil);
		return ResponseEntity.ok(permissao);
	}
}
