package br.gov.datasus.scodes.acl.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.hibernate.annotations.Where;

import javax.persistence.*;
import java.util.Date;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_ACL_USUARIO", schema = "DBSCODES")
@Where(clause = "ST_CONFIRMADO='S'")

@NamedQueries({
		@NamedQuery(name = IdentificacaoUsuario.OBTER_IDENTIFICACAO, query = "SELECT id FROM IdentificacaoUsuario id WHERE 1=1 AND (id.id = :id ) AND (id.cpf = :cpf) AND (id.email = :email)") })
public class IdentificacaoUsuario extends BaseEntity<Long> {

	private static final long serialVersionUID = 1L;

	public static final String OBTER_IDENTIFICACAO = "Usuario.obterIdentificacao";

	@Id
	@Column(name = "CO_SEQ_USUARIO")
	private Long id;

	@Column(name = "CO_CPF_USUARIO", length = 11)
	private String cpf;

	@Column(name = "DS_EMAIL", length = 100)
	private String email;

	@Column(name = "CO_SEXO", length = 1)
	private String sexo;

	@Column(name = "DT_NASCIMENTO")
	@Temporal(TemporalType.TIMESTAMP)
	private Date dataNascimento;

	@Column(name = "NO_MAE", length = 70)
	private String nomeMae;

	@Column(name = "NO_USUARIO", length = 70)
	private String nome;

	@Column(name = "NU_CNS", length = 15)
	private String cns;

	@Column(name = "NU_PASSAPORTE", length = 30)
	private String passaporte;

    @Column(name = "DT_CADASTRAMENTO")
    @Temporal(TemporalType.TIMESTAMP)
    private Date dataCadastro;

}
