package br.gov.datasus.scodes.acl.model.entity;

import javax.persistence.Column;
import javax.persistence.Convert;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.converter.SimNaoToBooleanConverter;
import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_PAIS", schema = "DBGERAL")
public class Pais extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "CO_SEQ_PAIS")
    private Long id;

    @Column(name = "NO_PAIS", length = 70)
    private String nomePais;

    @Convert(converter = SimNaoToBooleanConverter.class)
    @Column(name = "ST_REGISTRO_ATIVO")
    private Boolean registroAtivo;

}
