package br.gov.datasus.scodes.acl.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import br.gov.datasus.scodes.acl.model.converter.TipoPermissaoEnumConverter;
import br.gov.datasus.scodes.acl.model.enums.TipoPermissaoEnum;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_ACL_PERMISSAO", schema = "DBSCODES")
public class Permissao extends BaseEntity<Long> {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@Column(name = "CO_SEQ_PERMISSAO")
	private Long id;

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "CO_FUNCIONALIDADE")
	private Funcionalidade funcionalidade;

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "CO_PERFIL")
	private Perfil perfil;

	@Column(name = "CO_PERMISSAO_PAI")
	private Long idPermissaoPai;

	@OneToMany(mappedBy = "idPermissaoPai")
	private List<Permissao> permissoes = new ArrayList<Permissao>();

	@Column(name = "DS_PERMISSAO", length = 100)
	private String permissao;

	@Column(name = "NU_ORDEM")
	private Long ordem;

	@Convert(converter = TipoPermissaoEnumConverter.class)
	@Column(name = "TP_PERMISSAO")
	private TipoPermissaoEnum tipo;

}
