package br.gov.datasus.scodes.acl.model.entity;

import javax.persistence.Column;
import javax.persistence.Convert;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.converter.SimNaoToBooleanConverter;
import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_RACA_COR", schema = "DBGERAL")
public class RacaCor extends BaseEntity<String> {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@Column(name = "CO_RACA_COR", length = 2)
	private String id;

	@Column(name = "DS_RACA_COR", length = 25)
	private String racaCor;

	@Convert(converter = SimNaoToBooleanConverter.class)
	@Column(name = "ST_REGISTRO_ATIVO")
	private Boolean registroAtivo;

}
