package br.gov.datasus.scodes.acl.model.entity;

import javax.persistence.Column;
import javax.persistence.Convert;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.converter.SimNaoToBooleanConverter;
import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_ACL_SISTEMA", schema = "DBSCODES")
@NamedQueries({

		@NamedQuery(name = Sistema.OBTER_PAGINADO, query = "SELECT sistema FROM Sistema sistema "),
		@NamedQuery(name = Sistema.OBTER_POR_ID_SIGLA, query = "SELECT sistema FROM Sistema sistema "
				+ "WHERE 1=1 AND (sistema.id = :id) AND (sistema.sigla = :sigla)"),
		@NamedQuery(name = "Sistema.obterSistemasUsuario", query = "SELECT distinct upe.esferaSistema.sistema FROM UsuarioPerfilEsfera upe "
				+ "WHERE upe.situacaoAcesso = 'SIM' AND upe.usuarioPerfil.usuario.id = :idUsuario")

})
public class Sistema extends BaseEntity<Long> {

	private static final long serialVersionUID = 1L;

	public static final String OBTER_PAGINADO = "Sistema.obterTodosPaginado";

	public static final String OBTER_POR_ID_SIGLA = "Sistema.obterPorIdSigla";

	@Id
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_SISTEMA")
	@SequenceGenerator(name = "SEQ_GENERATOR_SISTEMA", sequenceName = "SQ_ACL_SISTEMA_COSEQSISTEMA", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
	@Column(name = "CO_SEQ_SISTEMA")
	private Long id;

	@Column(name = "DS_EMAIL_CORPORATIVO", length = 100)
	private String emailCorporativo;

	@Column(name = "DS_PAGINA_INICIAL", length = 100)
	private String paginaInicial;

	@Column(name = "DS_SISTEMA", length = 100)
	private String descricao;

	@Column(name = "QT_DIA_SEM_ACESSO")
	private Long quantidadeDiaSemAcesso;

	@Column(name = "SG_SISTEMA", length = 20)
	private String sigla;

	@Convert(converter = SimNaoToBooleanConverter.class)
	@Column(name = "ST_VALIDA_DOMINIO_EMAIL_USUARI")
	private Boolean validaDominioEmailUsuari;

	@Convert(converter = SimNaoToBooleanConverter.class)
	@Column(name = "ST_VALIDA_USUARIO_RH")
	private Boolean validaUsuarioRh;

}
