package br.gov.datasus.scodes.acl.model.entity;

import javax.persistence.Column;
import javax.persistence.Convert;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.converter.SimNaoToBooleanConverter;
import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_ACL_USUARIO_COMPLEMENTO", schema = "DBSCODES")
public class UsuarioComplemento extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_USUARIO_COMPLEMENTO")
    @SequenceGenerator(name = "SEQ_GENERATOR_USUARIO_COMPLEMENTO", sequenceName = "SQ_ACL_USUARIOCOMPL_COSEQUSUARCOMP", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_USUARIO_COMPLEMENTO")
    private Long id;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_MUNICIPIO_IBGE")
    private Municipio municipio;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_PAIS")
    private Pais pais;

    @Column(name = "DS_BAIRRO", length = 100)
    private String descricaoBairro;

    @Column(name = "DS_LOGRADOURO", length = 100)
    private String descricaoLogradouro;

    @Column(name = "DS_LOGRADOURO_COMPLEMENTO", length = 100)
    private String descricaoLogradouroComplemento;

    @Column(name = "DS_OCUPACAO", length = 50)
    private String descricaoOcupacao;

    @Column(name = "DS_UNIDADE_ORG", length = 100)
    private String descricaoUnidadeOrg;

    @Column(name = "NU_CELULAR", length = 9)
    private String numeroCelular;

    @Column(name = "NU_CEP", length = 8)
    private String numeroCep;

    @Column(name = "NU_DDD_CELULAR", length = 4)
    private String numeroDddCelular;

    @Column(name = "NU_DDD_FAX", length = 4)
    private String numeroDddFax;

    @Column(name = "NU_DDD_FONE", length = 4)
    private String numeroDddFone;

    @Column(name = "NU_DDI", length = 4)
    private String numeroDdi;

    @Column(name = "NU_FAX", length = 9)
    private String numeroFax;

    @Column(name = "NU_FONE", length = 9)
    private String numeroFone;

    @Column(name = "NU_RAMAL", length = 4)
    private String numeroRamal;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "SG_UF",referencedColumnName="SG_UF")
    private Uf uf;

    @Convert(converter = SimNaoToBooleanConverter.class)
    @Column(name = "ST_SENHA_EXPIRADA")
    private Boolean senhaExpirada;

}
