package br.gov.datasus.scodes.acl.model.enums;

import br.gov.datasus.api.core.model.annotations.Dominio;
import com.fasterxml.jackson.annotation.JsonValue;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.io.Serializable;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import java.util.stream.Stream;


@Dominio("Informar descrição")
@JsonSerialize
@AllArgsConstructor
public enum TipoPermissaoEnum implements Serializable {
    MENU("MEN", "Menu"),
    FUNCIONALIDADE("FUN", "Funcionalidade"),
    SUBMENU("SUB", "Submenu"),
    RAIZ("ROO", "Raiz");

	@Getter
	@JsonValue
	private String codigo;

	@Getter
	private String descricao;

	public static Optional<TipoPermissaoEnum> obterPorCodigo(final String codigo) {
		return TipoPermissaoEnum.stream().filter(e -> e.getCodigo().equals(codigo)).findFirst();
	}

	public static Optional<TipoPermissaoEnum> obterPorDescricao(final String descricao) {
		return TipoPermissaoEnum.stream().filter(e -> e.getDescricao().equals(descricao)).findFirst();
	}

	public static Stream<TipoPermissaoEnum> stream() {
		return Stream.of(TipoPermissaoEnum.values());
	}

	public static List<TipoPermissaoEnum> list() {
		return Arrays.asList(TipoPermissaoEnum.values());
	}
}
