package br.gov.datasus.scodes.acl.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.scodes.acl.model.dto.PerfilDTO;
import br.gov.datasus.scodes.acl.model.entity.Perfil;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface PerfilMapper extends BaseMapper<Perfil, PerfilDTO> {

	PerfilDTO toDto(Perfil entity);

	List<PerfilDTO> toDto(List<Perfil> entities);

	List<PerfilDTO> toDto(Iterable<Perfil> entities);

	Perfil toEntity(PerfilDTO dto);

	List<Perfil> toEntity(List<PerfilDTO> dtos);

	@InheritInverseConfiguration(name = "toDto")
	void fromDto(PerfilDTO dto, @MappingTarget Perfil entity);
}
