package br.gov.datasus.scodes.acl.repository;

import br.gov.datasus.api.core.dynamicquery.repository.DynamicNativeQueryRepository;
import br.gov.datasus.api.core.dynamicquery.repository.DynamicQueryRepository;
import br.gov.datasus.scodes.acl.model.entity.Permissao;
import br.gov.datasus.scodes.acl.model.enums.TipoPermissaoEnum;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;

public interface PermissaoRepository
		extends CrudRepository<Permissao, Long>, DynamicQueryRepository, DynamicNativeQueryRepository {
	@Query("SELECT perm FROM Permissao perm WHERE perm.idPermissaoPai is NULL AND perm.tipo =:tipo AND perm.perfil.sistema.sigla = :siglaSistema AND perm.perfil.sigla = :siglaPerfil ORDER BY perm.ordem ASC ")
	Permissao obterArvorePermissoes(@Param("siglaSistema") String siglaSistema,
			@Param("siglaPerfil") String siglaPerfil, @Param("tipo") TipoPermissaoEnum tipo);
}
