package br.gov.datasus.scodes.acl.repository;

import br.gov.datasus.api.core.dynamicquery.repository.DynamicNativeQueryRepository;
import br.gov.datasus.api.core.dynamicquery.repository.DynamicQueryRepository;
import br.gov.datasus.scodes.acl.model.entity.Sistema;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;

public interface SistemaRepository extends CrudRepository<Sistema, Long>, PagingAndSortingRepository<Sistema, Long>,
    DynamicQueryRepository, DynamicNativeQueryRepository {

    @Query("SELECT s FROM Sistema s ")
    public Page<Sistema> obterTodosPaginado(Pageable paginacao);

    public Iterable<Sistema> obterSistemasUsuario(@Param("idUsuario") Long idUsuario);

}
