package br.gov.datasus.scodes.acl.service;

import br.gov.datasus.scodes.acl.model.dto.PerfilDTO;
import br.gov.datasus.scodes.acl.model.entity.Perfil;
import br.gov.datasus.scodes.acl.model.mapper.PerfilMapper;
import br.gov.datasus.scodes.acl.repository.PerfilRepository;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@RequiredArgsConstructor
@Transactional(propagation = Propagation.SUPPORTS)
public class PerfilService {

	private final PerfilRepository repository;
	private final PerfilMapper mapper;

	public List<PerfilDTO> obterPorSistema(String siglaSistema) {
		Iterable<Perfil> itens = repository.obterPorSistema(siglaSistema);
		return mapper.toDto(itens);
	}

	public List<PerfilDTO> obterPorUsuarioSistema(Long idUsuario, String siglaSistema) {
		Iterable<Perfil> itens = repository.obterPorUsuarioSistema(idUsuario, siglaSistema);
		return mapper.toDto(itens);
	}

}
