package br.gov.datasus.scodes.acl.service;

import br.gov.datasus.api.core.exception.ResourceNotFoundException;
import br.gov.datasus.scodes.acl.model.dto.PermissaoDTO;
import br.gov.datasus.scodes.acl.model.entity.Permissao;
import br.gov.datasus.scodes.acl.model.enums.TipoPermissaoEnum;
import br.gov.datasus.scodes.acl.model.mapper.PermissaoMapper;
import br.gov.datasus.scodes.acl.repository.PermissaoRepository;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

@Service
@RequiredArgsConstructor
@Transactional(propagation = Propagation.SUPPORTS)
public class PermissaoService {

    private final PermissaoRepository repository;
    private final PermissaoMapper mapper;

    public PermissaoDTO obterArvorePermissoes(String siglaSistema, String siglaPerfil) {
        Permissao permissao = repository.obterArvorePermissoes(siglaSistema, siglaPerfil, TipoPermissaoEnum.RAIZ);
        if (permissao == null) {
            throw new ResourceNotFoundException();
        }
        return mapper.toDto(permissao);
    }

}
