package br.gov.datasus.authorization;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.context.event.ApplicationReadyEvent;
import org.springframework.context.ApplicationListener;
import org.springframework.stereotype.Component;

import br.gov.datasus.authorization.configuration.properties.ApplicationProperties;

@Component
public class ApplicationBootInitialization implements ApplicationListener<ApplicationReadyEvent> {

	@Autowired
	private ApplicationProperties.Security securityProperties;

	@Override
	public void onApplicationEvent(ApplicationReadyEvent event) {
		proxyInicialization();
	}

	private void proxyInicialization() {
		if (securityProperties.proxyEnable) {
			// HTTP
			System.setProperty("http.proxyHost", securityProperties.proxyHost);
			System.setProperty("http.proxyPort", securityProperties.proxyPort);

			// HTTPS
			System.setProperty("https.proxyHost", securityProperties.proxyHost);
			System.setProperty("https.proxyPort", securityProperties.proxyPort);
		}

	}

}
