package br.gov.datasus.authorization.configuration.properties;

import java.nio.charset.StandardCharsets;
import java.util.Locale;

import org.springframework.context.support.ResourceBundleMessageSource;

public class MessageSource {

	private static final String PROPERTIES_MESSAGES = "properties/messages";

	private static final ResourceBundleMessageSource messageSource;

	private static MessageSource instance;

	static {
		messageSource = new ResourceBundleMessageSource();
		messageSource.setBasenames(PROPERTIES_MESSAGES);
		messageSource.setDefaultEncoding(StandardCharsets.UTF_8.name());
	}

	private MessageSource() {
		super();
	}

	public static MessageSource get() {
		if (instance == null) {
			instance = new MessageSource();
		}
		return instance;
	}

	public String message(String key) {
		return messageSource.getMessage(key, null, Locale.getDefault());
	}

	public String message(String key, String... args) {
		return messageSource.getMessage(key, args, Locale.getDefault());
	}
}
