package br.gov.datasus.authorization.configuration.swagger;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import springfox.documentation.builders.ApiInfoBuilder;
import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.service.ApiInfo;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;

@Configuration
public class SwaggerConfiguration {

    public static final String TITLE = "API do Autorizador";
    public static final String DESCRIPTION = "Autorizador do DATASUS";

    private ApiInfo apiInfo() {
        return new ApiInfoBuilder()
                    .title(TITLE)
                    .description(DESCRIPTION)
                    .version("ver no POM.xml")
                    .build();
    }

    @Bean
    public Docket customImplementation() {
        return new Docket(DocumentationType.SWAGGER_2)
                .apiInfo(apiInfo()).select()
                .apis(RequestHandlerSelectors.any())
                .paths(PathSelectors.any())
                .build().pathMapping("/");
    }
}
