package br.gov.datasus.authorization.controller;

import br.gov.datasus.authorization.security.oauth2.model.User;
import br.gov.datasus.authorization.security.oauth2.model.UserInfo;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;

@Controller
public class UserController {

	@GetMapping(value = "/me", produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<UserInfo> user() {
		User principal = (User) SecurityContextHolder.getContext().getAuthentication().getPrincipal();
		return ResponseEntity.ok(principal.getUserInfo());
	}
}
