package br.gov.datasus.authorization.model.scpa;

import javax.persistence.*;
import java.time.LocalDateTime;

@Entity
@Table(name = "TH_ACL_ACESSO", schema = "DBSCODES")
public class Acesso {

	@Id
	@GeneratedValue(generator = "SQ_TH_ACL_ACESSO", strategy = GenerationType.SEQUENCE)
	@SequenceGenerator(name = "SQ_TH_ACL_ACESSO", sequenceName = "SQ_ACESSO_COSEQACESSO", schema = "DBSCODES", allocationSize = 1)
	@Column(name = "CO_SEQ_ACESSO")
	private Long id;

	@Column(name = "CO_USUARIO")
	private Long idUsuario;

	@Column(name = "SG_SISTEMA")
	private String siglaSistema;

	@Column(name = "DT_ACESSO")
	private LocalDateTime dateAcesso;

	@Column(name = "NU_IP_MAQUINA")
	private String ipAcesso;

	@Column(name = "ST_ACESSO_VALIDO")
	private String acessoValido = "S";

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Long getIdUsuario() {
		return idUsuario;
	}

	public void setIdUsuario(Long idUsuario) {
		this.idUsuario = idUsuario;
	}

	public String getSiglaSistema() {
		return siglaSistema;
	}

	public void setSiglaSistema(String siglaSistema) {
		this.siglaSistema = siglaSistema;
	}

	public LocalDateTime getDateAcesso() {
		return dateAcesso;
	}

	public void setDateAcesso(LocalDateTime dateAcesso) {
		this.dateAcesso = dateAcesso;
	}

	public String getIpAcesso() {
		return ipAcesso;
	}

	public void setIpAcesso(String ipAcesso) {
		this.ipAcesso = ipAcesso;
	}

	public String getAcessoValido() {
		return acessoValido;
	}

	public void setAcessoValido(String acessoValido) {
		this.acessoValido = acessoValido;
	}

}
