package br.gov.datasus.authorization.model.scpa;

import javax.persistence.Column;
import javax.persistence.Convert;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;

import br.gov.datasus.authorization.model.converter.SimNaoConverter;

@Entity
@Table(name = "TB_ACL_SISTEMA", schema = "DBSCODES")
public class Sistema {

	@Id
	@Column(name = "CO_SEQ_SISTEMA")
	private Long id;

	@Column(name = "SG_SISTEMA")
	private String sigla;

	@Column(name = "DS_SISTEMA")
	private String nome;

	@Column(name = "DS_PAGINA_INICIAL")
	private String paginaInicial;

	@Column(name = "CO_TOKEN_SERVICO")
	private String token;

	@Column(name = "ST_VALIDA_USUARIO_RH")
	@Convert(converter = SimNaoConverter.class)
	private Boolean validaRH;

	@Column(name = "ST_VALIDA_DOMINIO_EMAIL_USUARI")
	@Convert(converter = SimNaoConverter.class)
	private Boolean validaDominios;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getSigla() {
		return sigla;
	}

	public void setSigla(String sigla) {
		this.sigla = sigla;
	}

	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	public String getToken() {
		return token;
	}

	public void setToken(String token) {
		this.token = token;
	}

	public Boolean getValidaRH() {
		return validaRH;
	}

	public void setValidaRH(Boolean validaRH) {
		this.validaRH = validaRH;
	}


	public String getPaginaInicial() {
		return paginaInicial;
	}

	public void setPaginaInicial(String paginaInicial) {
		this.paginaInicial = paginaInicial;
	}

	public Boolean getValidaDominios() {
		return validaDominios;
	}

	public void setValidaDominios(Boolean validaDominios) {
		this.validaDominios = validaDominios;
	}

}
