package br.gov.datasus.authorization.security.oauth2.provider;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.authentication.dao.AbstractUserDetailsAuthenticationProvider;
import org.springframework.security.core.AuthenticationException;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.stereotype.Service;

import br.gov.datasus.authorization.service.IntegracaoLoginCidadaoService;

@Service("userDetailsAuthenticationCidadaoProvider")
public class UserDetailsAuthenticationCidadaoProvider extends AbstractUserDetailsAuthenticationProvider {

	@Autowired
	private IntegracaoLoginCidadaoService integracaoLoginCidadaoService;

	@Override
	protected void additionalAuthenticationChecks(UserDetails userDetails,
			UsernamePasswordAuthenticationToken authentication) throws AuthenticationException {
	}

	@Override
	protected UserDetails retrieveUser(String username, UsernamePasswordAuthenticationToken authentication)
			throws AuthenticationException {
		return integracaoLoginCidadaoService.loadUser(authentication.getPrincipal().toString());
	}

}
