package br.gov.datasus.authorization.security.oauth2.token;

import java.util.LinkedHashMap;
import java.util.Map;

import org.springframework.security.oauth2.common.DefaultOAuth2AccessToken;
import org.springframework.security.oauth2.common.OAuth2AccessToken;
import org.springframework.security.oauth2.provider.OAuth2Authentication;
import org.springframework.security.oauth2.provider.token.store.JwtAccessTokenConverter;

public class DatasusAccessToken extends JwtAccessTokenConverter {

	private static final String ORGANIZATION_DATASUS = "DATASUS";
	private static final String KEY_ORGANIZATION = "organization";

	@Override
	public OAuth2AccessToken enhance(OAuth2AccessToken accessToken, OAuth2Authentication authentication) {
		Map<String, Object> info = new LinkedHashMap<>(accessToken.getAdditionalInformation());
		addAdditionalInformation(info);
		DefaultOAuth2AccessToken customAccessToken = new DefaultOAuth2AccessToken(accessToken);
		customAccessToken.setAdditionalInformation(info);
		return super.enhance(customAccessToken, authentication);
	}

	public void addAdditionalInformation(Map<String, Object> info) {
		info.put(KEY_ORGANIZATION, ORGANIZATION_DATASUS);
	}
}
