package br.gov.datasus.authorization.service;

import java.time.LocalDateTime;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.gov.datasus.authorization.model.scpa.Acesso;
import br.gov.datasus.authorization.repository.scpa.AcessoRepository;

@Service
public class LogAcessoScpaService {

	private static final String IP_DEFAULT = "127.0.0.1";

	private static final String SEPARADOR_IP = ":";

	private static final String AUTORIZATION_SERVER = "AUTORIZATION_SERVER";

	@Autowired
	private AcessoRepository acessoRepository;

	public void registrarLog(String ip, Long idUsuario) {
		Acesso acesso = new Acesso();
		acesso.setDateAcesso(LocalDateTime.now());

		acesso.setSiglaSistema(AUTORIZATION_SERVER);
		acesso.setIdUsuario(idUsuario);
		if (ip == null || ip.contains(SEPARADOR_IP)) {
			ip = IP_DEFAULT;
		}
		acesso.setIpAcesso(ip);
		acessoRepository.save(acesso);
	}
}
