package br.gov.datasus.scodes.configuration.properties;

import br.gov.datasus.api.core.message.IMessageProperty;
import br.gov.datasus.api.core.message.MessageSource;

public enum MessageProperty implements IMessageProperty {
    TIPO_MODELO_NAO_ENCONTRADO ("tipo-modelo-nao-encontrado"),
    TIPO_DEMANDA_NAO_ENCONTRADA ("tipo-demanda-nao-encontrada"),
    ESPECIFICACAO_NAO_ENCONTRADA ("especificacao-nao-encontrada"),
    TIPO_DEMANDA_INCOPATIVEL_COM_TIPO_MODELO ("tipo-demanda-incopativel-com-tipo-modelo"),
    TIPO_DEMANDA_NAO_ENCONTRADA_TIPO_MODELO ("tipo-demanda-nao-encontrada-tipo-modelo"),
    FILTRO_PRODUTO_OBRIGATORIO ("filtro-produto-obrigatorio"),
    FILTRO_ESPEFICICACAO_OBRIGATORIO ("filtro-espeficicacao-obrigatorio"),
    FILTRO_PRODUTO_ESPECIFICACAO_OBRIGATORIOS ("filtro-produto-especificacao-obrigatorios"),
    ERRO_AO_GERAR_NOVO_CODIGO_ITEM ("erro-ao-gerar-novo-codigo-item"),
    SENHA_ATUAL_INVALIDA ("senha-atual-invalida"),
    INVENTARIO_ATIVO_UNIDADE_DISPENSADORA("inventario-ativo-unidade-dispensadora"),
    UNIDADE_DISPENSADORA_NAO_ENCONTRADA("unidade-dispensadora-nao-encontrada"),
    QTD_SAIDA_ESTOQUE("quantidade-saida-estoque"),
    NOVA_DATA_RETORNO_NAO_PODE_SER_FERIADO ("nova-data-retorno-nao-pode-ser-feriado"),
    NOVA_DATA_RETORNO_NAO_PODE_SER_MENOR_DATA_ATUAL ("nova-data-retorno-nao-pode-ser-menor-data-atual"),
    NOVA_DATA_RETORNO_NAO_PODE_SER_MAIOR_15_DIAS ("nova-data-retorno-nao-pode-maior-15-dias"),
    NOVA_DATA_RETORNO_NAO_PODE_SER_FINAL_SEMANA ("nova-data-retorno-nao-pode-ser-final-semana"),
    NOVA_DATA_RETORNO_NAO_PODE_SER_MENOR_15_DIAS_DATA_ATUAL_RETORNO("nova-data-retorno-nao-pode-ser-menor-15-dias-data-atual-retorno"),
    NOVA_DATA_RETORNO_NAO_PODE_SER_MAIOR_15_DIAS_DATA_ATUAL_RETORNO("nova-data-retorno-nao-pode-ser-maior-15-dias-data-atual-retorno"),
    EMAIL_JA_UTILIZADO_USUARIO("email-ja-utilizado-usuario"),
    LOGIN_JA_UTILIZADO_USUARIO("login-ja-utilizado-usuario"),
    INVENTARIO_JA_CONSOLIDADO("inventario-ja-consolidado"),
    DEMANDA_OBRIGATORIO("demanda-obrigatorio"),
    PROCESSUAL_OBRIGATORIO("processual-obrigatorio"),
    TIPO_DEMANDA_OBRIGATORIO("tipo-demanda-obrigatorio"),
    UNIDADE_ORGANIZACIONAL_OBRIGATORIO("unidade-organizacional-obrigatorio"),
    AUTOR_OBRIGATORIO("autor-obrigatorio"),
    ACAO_CONTRA_OBRIGATORIO("acao-contra-obrigatorio"),
    TIPO_PROCESO_OBRIGATORIO("tipo-proceso-obrigatorio"),
    PROTOCOLO_OBRIGATORIO("protocolo-obrigatorio"),
    PROCESSO_OBRIGATORIO("processo-obrigatorio"),
    DATA_ENTRADA_OBRIGATORIO("data-entrada-obrigatorio"),
    CIDADE_OBRIGATORIO("cidade-obrigatorio"),
    UF_OBRIGATORIO("uf-obrigatorio"),
    TIPO_VARA_OBRIGATORIO("tipo-vara-obrigatorio"),
    ENDERECO_OBRIGATORIO("endereco-obrigatorio"),
    BAIRRO_OBRIGATORIO("bairro-obrigatorio"),
    FORUM_OBRIGATORIO("forum-obrigatorio"),
    DESCRICAO_OBRIGATORIO("descricao-obrigatorio"),
    DIRETORIO_OBRIGATORIO("diretorio-obrigatorio"),
    DATA_PROTOCOLO_OBRIGATORIO("protocolo-obrigatorio"),
    ARQUIVO_OBRIGATORIO("arquivo-obrigatorio"),
    STATUS_OBRIGATORIO("status-obrigatorio"),
    NOME_OBRIGATORIO("nome-obrigatorio"),
    VARA_OBRIGATORIO("vara-obrigatorio"),
    SEGREDO_OBRIGATORIO("segredo-obrigatorio"),
    PRAZO_OBRIGATORIO("prazo-obrigatorio"),
    TIPO_PROFISSAO_OBRIGATORIO("tipo-profissao-obrigatorio"),
    PRODUTO_EXCLUSAO_VINCULO("produto-exclusao-vinculo"),
    ESPECIFICACAO_EXCLUSAO_VINCULO("especificacao-exclusao-vinculo"),
    ITEM_EXCLUSAO_VINCULO("item-exclusao-vinculo"),
    PROTOCOLO_PROCESSO_UNIDADE_ORGANIZACIONAL_JA_EXISTE("protocolo-processo-unidade-organizacional-ja-existe");

    private String[] args = {};

    private String key;

    private MessageProperty(String key) {
        this.key = key;
    }

    public String key() {
        return key;
    }

    public String message() {
        return MessageSource.get().message(key, args);
    }

    public IMessageProperty bind(String... args) {
        this.args = args;
        return this;
    }
}
