package br.gov.datasus.scodes.controller;

import br.gov.datasus.scodes.model.dto.AlteracaoDataRetornoDTO;
import br.gov.datasus.scodes.model.dto.AlteracaoDataRetornoProdutoDTO;
import br.gov.datasus.scodes.service.AlteracaoDataRetornoProdutoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Api(tags = "AlteracaoDataRetornoProduto")
@RequestMapping(value = "/alteracao-data-retorno-produto")
@RequiredArgsConstructor
@RestController
public class AlteracaoDataRetornoProdutoController {

    private final AlteracaoDataRetornoProdutoService service;

    @ApiOperation(value = "Obter alteracao-data-retorno-produto por código alteracao-data-retorno")
    @GetMapping(value = "/alteracao-data-retorno/{id}", produces = MediaType.APPLICATION_JSON_VALUE)
    public ResponseEntity<AlteracaoDataRetornoProdutoDTO> obterAlteracaoDataRetornoPorId(@PathVariable Long id) {
        return ResponseEntity.ok(service.obterAlteracaoDataRetornoPorId(id));
    }
}
