package br.gov.datasus.scodes.controller;

import br.gov.datasus.scodes.model.dto.FeriadoDTO;
import br.gov.datasus.scodes.service.FeriadoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Api(tags = "Feriado")
@RequestMapping(value = "/feriado")
@RequiredArgsConstructor
@RestController
public class FeriadoController {

    private final FeriadoService service;

    @ApiOperation(value = "Obter feriado por data do feriado")
    @GetMapping(value = "/{date}", produces = MediaType.APPLICATION_JSON_VALUE)
    public ResponseEntity<FeriadoDTO> obterPorDataFeriado(@PathVariable(name = "date") String date) {
        return ResponseEntity.ok(service.buscarPorDataFeriado(date));
    }


    @ApiOperation(value = "Obter todos feriados")
    @GetMapping(produces = MediaType.APPLICATION_JSON_VALUE)
    public ResponseEntity<List<FeriadoDTO>> obterTodos() {
        List<FeriadoDTO> lista = service.obterTodos();
        return ResponseEntity.ok(lista);
    }

}
