package br.gov.datasus.scodes.controller;

import java.util.List;

import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import br.gov.datasus.scodes.model.dto.TipoVaraDTO;
import br.gov.datasus.scodes.service.TipoVaraService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;

@Api(tags = "TipoVara")
@RequestMapping(value = "/tipo-vara")
@RequiredArgsConstructor
@RestController
public class TipoVaraController {

    private final TipoVaraService service;

    @ApiOperation(value = "Obter tipo-vara por código")
    @GetMapping(value = "/{id}", produces = MediaType.APPLICATION_JSON_VALUE)
    public ResponseEntity<TipoVaraDTO> obterPorId(@PathVariable(name = "id") Long id) {
        return ResponseEntity.ok(service.obterPorId(id));
    }

    @ApiOperation(value = "Obter todos tipo-varas")
    @GetMapping(value = "/todas", produces = MediaType.APPLICATION_JSON_VALUE)
    public ResponseEntity<List<TipoVaraDTO>> obterTodos() {
        List<TipoVaraDTO> lista = service.obterTodos();
        return ResponseEntity.ok(lista);
    }

}

