package br.gov.datasus.scodes.model.converter;

import java.util.Optional;

import javax.persistence.AttributeConverter;
import javax.persistence.Converter;

import br.gov.datasus.scodes.model.enums.TipoAcaoContraEnum;

@Converter
public class TipoAcaoContraEnumConverter implements AttributeConverter<TipoAcaoContraEnum, String>,
    org.springframework.core.convert.converter.Converter<String, TipoAcaoContraEnum> {

    @Override
    public String convertToDatabaseColumn(TipoAcaoContraEnum attribute) {
        return Optional.ofNullable(attribute)
            .map(TipoAcaoContraEnum::getId)
            .orElse(null);
    }

    @Override
    public TipoAcaoContraEnum convertToEntityAttribute(String dbData) {
        return Optional.ofNullable(dbData)
            .flatMap(TipoAcaoContraEnum::obterPorId)
            .orElse(null);
    }

    @Override
    public TipoAcaoContraEnum convert(String source) {
        return TipoAcaoContraEnum.obterPorId(source).orElse(null);
    }
}
