package br.gov.datasus.scodes.model.converter;

import br.gov.datasus.scodes.model.enums.TipoMovimentacaoTipoEnum;

import javax.persistence.AttributeConverter;
import javax.persistence.Converter;
import java.util.Optional;

@Converter
public class TipoMovimentacaoTipoEnumConverter implements AttributeConverter<TipoMovimentacaoTipoEnum, String>,
    org.springframework.core.convert.converter.Converter<String, TipoMovimentacaoTipoEnum> {

    @Override
    public String convertToDatabaseColumn(TipoMovimentacaoTipoEnum attribute) {
        return Optional.ofNullable(attribute)
            .map(TipoMovimentacaoTipoEnum::getCodigo)
            .orElse(null);
    }

    @Override
    public TipoMovimentacaoTipoEnum convertToEntityAttribute(String dbData) {
        return Optional.ofNullable(dbData)
            .flatMap(TipoMovimentacaoTipoEnum::obterPorCodigo)
            .orElse(null);
    }

    @Override
    public TipoMovimentacaoTipoEnum convert(String source) {
        return TipoMovimentacaoTipoEnum.obterPorCodigo(source).orElse(null);
    }
}
