package br.gov.datasus.scodes.model.converter;

import java.util.Optional;

import javax.persistence.AttributeConverter;
import javax.persistence.Converter;

import br.gov.datasus.scodes.model.enums.TipoSexoEnum;

@Converter
public class TipoSexoEnumConverter implements AttributeConverter<TipoSexoEnum, String>,
    org.springframework.core.convert.converter.Converter<String, TipoSexoEnum> {

    @Override
    public String convertToDatabaseColumn(TipoSexoEnum attribute) {
        return Optional.ofNullable(attribute)
            .map(TipoSexoEnum::getCodigo)
            .orElse(null);
    }

    @Override
    public TipoSexoEnum convertToEntityAttribute(String dbData) {
        return Optional.ofNullable(dbData)
            .flatMap(TipoSexoEnum::obterPorCodigo)
            .orElse(null);
    }

    @Override
    public TipoSexoEnum convert(String source) {
        return TipoSexoEnum.obterPorCodigo(source).orElse(null);
    }
}
