package br.gov.datasus.scodes.model.converter;

import br.gov.datasus.scodes.model.enums.TipoTransferenciaEnum;

import javax.persistence.AttributeConverter;
import javax.persistence.Converter;
import java.util.Optional;

@Converter
public class TipoTransferenciaEnumConverter implements AttributeConverter<TipoTransferenciaEnum, Integer>,
    org.springframework.core.convert.converter.Converter<Integer, TipoTransferenciaEnum> {

    @Override
    public Integer convertToDatabaseColumn(TipoTransferenciaEnum attribute) {
        return Optional.ofNullable(attribute)
            .map(TipoTransferenciaEnum::getCodigo)
            .orElse(null);
    }

    @Override
    public TipoTransferenciaEnum convertToEntityAttribute(Integer dbData) {
        return Optional.ofNullable(dbData)
            .flatMap(TipoTransferenciaEnum::obterPorCodigo)
            .orElse(null);
    }

    @Override
    public TipoTransferenciaEnum convert(Integer source) {
        return TipoTransferenciaEnum.obterPorCodigo(source).orElse(null);
    }
}
