package br.gov.datasus.scodes.model.dto;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.io.Serializable;
import java.util.Date;

@Getter
@Setter
@NoArgsConstructor
public class FeriadoDTO implements Serializable  {

    private static final long serialVersionUID = 1L;

    private Long id;

    @DateTimeFormat(iso = DateTimeFormat.ISO.DATE)
    private Date dataFeriado;

    @NotNull
    @Size(max = 45)
    private String diaSemana;

    @NotNull
    @Size(max = 250)
    private String descricao;

    @NotNull
    @Size(max = 2)
    private String siglaEstado;

    @NotNull
    @Size(max = 2)
    private String tipo;

    @NotNull
    private UnidadeDispensadoraDTO unidadeDispensadora;
}
