package br.gov.datasus.scodes.model.dto;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.Date;

@Getter
@Setter
@NoArgsConstructor
public class InventarioItemDTO implements Serializable {
    private static final long serialVersionUID = 1L;

    @NotNull
    private Long idInventario;

    @NotNull
    private Long idItem;

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private String codigoItem;

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private String descricaoItem;

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private String unidadeMedida;

    private Long id;

    @NotNull
    private Long quantidadeFisica;

    @NotNull
    @DateTimeFormat(iso = DateTimeFormat.ISO.DATE_TIME)
    private Date dataContagem;
}

