package br.gov.datasus.scodes.model.dto;

import java.io.Serializable;
import java.util.Date;

import javax.validation.constraints.NotNull;

import org.springframework.format.annotation.DateTimeFormat;

import br.gov.datasus.scodes.model.enums.TipoAcaoContraEnum;
import br.gov.datasus.scodes.model.enums.TipoStatusProcessualEnum;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
public class ProcessualDTO implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long id;

    @NotNull
    private Boolean segredo;

    @NotNull
    private TipoAcaoContraEnum tipoAcaoContra;

    @NotNull
    private PrazoDTO prazo;

    @NotNull
    private VaraDTO vara;

    private AutorDemandaDTO autorDemanda;

    // TODO: verificar set default value ao criar o processual pela demanda
    // @NotNull
    private TipoStatusProcessualEnum status;

    private Boolean docCompleta;

    @DateTimeFormat(iso = DateTimeFormat.ISO.DATE_TIME)
    private Date dataNaoCobrancaJud;

    private ProfissionalDTO profissional;

    @NotNull
    private TipoProfissaoDTO tipoProfissao;

    private TipoAcaoDTO tipoAcao;

    // TODO: verificar como associar cidade no legado
    private CidadeDTO cidade;

}
