package br.gov.datasus.scodes.model.dto;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.validation.Valid;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

@Getter
@Setter
@NoArgsConstructor
public class SaidaEstoqueDTO implements Serializable {

    private static final long serialVersionUID = 1L;
    
	private Long id;

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
	private Date dataSaida;

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private Long idUsuario;

    @NotNull
    private TipoMovimentacaoDTO tipoMovimentacao;

    @Valid
    private CompraTrocaDTO compraTroca;

    @Valid
    private TransferenciaDTO transferencia;

    @Size(max = 200)
    private String motivo;

    @Valid
    @NotEmpty
    private List<SaidaEstoqueItemDTO> itens;
}
