package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import br.gov.datasus.scodes.model.constants.AlteracaoDataRetornoConstants;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;
import java.time.LocalDate;
import java.util.Date;
import java.util.Set;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_ALTERACAO_DATA_RETORNO", schema = "DBSCODES")
@NamedQueries({
    @NamedQuery(
        name = AlteracaoDataRetornoConstants.QUERYNAME.OBTER_TODOS_PAGINADO,
        query = AlteracaoDataRetornoConstants.QUERIES.OBTER_TODOS_PAGINADO
    )
})
public class AlteracaoDataRetorno extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_ALTERACAO_DATA_RETORNO")
    @SequenceGenerator(name = "SEQ_GENERATOR_ALTERACAO_DATA_RETORNO", sequenceName = "SQ_ALTERADTRET_COSEQALTERDTRET", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_ALTERACAO_DATA_RETORNO")
    private Long id;

    @Column(name = "DT_CADASTRO", nullable = false)
    @Temporal(TemporalType.DATE)
    private Date dataCadastro;

    @Column(name = "DT_NOVA_DATA_RETORNO", nullable = false)
    @Temporal(TemporalType.DATE)
    private Date novaDataRetorno;

    @Column(name = "NO_TITULO", length = 100)
    private String titulo;

    @ManyToOne
    @JoinColumn(name = "CO_STATUS_ALTDTRET")
    private StatusAlteracaoDataRetorno status;

}
