package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;
import java.util.Date;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_ALTERACAO_DATA_RETORNO_PRODUTO", schema = "DBSCODES")
@NamedQueries({
    @NamedQuery(name = AlteracaoDataRetornoProduto.OBTER_TODOS_PAGINADO, query = "SELECT adrp FROM AlteracaoDataRetornoProduto adrp")
})
public class AlteracaoDataRetornoProduto  extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "AlteracaoDataRetornoProduto.obterTodosPaginado";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_ALT_DT_RETORNO_PRODUTO")
    @SequenceGenerator(name = "SEQ_GENERATOR_ALT_DT_RETORNO_PRODUTO", sequenceName = "SQ_ALTDTRETPROD_COSQALTDTRETPROD", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_ALT_DT_RETORNO_PRODUTO")
    private Long id;

    @Column(name = "DT_RETORNO_ANTERIOR", nullable = false)
    @Temporal(TemporalType.DATE)
    private Date dataRetornoAnterior;

    @Column(name = "CO_RECIBO_ORDEM_PRODUTO")
    private Long codigoReciboOrdemProduto;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_ALTERACAO_DATA_RETORNO")
    private AlteracaoDataRetorno alteracaoDataRetorno;

}
