package br.gov.datasus.scodes.model.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_APRESENTACAO", schema = "DBSCODES")
@NamedQuery(name = Apresentacao.OBTER_TODOS_PAGINADO, query = "SELECT apresentacao FROM Apresentacao apresentacao")
@NamedQuery(name = Apresentacao.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(apresentacao.id, apresentacao.nome) FROM Apresentacao apresentacao")
public class Apresentacao extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "Apresentacao.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "Apresentacao.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "CO_SEQ_APRESENTACAO")
    private Long id;

    @Column(name = "NO_APRESENTACAO", length = 50)
    private String nome;

}
