package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import br.gov.datasus.scodes.model.entity.Id.EstoqueAuxiliarId;
import lombok.AccessLevel;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;
import java.util.Date;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_ESTOQUE_AUXILIAR", schema = "DBSCODES")
public class EstoqueAuxiliar extends BaseEntity<EstoqueAuxiliarId> {

    private static final long serialVersionUID = 1L;

    @EmbeddedId
    private EstoqueAuxiliarId id;

    @Column(name = "QT_ITEM", nullable = false)
    private Long quantidadeItem;

    @Column(name = "DT_ATUALIZACAO", nullable = false)
    @Temporal(TemporalType.TIMESTAMP)
    @Setter(AccessLevel.NONE)
    private Date dataAtualizacao;

    @PrePersist
    public void prePersist() {
        this.dataAtualizacao = new Date();
    }

    @PreUpdate
    public void preUpdate() {
        this.dataAtualizacao = new Date();
    }
}
