package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;
import java.util.Date;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_FERIADO", schema = "DBSCODES")
public class Feriado  extends BaseEntity<Long>  {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_FERIADO")
    @SequenceGenerator(name = "SEQ_GENERATOR_FERIADO", sequenceName = "SQ_FERIADO_COSEQFERIADO", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_FERIADO", nullable = false)
    private Long id;

    @Column(name = "DT_DATA_FERIADO", nullable = false)
    @Temporal(TemporalType.DATE)
    private Date dataFeriado;

    @Column(name = "NO_DIA_SEMANA", length = 45)
    private String diaSemana;

    @Column(name = "DS_DESCRICAO", length = 250)
    private String descricao;

    @Column(name = "TP_FERIADO", length = 1)
    private String tipoFeriado;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_UF")
    private Uf uf;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_UNIDADE_DISPENSADORA")
    private UnidadeDispensadora unidadeDispensadora;

}


