package br.gov.datasus.scodes.model.entity;

import javax.persistence.*;

import br.gov.datasus.api.core.model.entity.BaseEntity;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_FUNCIONALIDADE", schema = "DBSCODES")
@NamedQueries({
    @NamedQuery(name = Funcionalidade.OBTER_TODOS_PAGINADO, query = "SELECT f FROM Funcionalidade f WHERE 1=1"
    		+ " AND (UPPER(f.nome) LIKE UPPER(:nome))"),
    @NamedQuery(name = Funcionalidade.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(f.id, f.nome) FROM Funcionalidade f")
})
public class Funcionalidade extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    
    public static final String OBTER_TODOS_PAGINADO = "Funcionalidade.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "Funcionalidade.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_FUNCIONALIDADE")
    @SequenceGenerator(name = "SEQ_GENERATOR_FUNCIONALIDADE", sequenceName = "SQ_FUNCIONALIDADE_COSEQFUNCIONALIDADE", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_FUNCIONALIDADE", nullable = false)
    private Long id;

    @Column(name = "CO_FUNCIONALIDADE_PAI")
    private Long idPai;

    @Column(name = "NO_FUNCIONALIDADE", length = 40, nullable = false)
    private String nome;

    @Column(name = "ST_ALTERAR", nullable = false)
    private Boolean situacaoAlterar;

    @Column(name = "ST_CRIAR", nullable = false)
    private Boolean situacaoCriar;

    @Column(name = "ST_EXCLUIR", nullable = false)
    private Boolean situacaoExcluir;

    @Column(name = "ST_IMPRIMIR", nullable = false)
    private Boolean situacaoImprimir;

    @Column(name = "ST_PESQUISAR", nullable = false)
    private Boolean situacaoPesquisar;

}
