package br.gov.datasus.scodes.model.entity.Id;

import java.io.Serializable;
import java.util.Objects;

import javax.persistence.*;

import br.gov.datasus.scodes.model.entity.Funcionalidade;
import br.gov.datasus.scodes.model.entity.Perfil;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor(staticName = "of")
@Embeddable
public class PerfilFuncionalidadeId implements Serializable {
	
	private static final long serialVersionUID = 1L;

	@ManyToOne
	@JoinColumn(name = "CO_PERFIL", nullable = false)
	private Perfil perfil;
	
	@ManyToOne
	@JoinColumn(name = "CO_FUNCIONALIDADE", nullable = false)
	private Funcionalidade funcionalidade;

	@Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof PerfilFuncionalidadeId)) return false;
        PerfilFuncionalidadeId that = (PerfilFuncionalidadeId) o;
        return this.getPerfil().equals(that.getPerfil()) && 
            this.getFuncionalidade().equals(that.getFuncionalidade());
    }
	
	@Override
	public int hashCode() {
		return Objects.hash(this.getPerfil(), this.getFuncionalidade());
	}
	
}
