package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_NATUREZA_DESPESA", schema = "DBSCODES")
@NamedQueries({
    @NamedQuery(name = NaturezaDespesa.OBTER_TODOS_PAGINADO, query = "SELECT nd FROM NaturezaDespesa nd WHERE 1=1"
        + " AND (nd.numero =:numero)"
        + " AND (UPPER(nd.descricao) LIKE UPPER(:descricao))"),
    @NamedQuery(
        name = NaturezaDespesa.OBTER_DOMINIO,
        query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel("
            + "    naturezaDespesa.id, "
            + "    naturezaDespesa.numero || ' - ' || naturezaDespesa.descricao "
            + ") FROM NaturezaDespesa naturezaDespesa"
    )
})
public class NaturezaDespesa extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "NaturezaDespesa.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "NaturezaDespesa.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_NATUREZA_DESPESA")
    @SequenceGenerator(name = "SEQ_GENERATOR_NATUREZA_DESPESA", sequenceName = "SQ_NATDESPESA_COSEQNATUDESPESA", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_NATUREZA_DESPESA")
    private Long id;

    @Column(name = "DS_NATUREZA_DESPESA", length = 800)
    private String descricao;

    @Column(name = "NU_NATUREZA_DESPESA")
    private Long numero;

}
