package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;
import java.util.Date;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_ORDEM_PRODUTO", schema = "DBSCODES")
public class OrdemProduto extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_ORDEM_PRODUTO")
    @SequenceGenerator(name = "SEQ_ORDEM_PRODUTO", sequenceName = "SQ_ORDEMPRODUTO_COSEQORDEMPRODUTO", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_ORDEM_PRODUTO", nullable = false)
    private Long id;

    @Column(name = "DT_DATA_ENTRADA_PRODUTO", nullable = false)
    @Temporal(TemporalType.DATE)
    private Date dataEntradaProduto;

    @Column(name = "QT_PRODUTO", length = 22)
    private Long quantidadeProduto;

    @Column(name = "NU_RETORNO", length = 22)
    private Long numeroRetorno;

    @Column(name = "NU_PRAZO", length = 22)
    private Long numeroPrazo;

    @Column(name = "NU_PERIODICIDADE", length = 22)
    private Long numeroPeriodicidade;

    @Column(name = "ST_IRREGULAR", length = 1)
    private String statusIrregular;

    @Column(name = "QT_PRAZO", length = 22)
    private Long quantidadePrazo;

    @Column(name = "ST_HABILITA_IMPORTADO", length = 1)
    private String statusHabilitaImportado;

    @Column(name = "ST_ATIVO", length = 1)
    private String statusAtivo;

    @Column(name = "DT_DATA_FIM", nullable = false)
    @Temporal(TemporalType.DATE)
    private Date dataFim;

    @Column(name = "NU_ATIVO_ATUAL", length = 22)
    private Long numeroAtivoAtual;

    @Column(name = "NU_CONCLUIDO", length = 22)
    private Long numeroConcluido;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_ORDEM_DISPENSACAO")
    private OrdemDispensacao ordemDispensacao;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_PRODUTO")
    private Produto produto;

}
