package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import br.gov.datasus.scodes.model.converter.TipoPlanoSaudeEnumConverter;
import br.gov.datasus.scodes.model.enums.TipoPlanoSaudeEnum;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_PLANO_SAUDE", schema = "DBSCODES")
@NamedQueries({
    @NamedQuery(name = PlanoSaude.OBTER_TODOS_PAGINADO, query = "SELECT planoSaude FROM PlanoSaude planoSaude WHERE 1=1 " +
        "AND (UPPER(planoSaude.descricao) LIKE UPPER(:descricao))" +
        "AND (planoSaude.tipo = :tipo)")
   ,@NamedQuery(name = PlanoSaude.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(planoSaude.id, planoSaude.descricao) FROM PlanoSaude planoSaude")
})
public class PlanoSaude extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "PlanoSaude.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "PlanoSaude.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_PLANO_SAUDE")
    @SequenceGenerator(name = "SEQ_GENERATOR_PLANO_SAUDE", sequenceName = "SQ_TIPOACAO_COSEQTIPOACAO", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_PLANO_SAUDE")
    private Long id;

    @Column(name = "DS_PLANO_SAUDE", length = 50)
    private String descricao;

    @Convert(converter = TipoPlanoSaudeEnumConverter.class)
    @Column(name = "TP_PLANO_SAUDE", length = 1)
    private TipoPlanoSaudeEnum tipo;

}
