package br.gov.datasus.scodes.model.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_PRAZO", schema = "DBSCODES")
public class Prazo extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_PRAZO")
    @SequenceGenerator(name = "SEQ_GENERATOR_PRAZO", sequenceName = "SQ_COSEQPRAZO", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_PRAZO", nullable = false)
    private Long id;
    
    @Column(name = "DS_DESCRICAO", length = 20, nullable = false)
    private String descricao;
    
    @Column(name = "NU_QTD_HRS", nullable = false)
    private Integer qtdHoras;
    
    @Column(name = "TP_URGENTE", nullable = false)
    private Boolean urgente;
    
}
