package br.gov.datasus.scodes.model.entity;

import javax.persistence.*;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_PROFISSIONAL", schema = "DBSCODES")
@NamedQueries({
    @NamedQuery(
        name = Profissional.OBTER_TODOS_PAGINADO,
        query = ""
            + " SELECT profissional FROM Profissional profissional WHERE 1 = 1"
            + " AND (UPPER(profissional.nome) LIKE UPPER(:nome)) "
            + " AND (UPPER(profissional.conselho) = UPPER(:conselho)) "
            + " AND (UPPER(profissional.email) = UPPER(:email)) "
            + " AND (profissional.tipoProfissao.id = :tipoProfissaoId) "
            + " AND (profissional.uf.id = :ufId) "
    ),
    @NamedQuery(
        name = Profissional.PESQUISAR_PATRONO,
        query = ""
            + " SELECT profissional FROM Profissional profissional WHERE 1 = 1"
            + " AND (UPPER(profissional.uf.id) = UPPER(:ufId)) "
            + " AND (profissional.tipoProfissao.id = :tipoProfissaoId) "
            + " AND (UPPER(profissional.nome) LIKE UPPER(:nome)) "
            + " AND (UPPER(profissional.conselho) LIKE UPPER(:conselho)) "
    )
})


public class Profissional extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "Profissional.obterTodosPaginado";
    public static final String PESQUISAR_PATRONO = "Profissional.pesquisarPatrono";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_PROFISSIONAL")
    @SequenceGenerator(name = "SEQ_GENERATOR_PROFISSIONAL", sequenceName = "SQ_PROFISSIONAL_COSEQPROFISSIONAL", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_PROFISSIONAL", nullable = false)
    private Long id;

    @Column(name = "TP_STATUS", nullable = false)
    private Boolean status;

    @Column(name = "NO_NOME", length = 80, nullable = false)
    private String nome;

    @ManyToOne
    @JoinColumn(name = "CO_TIPO_PROFISSAO", nullable = false)
    private TipoProfissao tipoProfissao;

    @ManyToOne
    @JoinColumn(name = "SG_UF", nullable = false)
    private Uf uf;

    @Column(name = "DS_CAMARA", length = 50)
    private String camara;

    @Column(name = "NU_CONSELHO", length = 15)
    private String conselho;

    @Column(name = "DS_MOTIVO", length = 100)
    private String motivo;

    @Column(name = "DS_TITULO", length = 50)
    private String titulo;

    @Column(name = "DS_EMAIL", length = 100)
    private String email;

}
