package br.gov.datasus.scodes.model.entity;

import javax.persistence.Entity;
import javax.persistence.GenerationType;
import javax.persistence.Column;
import javax.persistence.Table;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.Setter;
import lombok.NoArgsConstructor;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_PROGRAMA", schema = "DBSCODES")
@NamedQueries({
    @NamedQuery(name = Programa.OBTER_TODOS_PAGINADO, query = "SELECT programa FROM Programa programa")
   ,@NamedQuery(name = Programa.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(programa.id, programa.nome) FROM Programa programa")
})
public class Programa extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "Programa.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "Programa.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "CO_SEQ_PROGRAMA")
    private Long id;

    @Column(name = "NO_PROGRAMA", length = 50)
    private String nome;

}
