package br.gov.datasus.scodes.model.entity;


import br.gov.datasus.api.core.model.entity.BaseEntity;
import br.gov.datasus.scodes.model.entity.Id.ProtocoloJefazId;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@IdClass(ProtocoloJefazId.class)
@Table(name = "TB_PROTOCOLO_JEFAZ", schema = "DBSCODES")
public class ProtocoloJefaz extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_PROTOCOLO_JEFAZ")
    @SequenceGenerator(name = "SEQ_GENERATOR_PROTOCOLO_JEFAZ", sequenceName = "SQ_PROJEF_COSQPROJEF", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_PROTOCOLO_JEFAZ", nullable = false)
    private Long id;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_PROTOCOLO_JEFAZ_COUNT")
    @SequenceGenerator(name = "SEQ_GENERATOR_PROTOCOLO_JEFAZ_COUNT", sequenceName = "SQ_PROJEFCOUNT_COSQPROJEFCOUNT", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_PROTOCOLO_JEFAZ_COUNT", nullable = false)
    private Long contador;

    @Column(name = "NU_ANO", length = 4)
    private String ano;

    @Column(name = "NO_LOGIN_USUARIO", length = 50)
    private String loginUsuario;

    @Column(name = "CO_UNIDADE_ORGANIZACIONAL")
    private Long codigoUnidadeOrganizacional;
}
