package br.gov.datasus.scodes.model.entity;

import javax.persistence.*;

import br.gov.datasus.api.core.model.entity.BaseEntity;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_STATUS", schema = "DBSCODES")
public class Status extends BaseEntity<Long> {

	private static final long serialVersionUID = 1L;
	
	@Id
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_STATUS")
	@SequenceGenerator(name = "SEQ_GENERATOR_STATUS", sequenceName = "SQ_STATUS_COSEQSTATUS", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
	@Column(name = "CO_SEQ_STATUS", nullable = false)
	private Long id;

	@Column(name = "DS_DESCRICAO", length = 80)
	private String descricao;

	@Column(name = "NU_ORDEM")
	private Integer ordem;
	
	@Column(name = "NU_CLASSIFICACAO")
	private Integer classificacao;
	
}
