package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_TIPO_COBRANCA", schema = "DBSCODES")
@NamedQueries({
    @NamedQuery(name = TipoCobranca.OBTER_TODOS_PAGINADO, query = "SELECT tipoCobranca FROM TipoCobranca tipoCobranca WHERE 1=1 " +
        "AND (UPPER(tipoCobranca.descricao) LIKE UPPER(:descricao))")
   ,@NamedQuery(name = TipoCobranca.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(tipoCobranca.id, tipoCobranca.descricao) FROM TipoCobranca tipoCobranca")
})
public class TipoCobranca extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "TipoCobranca.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "TipoCobranca.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_TIPO_COBRANCA")
    @SequenceGenerator(name = "SEQ_GENERATOR_TIPO_COBRANCA", sequenceName = "SQ_TPCOBRANCA_COSEQTPCOBRANCA", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_TIPO_COBRANCA")
    private Long id;

    @Column(name = "DS_TIPO_COBRANCA", length = 50)
    private String descricao;

    @Column(name = "ST_ATIVO")
    private Boolean situacaoAtivo;

}
