package br.gov.datasus.scodes.model.entity;

import javax.persistence.Entity;
import javax.persistence.GenerationType;
import javax.persistence.Column;
import javax.persistence.Table;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.Setter;
import lombok.NoArgsConstructor;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_TIPO_CONTROLADO", schema = "DBSCODES")
@NamedQueries({
    @NamedQuery(name = TipoControlado.OBTER_TODOS_PAGINADO, query = "SELECT tipoControlado FROM TipoControlado tipoControlado")
   ,@NamedQuery(name = TipoControlado.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(tipoControlado.id, tipoControlado.nome) FROM TipoControlado tipoControlado")
})
public class TipoControlado extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "TipoControlado.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "TipoControlado.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "CO_SEQ_TIPO_CONTROLADO")
    private Long id;

    @Column(name = "NO_TIPO_CONTROLADO", length = 50)
    private String nome;

}
