package br.gov.datasus.scodes.model.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_TIPO_DISPENSACAO", schema = "DBSCODES")
@NamedQuery(name = TipoDispensacao.OBTER_TODOS_PAGINADO, query = "SELECT tipoDispensacao FROM TipoDispensacao tipoDispensacao")
@NamedQuery(name = TipoDispensacao.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(tipoDispensacao.id, tipoDispensacao.nome) FROM TipoDispensacao tipoDispensacao")
public class TipoDispensacao extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "TipoDispensacao.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "TipoDispensacao.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "CO_SEQ_TIPO_DISPENSACAO")
    private Long id;

    @Column(name = "NO_TIPO_DISPENSACAO", length = 50)
    private String nome;

}
