package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_TIPO_DOCUMENTO", schema = "DBSCODES")
@NamedQueries({
    @NamedQuery(name = TipoDocumento.OBTER_TODOS_PAGINADO, query = "SELECT tipoDocumento FROM TipoDocumento tipoDocumento WHERE 1=1"
        + " AND (UPPER(tipoDocumento.descricao) LIKE UPPER(:descricao))")
   ,@NamedQuery(name = TipoDocumento.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(tipoDocumento.id, '') FROM TipoDocumento tipoDocumento")
})
public class TipoDocumento extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "TipoDocumento.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "TipoDocumento.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_TIPO_DOCUMENTO")
    @SequenceGenerator(name = "SEQ_GENERATOR_TIPO_DOCUMENTO", sequenceName = "SQ_TIPODOC_COSEQTIPODOC", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_TIPO_DOCUMENTO")
    private Long id;

    @Column(name = "DS_TIPO_DOCUMENTO", length = 50)
    private String descricao;

}
