package br.gov.datasus.scodes.model.entity;

import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.NamedQuery;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_TIPO_MODELO", schema = "DBSCODES")
@NamedQuery(
    name = TipoModelo.OBTER_TODOS_PAGINADO,
    query = "SELECT tipoModelo FROM TipoModelo tipoModelo"
)
@NamedQuery(
    name = TipoModelo.OBTER_DOMINIO,
    query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(tipoModelo.id, tipoModelo.descricao) FROM TipoModelo tipoModelo"
)
public class TipoModelo extends BaseEntity<Long> {

    private static final long serialVersionUID = 1l;
    public static final String OBTER_TODOS_PAGINADO = "TipoModelo.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "TipoModelo.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_TIPO_MODELO")
    @SequenceGenerator(name = "SEQ_GENERATOR_TIPO_MODELO", sequenceName = "SQ_TIPOMODELO_COSEQTIPOMODELO", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_TIPO_MODELO")
    private Long id;

    @Column(name = "DS_TIPO_MODELO", length = 50)
    private String descricao;

    @ManyToMany
    @JoinTable(
        name = "RL_TIPO_DEMANDA_TIPO_MODELO",
        schema = "DBSCODES",
        joinColumns = @JoinColumn(name = "CO_TIPO_MODELO"),
        inverseJoinColumns = @JoinColumn(name = "CO_TIPO_DEMANDA")
    )
    private Set<TipoDemanda> tipoDemandas;

}
