package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_TIPO_PROFISSAO", schema = "DBSCODES")
@NamedQueries({
    @NamedQuery(name = TipoProfissao.OBTER_TODOS_PAGINADO, query = "SELECT tipoProfissao FROM TipoProfissao tipoProfissao")
   ,@NamedQuery(name = TipoProfissao.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(tipoProfissao.id, tipoProfissao.descricao) FROM TipoProfissao tipoProfissao")
})
public class TipoProfissao extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "TipoProfissao.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "TipoProfissao.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_TIPO_PROFISSAO")
    @SequenceGenerator(name = "SEQ_GENERATOR_TIPO_PROFISSAO", sequenceName = "SQ_TIPOPROFISSAO_COSEQTIPOPROF", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_TIPO_PROFISSAO")
    private Long id;

    @Column(name = "DS_CONSELHO", length = 10)
    private String descricaoConselho;

    @Column(name = "DS_TIPO_PROFISSAO", length = 50)
    private String descricao;

}
