package br.gov.datasus.scodes.model.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQuery;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_TIPO_VARA", schema = "DBSCODES")
@NamedQuery(
    name = TipoVara.OBTER_TODOS_PAGINADO,
    query = "SELECT tipoVara FROM TipoVara tipoVara"
)
@NamedQuery(
    name = TipoVara.OBTER_DOMINIO,
    query = "SELECT  tipoVara FROM TipoVara tipoVara"
)
public class TipoVara extends BaseEntity<Long> {

    private static final long serialVersionUID = 1l;
    public static final String OBTER_TODOS_PAGINADO = "TipoVara.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "TipoVara.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_TIPO_VARA")
    @SequenceGenerator(name = "SEQ_GENERATOR_TIPO_Vara", sequenceName = "SQ_TIPOVARA_COSEQTIPOVARA", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_TIPO_VARA")
    private Long id;

    @Column(name = "DS_DESCRICAO", length = 80)
    private String descricao;

}
