package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import br.gov.datasus.scodes.model.converter.TipoTransferenciaEnumConverter;
import br.gov.datasus.scodes.model.enums.TipoTransferenciaEnum;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_TRANSFERENCIA", schema = "DBSCODES")
public class Transferencia extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_TRANSFERENCIA")
    @SequenceGenerator(name = "SEQ_GENERATOR_TRANSFERENCIA", sequenceName = "SQ_TRANSF_COSEQTRANSFERENCIA", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_TRANSFERENCIA", nullable = false)
    private Long id;

    @Column(name = "DS_TRANSFERENCIA", length = 30, nullable = false)
    private String descricao;

    @Convert(converter = TipoTransferenciaEnumConverter.class)
    @Column(name = "TP_TRANSFERENCIA", nullable = false)
    private TipoTransferenciaEnum tipo;

    @ManyToOne
    @JoinColumn(name = "CO_UNIDADE_TRANSFERENCIA", nullable = false)
    private UnidadeTransferencia unidadeTransferencia;
}
