package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_UF", schema = "DBSCODES")
@NamedQueries({
    @NamedQuery(name = Uf.OBTER_TODOS_PAGINADO, query = "SELECT uf FROM Uf uf")
   ,@NamedQuery(name = Uf.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(uf.id, uf.descricao) FROM Uf uf")
})
public class Uf extends BaseEntity<String> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "Uf.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "Uf.obterDominio";

    @Id
    @Column(name = "SG_UF", length = 2)
    private String id;

    @Column(name = "DS_UF", length = 50)
    private String descricao;

}
