package br.gov.datasus.scodes.model.enums;

import javax.validation.constraints.NotNull;

import com.fasterxml.jackson.annotation.JsonValue;

import lombok.Getter;

public enum TipoDocumentoEnum {
    
    CPF (1, "CPF"),
    RG (2, "RG"),
    CNS (3, "CNS");
    
    private TipoDocumentoEnum(Integer id, String descricao) {
        this.id = id;
        this.descricao = descricao;
    }

    @JsonValue
    @Getter
    private Integer id;

    @Getter
    private String descricao;
    
    public static TipoDocumentoEnum obter(@NotNull Integer id) {
        for (TipoDocumentoEnum tipoDemanda : TipoDocumentoEnum.values()) {
            if(tipoDemanda.getId() == id) {
                return tipoDemanda;
            }
        }
        return null;
    }
}
