package br.gov.datasus.scodes.model.enums;

import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import java.util.stream.Stream;

import com.fasterxml.jackson.annotation.JsonValue;

import lombok.Getter;

public enum TipoProcessoEnum {
    
    ESTADO("I","Individual"),
    MUNICIPIO("C","Coletivo");
    
    private TipoProcessoEnum(String id, String descricao) {
        this.id = id;
        this.descricao = descricao;
    }

    @JsonValue
    @Getter
    private String id;

    @Getter
    private String descricao;
    
    @Override
    public String toString() {
        return this.descricao;
    }

    public static Optional<TipoProcessoEnum> obterPorId(final String id) {
        return TipoProcessoEnum.stream().filter(e -> e.getId().equals(id)).findFirst();
    }

    public static Optional<TipoProcessoEnum> obterPorDescricao(final String descricao) {
        return TipoProcessoEnum.stream().filter(e -> e.getDescricao().equals(descricao)).findFirst();
    }

    public static Stream<TipoProcessoEnum> stream() {
        return Stream.of(TipoProcessoEnum.values());
    }

    public static List<TipoProcessoEnum> list() {
        return Arrays.asList(TipoProcessoEnum.values());
    }
}
