package br.gov.datasus.scodes.model.enums;

import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import java.util.stream.Stream;

import com.fasterxml.jackson.annotation.JsonValue;

import lombok.Getter;

public enum TipoSexoEnum {
    
    FEMININO("F","Feminino"),
    MASCULINO("M","Masculino"),
    OUTROS("O","Outros");
    
    private TipoSexoEnum(String codigo, String descricao) {
        this.codigo = codigo;
        this.descricao = descricao;
    }

    @JsonValue
    @Getter
    private String codigo;

    @Getter
    private String descricao;
    
    @Override
    public String toString() {
        return this.codigo;
    }

    public static Optional<TipoSexoEnum> obterPorCodigo(final String codigo) {
        return TipoSexoEnum.stream().filter(e -> e.getCodigo().equals(codigo)).findFirst();
    }

    public static Optional<TipoSexoEnum> obterPorDescricao(final String descricao) {
        return TipoSexoEnum.stream().filter(e -> e.getDescricao().equals(descricao)).findFirst();
    }

    public static Stream<TipoSexoEnum> stream() {
        return Stream.of(TipoSexoEnum.values());
    }

    public static List<TipoSexoEnum> list() {
        return Arrays.asList(TipoSexoEnum.values());
    }
}
