package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.entity.Apresentacao;
import br.gov.datasus.scodes.model.dto.ApresentacaoDTO;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface ApresentacaoMapper extends BaseMapper<Apresentacao, ApresentacaoDTO> {

    ApresentacaoDTO toDto(Apresentacao entity);

    List<ApresentacaoDTO> toDto(List<Apresentacao> entities);

    List<ApresentacaoDTO> toDto(Iterable<Apresentacao> entities);

    PageableResponseModel<ApresentacaoDTO> toDtoPageableResponse(PageableResponseModel<Apresentacao> pageableResponseModel);

    Apresentacao toEntity(ApresentacaoDTO dto);

    List<Apresentacao> toEntity(List<ApresentacaoDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(ApresentacaoDTO dto, @MappingTarget Apresentacao entity);
}
