package br.gov.datasus.scodes.model.mapper;

import java.util.List;

import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.AutorDemandaDTO;
import br.gov.datasus.scodes.model.entity.AutorDemanda;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface AutorDemandaMapper extends BaseMapper<AutorDemanda, AutorDemandaDTO> {

    AutorDemandaDTO toDto(AutorDemanda entity);

    List<AutorDemandaDTO> toDto(List<AutorDemanda> entities);

    List<AutorDemandaDTO> toDto(Iterable<AutorDemanda> entities);

    PageableResponseModel<AutorDemandaDTO> toDtoPageableResponse(PageableResponseModel<AutorDemanda> pageableResponseModel);

    AutorDemanda toEntity(AutorDemandaDTO dto);

    List<AutorDemanda> toEntity(List<AutorDemandaDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(AutorDemandaDTO dto, @MappingTarget AutorDemanda entity);
}
