package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.entity.Cidade;
import br.gov.datasus.scodes.model.dto.CidadeDTO;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface CidadeMapper extends BaseMapper<Cidade, CidadeDTO> {

    CidadeDTO toDto(Cidade entity);

    List<CidadeDTO> toDto(List<Cidade> entities);

    List<CidadeDTO> toDto(Iterable<Cidade> entities);

    PageableResponseModel<CidadeDTO> toDtoPageableResponse(PageableResponseModel<Cidade> pageableResponseModel);

    Cidade toEntity(CidadeDTO dto);

    List<Cidade> toEntity(List<CidadeDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(CidadeDTO dto, @MappingTarget Cidade entity);
}
