package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.entity.ClassificacaoCobranca;
import br.gov.datasus.scodes.model.dto.ClassificacaoCobrancaDTO;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface ClassificacaoCobrancaMapper extends BaseMapper<ClassificacaoCobranca, ClassificacaoCobrancaDTO> {

    ClassificacaoCobrancaDTO toDto(ClassificacaoCobranca entity);

    List<ClassificacaoCobrancaDTO> toDto(List<ClassificacaoCobranca> entities);

    List<ClassificacaoCobrancaDTO> toDto(Iterable<ClassificacaoCobranca> entities);

    PageableResponseModel<ClassificacaoCobrancaDTO> toDtoPageableResponse(PageableResponseModel<ClassificacaoCobranca> pageableResponseModel);

    ClassificacaoCobranca toEntity(ClassificacaoCobrancaDTO dto);

    List<ClassificacaoCobranca> toEntity(List<ClassificacaoCobrancaDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(ClassificacaoCobrancaDTO dto, @MappingTarget ClassificacaoCobranca entity);
}
