package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.CompraModalidadeDTO;
import br.gov.datasus.scodes.model.entity.CompraModalidade;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface CompraModalidadeMapper extends BaseMapper<CompraModalidade, CompraModalidadeDTO> {

	CompraModalidadeDTO toDto(CompraModalidade entity);

	List<CompraModalidadeDTO> toDto(List<CompraModalidade> entities);

	List<CompraModalidadeDTO> toDto(Iterable<CompraModalidade> entities);

	PageableResponseModel<CompraModalidadeDTO> toDtoPageableResponse(PageableResponseModel<CompraModalidade> pageableResponseModel);

	CompraModalidade toEntity(CompraModalidadeDTO dto);

	List<CompraModalidade> toEntity(List<CompraModalidadeDTO> dtos);
	
	@InheritInverseConfiguration(name = "toDto")
	void fromDto(CompraModalidadeDTO dto, @MappingTarget CompraModalidade entity);
}
