package br.gov.datasus.scodes.model.mapper;

import java.util.List;

import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.CidadeDTO;
import br.gov.datasus.scodes.model.dto.DemandaDTO;
import br.gov.datasus.scodes.model.dto.RelatorioTecnicoDTO;
import br.gov.datasus.scodes.model.dto.TipoDemandaDTO;
import br.gov.datasus.scodes.model.dto.UnidadeOrganizacionalDTO;
import br.gov.datasus.scodes.model.entity.Cidade;
import br.gov.datasus.scodes.model.entity.Demanda;
import br.gov.datasus.scodes.model.entity.RelatorioTecnico;
import br.gov.datasus.scodes.model.entity.TipoDemanda;
import br.gov.datasus.scodes.model.entity.UnidadeOrganizacional;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface DemandaMapper extends BaseMapper<Demanda, DemandaDTO> {

    DemandaDTO toDto(Demanda entity);

    List<DemandaDTO> toDto(List<Demanda> entities);

    List<DemandaDTO> toDto(Iterable<Demanda> entities);

    PageableResponseModel<DemandaDTO> toDtoPageableResponse(PageableResponseModel<Demanda> pageableResponseModel);

    Demanda toEntity(DemandaDTO dto);

    List<Demanda> toEntity(List<DemandaDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(DemandaDTO dto, @MappingTarget Demanda entity);
    
    TipoDemandaDTO tipoDemanadaToDto(TipoDemanda entity);
    
    TipoDemanda tipoDemanadaToDto(TipoDemandaDTO entity);
    
    CidadeDTO cidadeToDto(Cidade entity);
    
    Cidade cidadeToDto(CidadeDTO entity);

    UnidadeOrganizacionalDTO unidadeOrganizacionalToDto(UnidadeOrganizacional entity);
    
    UnidadeOrganizacional unidadeOrganizacionalToDto(UnidadeOrganizacionalDTO entity);

    RelatorioTecnicoDTO relatorioTecnicoToDto(RelatorioTecnico entity);
    
    RelatorioTecnico relatorioTecnicoToDto(RelatorioTecnicoDTO entity);
}
