package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.entity.Drs;
import br.gov.datasus.scodes.model.dto.DrsDTO;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface DrsMapper extends BaseMapper<Drs, DrsDTO> {

    DrsDTO toDto(Drs entity);

    List<DrsDTO> toDto(List<Drs> entities);

    List<DrsDTO> toDto(Iterable<Drs> entities);

    PageableResponseModel<DrsDTO> toDtoPageableResponse(PageableResponseModel<Drs> pageableResponseModel);

    Drs toEntity(DrsDTO dto);

    List<Drs> toEntity(List<DrsDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(DrsDTO dto, @MappingTarget Drs entity);
}
