package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.*;
import br.gov.datasus.scodes.model.entity.*;
import org.mapstruct.*;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface EntradaEstoqueItemMapper extends BaseMapper<EntradaEstoqueItem, EntradaEstoqueItemDTO> {

    @Mappings({
        @Mapping(source = "item.id", target = "idItem"),
        @Mapping(source = "unidadeDispensadora.id", target = "idUnidadeDispensadora")
    })
    EntradaEstoqueItemDTO toDto(EntradaEstoqueItem entity);

    List<EntradaEstoqueItemDTO> toDto(List<EntradaEstoqueItem> entities);

    List<EntradaEstoqueItemDTO> toDto(Iterable<EntradaEstoqueItem> entities);

    PageableResponseModel<EntradaEstoqueItemDTO> toDtoPageableResponse(PageableResponseModel<EntradaEstoqueItem> pageableResponseModel);

    @InheritInverseConfiguration
    @Mapping(target = "dataEntradaItem", ignore = true)
    EntradaEstoqueItem toEntity(EntradaEstoqueItemDTO dto);

    List<EntradaEstoqueItem> toEntity(List<EntradaEstoqueItemDTO> dtos);

    @InheritConfiguration
    void fromDto(EntradaEstoqueItemDTO dto, @MappingTarget EntradaEstoqueItem entity);

    FabricanteDTO fabricanteToDto(Fabricante entity);

    Fabricante fabricanteToEntity(FabricanteDTO dto);
}
