package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.FornecedorDTO;
import br.gov.datasus.scodes.model.entity.Fornecedor;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface FornecedorMapper extends BaseMapper<Fornecedor, FornecedorDTO> {

	FornecedorDTO toDto(Fornecedor entity);

	List<FornecedorDTO> toDto(List<Fornecedor> entities);

	List<FornecedorDTO> toDto(Iterable<Fornecedor> entities);

	PageableResponseModel<FornecedorDTO> toDtoPageableResponse(PageableResponseModel<Fornecedor> pageableResponseModel);

	Fornecedor toEntity(FornecedorDTO dto);

	List<Fornecedor> toEntity(List<FornecedorDTO> dtos);
	
	@InheritInverseConfiguration(name = "toDto")
	void fromDto(FornecedorDTO dto, @MappingTarget Fornecedor entity);
}
