package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

import br.gov.datasus.scodes.model.dto.*;
import br.gov.datasus.scodes.model.entity.*;

import org.mapstruct.*;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface ItemMapper extends BaseMapper<Item, ItemDTO> {

    ItemDTO toDto(Item entity);

    List<ItemDTO> toDto(List<Item> entities);

    List<ItemDTO> toDto(Iterable<Item> entities);

    PageableResponseModel<ItemDTO> toDtoPageableResponse(PageableResponseModel<Item> pageableResponseModel);

    @InheritInverseConfiguration
    @Mappings({
        @Mapping(target = "codigo", ignore = true),
        @Mapping(target = "descricao", ignore = true),
    })
    Item toEntity(ItemDTO dto);

    List<Item> toEntity(List<ItemDTO> dtos);

    @InheritConfiguration
    void fromDto(ItemDTO dto, @MappingTarget Item entity);

    EspecificacaoDTO especificacaoToDto(Especificacao entity);

    Especificacao especificacaoToEntity(EspecificacaoDTO dto);

    MarcaDTO marcaToDto(Marca entity);

    Marca marcaToEntity(MarcaDTO dto);

    NaturezaDespesaDTO naturezaDespesaToDto(NaturezaDespesa entity);

    NaturezaDespesa naturezaDespesaToEntity(NaturezaDespesaDTO dto);

    ProgramaDTO programaToDto(Programa entity);

    Programa programaToEntity(ProgramaDTO dto);

    TipoDispensacaoDTO tipoDispensacaoToDto(TipoDispensacao entity);

    TipoDispensacao tipoDispensacaoToEntity(TipoDispensacaoDTO dto);

    TipoItemDTO tipoItemToDto(TipoItem entity);

    TipoItem tipoItemToEntity(TipoItemDTO dto);

}
