package br.gov.datasus.scodes.model.mapper;

import java.util.List;

import br.gov.datasus.scodes.model.dto.*;
import br.gov.datasus.scodes.model.entity.*;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface ProcessualMapper extends BaseMapper<Processual, ProcessualDTO> {

    ProcessualDTO toDto(Processual entity);

    List<ProcessualDTO> toDto(List<Processual> entities);

    List<ProcessualDTO> toDto(Iterable<Processual> entities);

    PageableResponseModel<ProcessualDTO> toDtoPageableResponse(PageableResponseModel<Processual> pageableResponseModel);

    Processual toEntity(ProcessualDTO dto);

    List<Processual> toEntity(List<ProcessualDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(ProcessualDTO dto, @MappingTarget Processual entity);

    PrazoDTO prazoToDto(Prazo entity);

    Prazo prazoToDto(PrazoDTO entity);

    VaraDTO varaToDto(Vara entity);

    Vara varaToDto(VaraDTO entity);

    AutorDemandaDTO autorDemandaToDto(AutorDemanda entity);

    AutorDemanda autorDemandaToDto(AutorDemandaDTO entity);

    ProfissionalDTO profissionalToDto(Profissional entity);

    Profissional profissionalToDto(ProfissionalDTO entity);

    TipoProfissaoDTO tipoProfissaoToDto(TipoProfissao entity);

    TipoProfissao tipoProfissaoToDto(TipoProfissaoDTO entity);

    TipoAcaoDTO tipoAcaoToDto(TipoAcao entity);

    TipoAcao tipoAcaoToDto(TipoAcaoDTO entity);

    CidadeDTO cidadeToDto(Cidade entity);

    Cidade cidadeToDto(CidadeDTO entity);

}
