package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.dto.CategoriaDTO;
import br.gov.datasus.scodes.model.dto.ProdutoDTO;
import br.gov.datasus.scodes.model.dto.TipoControladoDTO;
import br.gov.datasus.scodes.model.entity.Categoria;
import br.gov.datasus.scodes.model.entity.Produto;
import br.gov.datasus.scodes.model.entity.TipoControlado;

import java.util.List;

import org.mapstruct.*;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface ProdutoMapper extends BaseMapper<Produto, ProdutoDTO> {

    ProdutoDTO toDto(Produto entity);

    List<ProdutoDTO> toDto(List<Produto> entities);

    List<ProdutoDTO> toDto(Iterable<Produto> entities);

    PageableResponseModel<ProdutoDTO> toDtoPageableResponse(PageableResponseModel<Produto> pageableResponseModel);

    @InheritInverseConfiguration
    Produto toEntity(ProdutoDTO dto);

    List<Produto> toEntity(List<ProdutoDTO> dtos);

    @InheritConfiguration
    void fromDto(ProdutoDTO dto, @MappingTarget Produto entity);
    
    CategoriaDTO categoriaToDto(Categoria entity);

	Categoria categoriaToEntity(CategoriaDTO dto);
	
	TipoControladoDTO tipoControladoToDto(TipoControlado entity);

	TipoControlado tipoControladoToEntity(TipoControladoDTO dto);
}
