package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseGenericObjectMapper;
import br.gov.datasus.scodes.model.dto.ResultadoRelatorioDataRetornoDemandaDTO;
import org.mapstruct.*;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface RelatorioDataRetornoDemandaMapper extends BaseGenericObjectMapper<ResultadoRelatorioDataRetornoDemandaDTO> {

    @InheritInverseConfiguration(name = "toMap")
    public List<ResultadoRelatorioDataRetornoDemandaDTO> toList(List<Object> value);

    @Mappings({
        @Mapping(
            target = "tipoDemanda",
            expression = "java(toString( value, 0 ))"
        ),
        @Mapping(
            target = "dataCadastro",
            expression = "java(toString( value, 1 ))"
        ),
        @Mapping(
            target = "codigoDemanda",
            expression = "java(toLong( value, 2 ))"
        ),
        @Mapping(
            target = "autor",
            expression = "java(toString( value, 3 ))"
        ),
        @Mapping(
            target = "protocolo",
            expression = "java(toString( value, 4 ))"
        ),
        @Mapping(
            target = "processo",
            expression = "java(toString( value, 5 ))"
        ),
        @Mapping(
            target = "descricaoUnidadeDispensadora",
            expression = "java(toString( value, 6 ))"
        ),
        @Mapping(
            target = "descricaoCategoria",
            expression = "java(toString( value, 7 ))"
        ),
        @Mapping(
            target = "codigoProduto",
            expression = "java(toLong( value, 8 ))"
        ),
        @Mapping(
            target = "descricaoItem",
            expression = "java(toString( value, 9 ))"
        ),
        @Mapping(
            target = "quantidadeProduto",
            expression = "java(toLong( value, 10 ))"
        ),
        @Mapping(
            target = "dataRetornoAnterior",
            expression = "java(toString( value, 11 ))"
        ),
        @Mapping(
            target = "dataRetornoAtual",
            expression = "java(toString( value, 12 ))"
        ),
        @Mapping(
            target = "codigoAutor",
            expression = "java(toLong( value, 13 ))"
        ),
        @Mapping(
            target = "codigoReciboOrdemProduto",
            expression = "java(toLong( value, 14 ))"
        ),
        @Mapping(
            target = "codigoUnidadeDispensadora",
            expression = "java(toLong( value, 15 ))"
        ),
        @Mapping(
            target = "codigoTipoDemanda",
            expression = "java(toLong( value, 16 ))"
        )
    })
    public ResultadoRelatorioDataRetornoDemandaDTO toMap(Object value);
}
