package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseGenericObjectMapper;
import br.gov.datasus.scodes.model.dto.ResultadoPesquisaDRAutorDemandaReciboOrdemProdutoDTO;
import org.mapstruct.*;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface ResultadoPesquisaDRAutorDemandaReciboOrdemProdutoMapper extends BaseGenericObjectMapper<ResultadoPesquisaDRAutorDemandaReciboOrdemProdutoDTO> {

    @InheritInverseConfiguration(name = "toMap")
    public List<ResultadoPesquisaDRAutorDemandaReciboOrdemProdutoDTO> toList(List<Object> value);

    @Mappings({
        @Mapping(
            target = "codigoReciboOrdemProduto",
            expression = "java(toLong( value, 0 ))"
        ),
        @Mapping(
            target = "codigoAutor",
            expression = "java(toLong( value, 1 ))"
        ),
        @Mapping(
            target = "autor",
            expression = "java(toString( value, 2 ))"
        ),
        @Mapping(
            target = "protocolo",
            expression = "java(toString( value, 3 ))"
        ),
        @Mapping(
            target = "processo",
            expression = "java(toString( value, 4 ))"
        ),
        @Mapping(
            target = "codigoUnidadeDispensadora",
            expression = "java(toLong( value, 5 ))"
        ),
        @Mapping(
            target = "descricaoUnidadeDispensadora",
            expression = "java(toString( value, 6 ))"
        ),
        @Mapping(
            target = "codigoTipoDemanda",
            expression = "java(toLong( value, 7 ))"
        ),
        @Mapping(
            target = "tipoDemanda",
            expression = "java(toString( value, 8 ))"
        ),
        @Mapping(
            target = "dataCadastro",
            expression = "java(toDate( value, 9 ))"
        ),
        @Mapping(
            target = "dataRetornoAnterior",
            expression = "java(toDate( value, 10 ))"
        ),
        @Mapping(
            target = "dataRetornoAtual",
            expression = "java(toDate( value, 11 ))"
        ),
        @Mapping(
            target = "codigoAutorDemanda",
            expression = "java(toLong( value, 12 ))"
        ),
        @Mapping(
            target = "codigoAlteracaoDataRetorno",
            expression = "java(toLong( value, 13 ))"
        )
    })
    public ResultadoPesquisaDRAutorDemandaReciboOrdemProdutoDTO toMap(Object value);
}
