package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.dto.TipoControladoDTO;
import br.gov.datasus.scodes.model.entity.TipoControlado;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface TipoControladoMapper extends BaseMapper<TipoControlado, TipoControladoDTO> {

    TipoControladoDTO toDto(TipoControlado entity);

    List<TipoControladoDTO> toDto(List<TipoControlado> entities);

    List<TipoControladoDTO> toDto(Iterable<TipoControlado> entities);

    PageableResponseModel<TipoControladoDTO> toDtoPageableResponse(PageableResponseModel<TipoControlado> pageableResponseModel);

    TipoControlado toEntity(TipoControladoDTO dto);

    List<TipoControlado> toEntity(List<TipoControladoDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(TipoControladoDTO dto, @MappingTarget TipoControlado entity);
}
