package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.entity.TipoDemanda;
import br.gov.datasus.scodes.model.dto.TipoDemandaDTO;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface TipoDemandaMapper extends BaseMapper<TipoDemanda, TipoDemandaDTO> {

    TipoDemandaDTO toDto(TipoDemanda entity);

    List<TipoDemandaDTO> toDto(List<TipoDemanda> entities);

    List<TipoDemandaDTO> toDto(Iterable<TipoDemanda> entities);

    PageableResponseModel<TipoDemandaDTO> toDtoPageableResponse(PageableResponseModel<TipoDemanda> pageableResponseModel);

    TipoDemanda toEntity(TipoDemandaDTO dto);

    List<TipoDemanda> toEntity(List<TipoDemandaDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(TipoDemandaDTO dto, @MappingTarget TipoDemanda entity);
}
