package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.dto.TipoDispensacaoDTO;
import br.gov.datasus.scodes.model.entity.TipoDispensacao;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface TipoDispensacaoMapper extends BaseMapper<TipoDispensacao, TipoDispensacaoDTO> {

    TipoDispensacaoDTO toDto(TipoDispensacao entity);

    List<TipoDispensacaoDTO> toDto(List<TipoDispensacao> entities);

    List<TipoDispensacaoDTO> toDto(Iterable<TipoDispensacao> entities);

    PageableResponseModel<TipoDispensacaoDTO> toDtoPageableResponse(PageableResponseModel<TipoDispensacao> pageableResponseModel);

    TipoDispensacao toEntity(TipoDispensacaoDTO dto);

    List<TipoDispensacao> toEntity(List<TipoDispensacaoDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(TipoDispensacaoDTO dto, @MappingTarget TipoDispensacao entity);
}
