package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.dto.TipoDocumentoDTO;
import br.gov.datasus.scodes.model.entity.TipoDocumento;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface TipoDocumentoMapper extends BaseMapper<TipoDocumento, TipoDocumentoDTO> {

    TipoDocumentoDTO toDto(TipoDocumento entity);

    List<TipoDocumentoDTO> toDto(List<TipoDocumento> entities);

    List<TipoDocumentoDTO> toDto(Iterable<TipoDocumento> entities);

    PageableResponseModel<TipoDocumentoDTO> toDtoPageableResponse(PageableResponseModel<TipoDocumento> pageableResponseModel);

    TipoDocumento toEntity(TipoDocumentoDTO dto);

    List<TipoDocumento> toEntity(List<TipoDocumentoDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(TipoDocumentoDTO dto, @MappingTarget TipoDocumento entity);
}
