package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.entity.TipoItem;
import br.gov.datasus.scodes.model.dto.TipoItemDTO;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface TipoItemMapper extends BaseMapper<TipoItem, TipoItemDTO> {

    TipoItemDTO toDto(TipoItem entity);

    List<TipoItemDTO> toDto(List<TipoItem> entities);

    List<TipoItemDTO> toDto(Iterable<TipoItem> entities);

    PageableResponseModel<TipoItemDTO> toDtoPageableResponse(PageableResponseModel<TipoItem> pageableResponseModel);

    TipoItem toEntity(TipoItemDTO dto);

    List<TipoItem> toEntity(List<TipoItemDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(TipoItemDTO dto, @MappingTarget TipoItem entity);
}
