package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.dto.TipoProfissaoDTO;
import br.gov.datasus.scodes.model.entity.TipoProfissao;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface TipoProfissaoMapper extends BaseMapper<TipoProfissao, TipoProfissaoDTO> {

    TipoProfissaoDTO toDto(TipoProfissao entity);

    List<TipoProfissaoDTO> toDto(List<TipoProfissao> entities);

    List<TipoProfissaoDTO> toDto(Iterable<TipoProfissao> entities);

    PageableResponseModel<TipoProfissaoDTO> toDtoPageableResponse(PageableResponseModel<TipoProfissao> pageableResponseModel);

    TipoProfissao toEntity(TipoProfissaoDTO dto);

    List<TipoProfissao> toEntity(List<TipoProfissaoDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(TipoProfissaoDTO dto, @MappingTarget TipoProfissao entity);
}
