package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.dto.UnidadeDispensadoraDTO;
import br.gov.datasus.scodes.model.entity.UnidadeDispensadora;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface UnidadeDispensadoraMapper extends BaseMapper<UnidadeDispensadora, UnidadeDispensadoraDTO> {

    UnidadeDispensadoraDTO toDto(UnidadeDispensadora entity);

    List<UnidadeDispensadoraDTO> toDto(List<UnidadeDispensadora> entities);

    List<UnidadeDispensadoraDTO> toDto(Iterable<UnidadeDispensadora> entities);

    PageableResponseModel<UnidadeDispensadoraDTO> toDtoPageableResponse(PageableResponseModel<UnidadeDispensadora> pageableResponseModel);

    UnidadeDispensadora toEntity(UnidadeDispensadoraDTO dto);

    List<UnidadeDispensadora> toEntity(List<UnidadeDispensadoraDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(UnidadeDispensadoraDTO dto, @MappingTarget UnidadeDispensadora entity);
}
