package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.dto.UnidadeOrganizacionalDTO;
import br.gov.datasus.scodes.model.entity.UnidadeOrganizacional;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface UnidadeOrganizacionalMapper extends BaseMapper<UnidadeOrganizacional, UnidadeOrganizacionalDTO> {

    UnidadeOrganizacionalDTO toDto(UnidadeOrganizacional entity);

    List<UnidadeOrganizacionalDTO> toDto(List<UnidadeOrganizacional> entities);

    List<UnidadeOrganizacionalDTO> toDto(Iterable<UnidadeOrganizacional> entities);

    PageableResponseModel<UnidadeOrganizacionalDTO> toDtoPageableResponse(PageableResponseModel<UnidadeOrganizacional> pageableResponseModel);

    UnidadeOrganizacional toEntity(UnidadeOrganizacionalDTO dto);

    List<UnidadeOrganizacional> toEntity(List<UnidadeOrganizacionalDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(UnidadeOrganizacionalDTO dto, @MappingTarget UnidadeOrganizacional entity);
}
