package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.entity.UnidadeTransferencia;
import br.gov.datasus.scodes.model.dto.UnidadeTransferenciaDTO;
import java.util.List;

import org.mapstruct.*;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface UnidadeTransferenciaMapper extends BaseMapper<UnidadeTransferencia, UnidadeTransferenciaDTO> {

    UnidadeTransferenciaDTO toDto(UnidadeTransferencia entity);

    List<UnidadeTransferenciaDTO> toDto(List<UnidadeTransferencia> entities);

    List<UnidadeTransferenciaDTO> toDto(Iterable<UnidadeTransferencia> entities);

    PageableResponseModel<UnidadeTransferenciaDTO> toDtoPageableResponse(PageableResponseModel<UnidadeTransferencia> pageableResponseModel);

    @InheritInverseConfiguration(name = "toDto")
    UnidadeTransferencia toEntity(UnidadeTransferenciaDTO dto);

    List<UnidadeTransferencia> toEntity(List<UnidadeTransferenciaDTO> dtos);

    @InheritConfiguration(name = "toEntity")
    void fromDto(UnidadeTransferenciaDTO dto, @MappingTarget UnidadeTransferencia entity);
}
