package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.PerfilDTO;
import br.gov.datasus.scodes.model.dto.UsuarioDTO;
import br.gov.datasus.scodes.model.entity.Perfil;
import br.gov.datasus.scodes.model.entity.Usuario;
import org.mapstruct.*;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface UsuarioMapper extends BaseMapper<Usuario, UsuarioDTO> {

    UsuarioDTO toDto(Usuario entity);

    @Named("toSimpleDto")
    @InheritConfiguration(name = "toDto")
    @Mapping(target = "perfis", ignore = true)
    UsuarioDTO toSimpleDto(Usuario entity);

    @IterableMapping(qualifiedByName = "toSimpleDto")
    List<UsuarioDTO> toDto(List<Usuario> entities);

    @IterableMapping(qualifiedByName = "toSimpleDto")
    List<UsuarioDTO> toDto(Iterable<Usuario> entities);

    @IterableMapping(qualifiedByName = "toSimpleDto")
    PageableResponseModel<UsuarioDTO> toDtoPageableResponse(PageableResponseModel<Usuario> pageableResponseModel);

    @InheritInverseConfiguration(name = "toDto")
    Usuario toEntity(UsuarioDTO dto);

    List<Usuario> toEntity(List<UsuarioDTO> dtos);

    @InheritConfiguration(name = "toEntity")
    void fromDto(UsuarioDTO dto, @MappingTarget Usuario entity);

    @Mapping(target = "perfilFuncionalidades", source = "perfilFuncionalidades", ignore = true)
    PerfilDTO perfilToDto(Perfil entity);

    @InheritInverseConfiguration(name = "perfilToDto")
    Perfil perfilToEntity(PerfilDTO dto);
}
