package br.gov.datasus.scodes.model.mapper;

import java.util.List;

import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.CidadeDTO;
import br.gov.datasus.scodes.model.dto.TipoVaraDTO;
import br.gov.datasus.scodes.model.dto.VaraDTO;
import br.gov.datasus.scodes.model.entity.Cidade;
import br.gov.datasus.scodes.model.entity.TipoVara;
import br.gov.datasus.scodes.model.entity.Vara;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface VaraMapper extends BaseMapper<Vara, VaraDTO> {

    VaraDTO toDto(Vara entity);

    List<VaraDTO> toDto(List<Vara> entities);

    List<VaraDTO> toDto(Iterable<Vara> entities);

    PageableResponseModel<VaraDTO> toDtoPageableResponse(PageableResponseModel<Vara> pageableResponseModel);

    Vara toEntity(VaraDTO dto);

    List<Vara> toEntity(List<VaraDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(VaraDTO dto, @MappingTarget Vara entity);
    
    TipoVaraDTO tipoVaraToDto(TipoVara entity);
    
    TipoVara tipoVaraToDto(TipoVaraDTO entity);
    
    CidadeDTO cidadeToDto(Cidade entity);
    
    Cidade cidadeToDto(CidadeDTO entity);
}
