package br.gov.datasus.scodes.model.mapper.generic;

import br.gov.datasus.api.core.model.mapper.BaseGenericObjectMapper;
import br.gov.datasus.scodes.model.dto.InventarioItemConsolidadoDTO;
import org.mapstruct.*;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface InventarioItemConsolidadoGenericMapper extends BaseGenericObjectMapper<InventarioItemConsolidadoDTO> {

    @IterableMapping(qualifiedByName = "toMap")
    List<InventarioItemConsolidadoDTO> toList(List<Object> value);

    @Named("toMap")
    @Mappings({
        @Mapping(target = "idInventario", expression = "java(toLong(value, 0))"),
        @Mapping(target = "idItem", expression = "java(toLong(value, 1))"),
        @Mapping(target = "codigoItem", expression = "java(toString(value, 2))"),
        @Mapping(target = "descricaoItem", expression = "java(toString(value, 3))"),
        @Mapping(target = "unidadeMedida", expression = "java(toString(value, 4))"),
        @Mapping(target = "id", expression = "java(toLong(value, 5))"),
        @Mapping(target = "quantidadeFisica", expression = "java(toLong(value, 6))"),
        @Mapping(target = "dataContagem", expression = "java(toDate(value, 7))"),
        @Mapping(target = "situacaoAlterado", expression = "java(toBooleanFromString(value, 8, \"true\"))"),
        @Mapping(target = "quantidadeCompraEntrada", expression = "java(toLong(value, 9))"),
        @Mapping(target = "quantidadeOutraEntrada", expression = "java(toLong(value, 10))"),
        @Mapping(target = "quantidadePerdaSaida", expression = "java(toLong(value, 11))"),
        @Mapping(target = "quantidadeTransferenciaSaida", expression = "java(toLong(value, 12))"),
        @Mapping(target = "quantidadeDispensacaoSaida", expression = "java(toLong(value, 13))"),
        @Mapping(target = "quantidadeEstornoEntrada", expression = "java(toLong(value, 14))"),
        @Mapping(target = "quantidadeReciboInvalidadoEntrada", expression = "java(toLong(value, 15))"),
        @Mapping(target = "quantidadeOutraSaida", expression = "java(toLong(value, 16))"),
        @Mapping(target = "quantidadePerdaVencimentoSaida", expression = "java(toLong(value, 17))"),
        @Mapping(target = "quantidadeQuebraSaida", expression = "java(toLong(value, 18))"),
        @Mapping(target = "quantidadeAjusteSaida", expression = "java(toLong(value, 19))"),
        @Mapping(target = "quantidadeEstoqueDataContagem", expression = "java(toLong(value, 20))"),
        @Mapping(target = "quantidadeItemPosCalculos", expression = "java(toLong(value, 21))"),
        @Mapping(target = "quantidadeItemDiferenca", expression = "java(toLong(value, 22))"),
        @Mapping(target = "valorItem", expression = "java(toBigDecimal(value, 23))"),
    })
    InventarioItemConsolidadoDTO toMap(Object value);
}
