package br.gov.datasus.scodes.model.mapper.generic;

import br.gov.datasus.api.core.model.mapper.BaseGenericObjectMapper;
import br.gov.datasus.scodes.model.dto.InventarioItemDTO;
import org.mapstruct.*;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface InventarioItemGenericMapper extends BaseGenericObjectMapper<InventarioItemDTO> {

    @IterableMapping(qualifiedByName = "toMap")
    List<InventarioItemDTO> toList(List<Object> value);

    @Named("toMap")
    @Mappings({
        @Mapping(target = "idInventario", expression = "java(toLong(value, 0))"),
        @Mapping(target = "idItem", expression = "java(toLong(value, 1))"),
        @Mapping(target = "codigoItem", expression = "java(toString(value, 2))"),
        @Mapping(target = "descricaoItem", expression = "java(toString(value, 3))"),
        @Mapping(target = "unidadeMedida", expression = "java(toString(value, 4))"),
        @Mapping(target = "id", expression = "java(toLong(value, 5))"),
        @Mapping(target = "quantidadeFisica", expression = "java(toLong(value, 6))"),
        @Mapping(target = "dataContagem", expression = "java(toDate(value, 7))"),
    })
    InventarioItemDTO toMap(Object value);
}
