package br.gov.datasus.scodes.repository;

import br.gov.datasus.api.core.dynamicquery.repository.DynamicNativeQueryRepository;
import br.gov.datasus.api.core.dynamicquery.repository.DynamicQueryRepository;
import br.gov.datasus.scodes.model.constants.AlteracaoDataRetornoConstants;
import br.gov.datasus.scodes.model.dto.projection.ResultadoAlterarDataRetornoDTO;
import br.gov.datasus.scodes.model.entity.AlteracaoDataRetorno;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface AlteracaoDataRetornoRepository extends JpaRepository<AlteracaoDataRetorno, Long>, DynamicQueryRepository, DynamicNativeQueryRepository {
    void deleteByIdAndStatusId(Long id, Long idStatus);

    @Query(value = AlteracaoDataRetornoConstants
            .QUERIES
            .RESULTADO_ALTERAR_DATA_RETORNO, nativeQuery = true)
    List<ResultadoAlterarDataRetornoDTO> obterResultadoAlterarDataRetorno(@Param("codigoAlteracaoRetorno") Long codigoAlteracaoRetorno);

}
