package br.gov.datasus.scodes.repository;

import br.gov.datasus.scodes.model.entity.GrupoEspecificacao;

import java.util.List;
import br.gov.datasus.api.core.model.dto.DominioItemModel;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import br.gov.datasus.api.core.dynamicquery.repository.DynamicNativeQueryRepository;
import br.gov.datasus.api.core.dynamicquery.repository.DynamicQueryRepository;
import org.springframework.data.repository.query.Param;

public interface GrupoEspecificacaoRepository extends CrudRepository<GrupoEspecificacao, Long>, DynamicQueryRepository, DynamicNativeQueryRepository {

    public List<DominioItemModel> obterDominio();

    @Query("SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel("
        + "   grupoEspecificacao.id, "
        + "   grupoEspecificacao.codigoGrupoAnatomico || ' - ' || grupoEspecificacao.nome"
        + ") FROM GrupoEspecificacao grupoEspecificacao"
        + " WHERE grupoEspecificacao.categoria.id = :idCategoria")
    public List<DominioItemModel> obterDominio(@Param("idCategoria") Long idCategoria);
}
