package br.gov.datasus.scodes.repository;

import br.gov.datasus.scodes.model.entity.TipoVara;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;

import br.gov.datasus.api.core.dynamicquery.repository.DynamicNativeQueryRepository;
import br.gov.datasus.api.core.dynamicquery.repository.DynamicQueryRepository;
import br.gov.datasus.scodes.model.entity.Vara;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface VaraRepository extends CrudRepository<Vara, Long>, DynamicQueryRepository, DynamicNativeQueryRepository {


    @Query("SELECT DISTINCT (vara.tipoVara), vara.tipoVara.id FROM Vara vara WHERE vara.cidade.id = :cidadeId ORDER BY (vara.tipoVara.id) ASC")
    List<TipoVara> obterTiposVaraPorCodigoMunicipio( @Param("cidadeId") Long cidadeId);

    List<Vara> findByTipoVaraId(Long tipoVaraId);
}
