package br.gov.datasus.scodes.service;

import java.util.List;
import java.util.Optional;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import br.gov.datasus.api.core.exception.ResourceNotFoundException;
import br.gov.datasus.api.core.model.dto.DominioItemModel;
import br.gov.datasus.scodes.model.dto.AreaDTO;
import br.gov.datasus.scodes.model.entity.Area;
import br.gov.datasus.scodes.model.mapper.AreaMapper;
import br.gov.datasus.scodes.repository.AreaRepository;
import lombok.RequiredArgsConstructor;

@Service
@RequiredArgsConstructor
@Transactional(propagation = Propagation.SUPPORTS)
public class AreaService {

	private final AreaRepository repository;
	private final AreaMapper mapper;

	public AreaDTO obterPorId(Long id) {
		Area entity = repository.findById(id).orElseThrow(ResourceNotFoundException::new);
		return mapper.toDto(entity);
	}

	public List<AreaDTO> obterTodos() {
		Iterable<Area> itens = repository.findAll();
		return mapper.toDto(itens);
	}
	
	public List<DominioItemModel> obterDominio() {
        return repository.obterDominio();
    }
}
