package br.gov.datasus.scodes.service;

import br.gov.datasus.scodes.model.entity.Item;
import br.gov.datasus.scodes.model.entity.UnidadeDispensadora;
import br.gov.datasus.scodes.repository.EntradaEstoqueItemRepository;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;

@Service
@RequiredArgsConstructor
@Transactional(propagation = Propagation.SUPPORTS)
public class EntradaEstoqueItemService {

    private final EntradaEstoqueItemRepository repository;

    public BigDecimal obterValorItemUltimaEntrada(Item item, UnidadeDispensadora unidadeDispensadora) {
        return repository.findValorItemUltimaEntrada(item, unidadeDispensadora).orElse(new BigDecimal(0));
    }


}
