package br.gov.datasus.scodes.service;

import java.util.List;
import java.util.Optional;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import br.gov.datasus.api.core.exception.ResourceNotFoundException;
import br.gov.datasus.scodes.model.dto.TipoVaraDTO;
import br.gov.datasus.scodes.model.entity.TipoVara;
import br.gov.datasus.scodes.model.mapper.TipoVaraMapper;
import br.gov.datasus.scodes.repository.TipoVaraRepository;
import lombok.RequiredArgsConstructor;

@Service
@RequiredArgsConstructor
@Transactional(propagation= Propagation.SUPPORTS)
public class TipoVaraService {

    private final TipoVaraRepository repository;
    private final TipoVaraMapper mapper;

    public TipoVaraDTO obterPorId(Long id) {
        Optional<TipoVara> one = repository.findById(id);
        TipoVara entity = one.orElseThrow(ResourceNotFoundException::new);
        return mapper.toDto(entity);
    }

    public List<TipoVaraDTO> obterTodos() {
        Iterable<TipoVara> itens = repository.findAll();
        return mapper.toDto(itens);
    }

}
