SELECT
    inv.co_seq_inventario as "idInventario",
    item.co_seq_item as "idItem",
    item.co_item AS "codigoItem",
    dbscodes.fc_descricao_item(item.co_seq_item) AS "descricaoItem",
    espec.no_especificacao AS "unidadeMedida",
    invitem.co_seq_inventario_item as "idInventarioItem",
    invitem.qt_inventario_item AS "quantidadeFisica",
    invitem.dt_contagem AS "dataContagem",
    invitem.st_alterado AS "situacaoAlterado",
    invitem.qt_compra_entrada AS "quantidadeCompraEntrada",
    invitem.qt_outra_entrada AS "quantidadeOutraEntrada",
    invitem.qt_perda_saida AS "quantidadePerdaSaida",
    invitem.qt_transferencia_saida AS "quantidadeTransferenciaSaida",
    invitem.qt_dispensacao_saida AS "quantidadeDispensacaoSaida",
    invitem.qt_estorno_entrada AS "quantidadeEstornoEntrada",
    invitem.qt_recibo_invalidado_entrada AS "quantidadeReciboInvalidadoEntrada",
    invitem.qt_outra_saida AS "quantidadeOutraSaida",
    invitem.qt_perda_vencimento_saida AS "quantidadePerdaVencimentoSaida",
    invitem.qt_quebra_saida AS "quantidadeQuebraSaida",
    invitem.qt_ajuste_saida AS "quantidadeAjusteSaida",
    invitem.qt_estoque_data_contagem AS "quantidadeEstoqueDataContagem",
    invitem.qt_item_pos_calculos AS "quantidadeItemPosCalculos",
    invitem.qt_item_diferenca AS "quantidadeItemDiferenca",
    invitem.vl_item AS "valorItem"
FROM dbscodes.tb_inventario inv
INNER JOIN dbscodes.tb_estoque_auxiliar estaux ON inv.co_unidade_dispensadora = estaux.co_unidade_dispensadora
INNER JOIN dbscodes.tb_item item ON estaux.co_item = item.co_seq_item
INNER JOIN dbscodes.tb_especificacao espec ON item.co_especificacao = espec.co_seq_especificacao
INNER JOIN dbscodes.tb_produto prod ON espec.co_produto = prod.co_seq_produto
INNER JOIN dbscodes.tb_inventario_item invitem ON inv.co_seq_inventario = invitem.co_inventario AND item.co_seq_item = invitem.co_item
WHERE inv.co_seq_inventario = :idInventario
ORDER BY item.co_item ASC
