SELECT DISTINCT
    trop.CO_SEQ_RECIBO_ORDEM_PRODUTO  AS codigoReciboOrdemProduto,
    aut.CO_SEQ_AUTOR                  AS codigoAutor,
    aut.NO_NOME                       AS autor,
    tdema.NU_PROTOCOLO                AS protocolo,
    tdema.NU_PROCESSO                 AS processo,
    tud.CO_SEQ_UNIDADE_DISPENSADORA   AS codigoUnidadeDispensadora,
    tud.DS_UNIDADE_DISPENSADORA       AS descricaoUnidadeDispensadora,
    tdema.CO_TIPO_DEMANDA             AS codigoTipoDemanda,
    CASE tdema.CO_TIPO_DEMANDA
        WHEN 1   THEN
            'Administrativa'
        WHEN 2   THEN
            'Judicial'
        WHEN 3   THEN
            'Jefaz'
        WHEN 4   THEN
            'Comissão de Farmacologia'
    END AS tipoDemanda,
    tdema.DT_ENTRADA                  AS dataCadastro,
    trop.DT_DATA_RETORNO              AS dataRetornoAnterior,
    trop.DT_DATA_RETORNO              AS dataRetornoAtual,
    tad.CO_SEQ_AUTOR_DEMANDA          AS codigoAutorDemanda,
    tadrp.co_alteracao_data_retorno   AS codigoAlteracaoDataRetorno
FROM dbscodes.RL_AUTOR_AUTOR_DEMANDA  AS raad
        INNER JOIN dbscodes.TB_AUTOR_DEMANDA AS tad on tad.CO_SEQ_AUTOR_DEMANDA = raad.CO_AUTOR_DEMANDA
        INNER JOIN dbscodes.TB_AUTOR AS aut ON aut.CO_SEQ_AUTOR = raad.CO_AUTOR
        INNER JOIN dbscodes.TB_DEMANDA AS tdema ON tdema.CO_SEQ_DEMANDA = tad.CO_DEMANDA
        INNER JOIN dbscodes.TB_ORDEM_DISPENSACAO AS tod ON tod.CO_AUTOR_DEMANDA = tad.CO_SEQ_AUTOR_DEMANDA
        INNER JOIN dbscodes.TB_ORDEM_PRODUTO AS torp ON (torp.CO_ORDEM_DISPENSACAO = tod.CO_SEQ_ORDEM_DISPENSACAO AND torp.NU_ATIVO_ATUAL = 1)
        INNER JOIN dbscodes.TB_UNIDADE_DISPENSADORA AS tud ON tud.CO_SEQ_UNIDADE_DISPENSADORA = tod.CO_UNIDADE_DISPENSADORA
        INNER JOIN dbscodes.TB_STATUS AS tst ON tst.CO_SEQ_STATUS = tad.CO_STATUS
        INNER JOIN dbscodes.TB_PRODUTO AS tpro ON tpro.CO_SEQ_PRODUTO = torp.CO_PRODUTO
        INNER JOIN dbscodes.TB_RECIBO_ORDEM_PRODUTO AS trop ON trop.CO_ORDEM_PRODUTO = torp.CO_SEQ_ORDEM_PRODUTO
        INNER JOIN dbscodes.TB_RECIBO AS trec ON trec.CO_SEQ_RECIBO = trop.CO_RECIBO
        LEFT OUTER JOIN dbscodes.TB_ALTERACAO_DATA_RETORNO_PRODUTO tadrp ON tadrp.CO_RECIBO_ORDEM_PRODUTO = trop.CO_SEQ_RECIBO_ORDEM_PRODUTO

WHERE 1 = 1

AND (trop.DT_DATA_RETORNO = :dataRetornoAnterior)
AND (tad.CO_SEQ_AUTOR_DEMANDA in (:codigosAutoresDemanda))


ORDER BY aut.NO_NOME, tud.DS_UNIDADE_DISPENSADORA
