SELECT DISTINCT
	CASE tdema.CO_TIPO_DEMANDA
		WHEN 1 THEN 'Administrativa'
		WHEN 2 THEN 'Judicial'
		WHEN 3 THEN 'Jefaz'
		WHEN 4 THEN 'Comissão de Farmacologia'
	END AS tipoDemanda,
	TO_CHAR(tdema.DT_ENTRADA, 'dd/mm/yyyy')             AS dataCadastro,
	tdema.CO_SEQ_DEMANDA 			                    AS codigoDemanda,
	aut.NO_NOME                                         AS autor,
	COALESCE(CONCAT('N: ', tdema.NU_PROTOCOLO), cast(tdema.NU_PROTOCOLO as VARCHAR), cast(tdema.NU_PROTOCOLO as VARCHAR)) AS protocolo,
	COALESCE(CONCAT('N: ', tdema.NU_PROCESSO), cast(tdema.NU_PROCESSO as VARCHAR), cast(tdema.NU_PROCESSO as VARCHAR)) AS processo,
	tud.DS_UNIDADE_DISPENSADORA                         AS descricaoUnidadeDispensadora,
	tcat.NO_CATEGORIA 				                    AS descricaoCategoria,
	tpro.CO_SEQ_PRODUTO 			                    AS codigoProduto,
	DBSCODES.FC_DESCRICAO_ITEM(tite.CO_SEQ_ITEM)        AS descricaoItem,
	torp.QT_PRODUTO 				                    AS quantidadeProduto,
	TO_CHAR(tadrp.DT_RETORNO_ANTERIOR, 'dd/mm/yyyy')    AS dataRetornoAnterior,
	TO_CHAR(TO_DATE(:dataRetornoAtual, 'yyyy-MM-dd'), 'dd/mm/yyyy') AS dataRetornoAtual,
	aut.CO_SEQ_AUTOR                                    AS codigoAutor,
	trop.CO_SEQ_RECIBO_ORDEM_PRODUTO 					AS codigoReciboOrdemProduto,
	tud.CO_SEQ_UNIDADE_DISPENSADORA						AS codigoUnidadeDispensadora,
	tdema.CO_TIPO_DEMANDA 								AS codigoTipoDemanda
FROM dbscodes.RL_AUTOR_AUTOR_DEMANDA  AS raad
        INNER JOIN dbscodes.TB_AUTOR_DEMANDA AS tad on tad.CO_SEQ_AUTOR_DEMANDA = raad.CO_AUTOR_DEMANDA
        INNER JOIN dbscodes.TB_AUTOR AS aut ON aut.CO_SEQ_AUTOR = raad.CO_AUTOR
        INNER JOIN dbscodes.TB_DEMANDA AS tdema ON tdema.CO_SEQ_DEMANDA = tad.CO_DEMANDA
        INNER JOIN dbscodes.TB_ORDEM_DISPENSACAO AS tod ON tod.CO_AUTOR_DEMANDA = tad.CO_SEQ_AUTOR_DEMANDA
        INNER JOIN dbscodes.TB_ORDEM_PRODUTO AS torp ON (torp.CO_ORDEM_DISPENSACAO = tod.CO_SEQ_ORDEM_DISPENSACAO AND torp.NU_ATIVO_ATUAL = 1)
        INNER JOIN dbscodes.TB_UNIDADE_DISPENSADORA AS tud ON tud.CO_SEQ_UNIDADE_DISPENSADORA = tod.CO_UNIDADE_DISPENSADORA
        INNER JOIN dbscodes.TB_STATUS AS tst ON tst.CO_SEQ_STATUS = tad.CO_STATUS
        INNER JOIN dbscodes.TB_PRODUTO AS tpro ON tpro.CO_SEQ_PRODUTO = torp.CO_PRODUTO
        INNER JOIN dbscodes.TB_RECIBO_ORDEM_PRODUTO AS trop ON trop.CO_ORDEM_PRODUTO = torp.CO_SEQ_ORDEM_PRODUTO
        INNER JOIN dbscodes.TB_RECIBO AS trec ON trec.CO_SEQ_RECIBO = trop.CO_RECIBO
        LEFT OUTER JOIN dbscodes.TB_ALTERACAO_DATA_RETORNO_PRODUTO tadrp ON tadrp.CO_RECIBO_ORDEM_PRODUTO = trop.CO_SEQ_RECIBO_ORDEM_PRODUTO
        LEFT OUTER JOIN dbscodes.TB_ALTERACAO_DATA_RETORNO tadr ON tadr.CO_SEQ_ALTERACAO_DATA_RETORNO = tadrp.CO_ALTERACAO_DATA_RETORNO
        INNER JOIN dbscodes.TB_ESPECIFICACAO tesp ON tesp.CO_PRODUTO = tpro.CO_SEQ_PRODUTO
        INNER JOIN dbscodes.TB_ITEM tite ON tite.CO_ESPECIFICACAO = tesp.CO_SEQ_ESPECIFICACAO
        INNER JOIN dbscodes.TB_CATEGORIA tcat ON tcat.CO_SEQ_CATEGORIA = tpro.CO_CATEGORIA

WHERE 1 = 1

AND tadrp.co_alteracao_data_retorno = :codigoAlteracaoDataRetorno

ORDER BY aut.NO_NOME, tud.DS_UNIDADE_DISPENSADORA;
