# SCODES

> SCODES

**Antes de qualquer coisa, você deve ter instalado o [Node.js + NPM](https://nodejs.org/en/) e o [Angular CLI](https://cli.angular.io/).**

Passando esse _setup_ inicial, para executar a aplicação, vá no terminal e execute os passo abaixo:

- Instala as dependencias

```bash
# npm install
npm i
# npm update
npm up
```

- Constrói e serve a aplicação, assim que estiver pronto abre no navegador

```bash
# ng serve --open
ng s -o
```

Caso não abra no navegador automáticamente. Acesse http://localhost:4200

## DATASUS Angular

Aplicação utiliza os módulos/pacotes do DATASUS Angular `@datasus/...`.

Para mais dúvidas, consultem o site oficial do [Angular](https://angular.io) e do [Angular Material](https://material.angular.io).

## Usando o front-end sem o back-end

Para executar os _mocks_ simulando os requests do _back-end_, substitua a propriedade `backendUrl` do `config/env.json`:

- De:

```json
{
  "backendUrl": "http://localhost:8080/scodes",
  ...
}
```

- Para:

```json
{
  "backendUrl": "http://localhost:4200/mock",
  ...
}
```

E implementar os retornos dos JSON na pasta `src/mock`.

Exemplo:

- Se o _endpoint_ do backend é `/recurso/1` que retornaria o JSON `{"id": 1, "nome": "Teste"}`, então deve-se criar o arquivo `src/mock/recurso/1.json` com JSON esperado.
- Caso o _endpoint_ é `/recurso/na/raiz/`, coloque o JSON em no arquivo `src/mock/recurso/na/raiz/index.json`.
- Utilizando um método diferente de **GET**, deve-se colocar o método, em minusculo, como sufixo antes da extensão: `src/mock/recurso/na/raiz/index-post.json` ou `src/mock/recurso/1-delete.json`
