import { Injectable } from '@angular/core';

import { Observable } from 'rxjs';

import { BaseService, PageableRequestModel, PageableResponseModel } from '@datasus/core';

import { AcessoModel } from '../models/acesso.model';
import { AcessoFilterModel } from '../models/acesso-filter.model';
import { RelatorioAcessoFilterModel } from '../models/relatorio-acesso-filter.model';
import { ArquivoBase64Model } from '../../../shared/models/arquivo-base64.model';

@Injectable()
export class AcessoService extends BaseService {
    obterPorId(id: number): Observable<AcessoModel> {
        return this.baseGet<AcessoModel>(`/acesso/${id}`);
    }

    obterTodosPaginado(body: PageableRequestModel<AcessoFilterModel>): Observable<PageableResponseModel<AcessoModel>> {
        return this.basePost<PageableResponseModel<AcessoModel>>('/acesso/paginado', body);
    }

    relatorio(body: RelatorioAcessoFilterModel): Observable<ArquivoBase64Model> {
        return this.basePost<ArquivoBase64Model>('/acesso/relatorio', body);
    }
}
