import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';
import { NgxMaskModule } from 'ngx-mask';

import { MaterialModule } from '../../../material/material.module';
import { DatasusModule } from '../../../datasus/datasus.module';
import { SharedModule } from '../../shared/shared.module';
import { GrupoRoutingModule } from './grupo-routing.module';
import { GrupoService } from './services/grupo.service';
import { GrupoResolver } from './resolvers/grupo.resolver';
import { GrupoListComponent } from './pages/list/grupo.list.component';
import { GrupoFormComponent } from './pages/form/grupo.form.component';

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // JSDADDY Ngx Mask
    NgxMaskModule.forChild({ dropSpecialCharacters: true }),
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // Grupo
    GrupoRoutingModule,
  ],
  declarations: [
    /*declaration component*/
    GrupoListComponent,
    GrupoFormComponent,
  ],
  providers: [
    /*declaration provider*/
    GrupoResolver,
    GrupoService,
  ],
})
export class GrupoModule { }
