import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';

import { GrupoModel } from '../models/grupo.model';
import { GrupoService } from '../services/grupo.service';

@Injectable()
export class GrupoResolver implements Resolve<GrupoModel> {

  constructor(
    private grupoService: GrupoService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<GrupoModel> | Promise<GrupoModel> | GrupoModel {
    return this.grupoService.obterPorId(route.params.id);
  }

}
