import { Injectable } from '@angular/core';
import { ActivatedRouteSnapshot, Resolve, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';
import { UsuarioLocalModel } from '../models/usuario-local.model';
import { UsuarioLocalService } from '../services/usuario-local.service';


@Injectable()
export class UsuarioLocalResolver implements Resolve<UsuarioLocalModel> {

  constructor(
    private usuarioLocalService: UsuarioLocalService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<UsuarioLocalModel> | Promise<UsuarioLocalModel> | UsuarioLocalModel {
    return this.usuarioLocalService.obterPorId(route.params.id);
  }

}
