import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';

import { UsuarioModel } from '../models/usuario.model';
import { UsuarioService } from '../services/usuario.service';

@Injectable()
export class UsuarioResolver implements Resolve<UsuarioModel> {

  constructor(
    private usuarioService: UsuarioService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<UsuarioModel> | Promise<UsuarioModel> | UsuarioModel {
    return this.usuarioService.obterPorId(route.params.id);
  }

}
