import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';

import { BaseService, PageableRequestModel, PageableResponseModel } from '@datasus/core';

import { UsuarioLocalModel } from '../models/usuario-local.model';
import { UsuarioLocalFilterModel } from '../models/usuario-local-filter.model';

@Injectable({
  providedIn: 'root',
})
export class UsuarioLocalService extends BaseService {

  obterPorId(id: number): Observable<UsuarioLocalModel> {
    return this.baseGet<UsuarioLocalModel>(`/usuario-local/${id}`);
  }

  obterTodosPaginado(body: PageableRequestModel<UsuarioLocalFilterModel>): Observable<PageableResponseModel<UsuarioLocalModel>> {
    return this.basePost<PageableResponseModel<UsuarioLocalModel>>('/usuario-local/paginado', body);
  }

  incluir(body: UsuarioLocalModel): Observable<UsuarioLocalModel> {
    return this.basePost<UsuarioLocalModel>('/usuario-local', body);
  }

  alterar(body: UsuarioLocalModel, id: number): Observable<UsuarioLocalModel> {
    return this.basePut<UsuarioLocalModel>(`/usuario-local/${id}`, body);
  }

  excluir(id: number): Observable<void> {
    return this.baseDelete<void>(`/usuario-local/${id}`);
  }

}
