import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';

import { BaseService, DominioItemModel, PageableRequestModel, PageableResponseModel } from '@datasus/core';

import { UsuarioModel } from '../models/usuario.model';
import { UsuarioFilterModel } from '../models/usuario-filter.model';

@Injectable({
  providedIn: 'root'
})
export class UsuarioService extends BaseService {

  obterPorId(id: number): Observable<UsuarioModel> {
    return this.baseGet<UsuarioModel>(`/usuario/${id}`);
  }

  obterTodosPaginado(body: PageableRequestModel<UsuarioFilterModel>): Observable<PageableResponseModel<UsuarioModel>> {
    return this.basePost<PageableResponseModel<UsuarioModel>>('/usuario/paginado', body);
  }

}
