import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import { NotFoundComponent, guardsDefault} from '@datasus/commons';

import { UsuarioListComponent } from './pages/list/usuario.list.component';
import { UsuarioFormComponent } from './pages/form/usuario.form.component';
import { UsuarioLocalResolver } from './resolvers/usuario-local.resolver';

const routes: Routes = [
  {
    path: '',
    component: NotFoundComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'error',
    }
  },
  {
    path: 'listar',
    component: UsuarioListComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'primary',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'editar/:id',
    component: UsuarioFormComponent,
    resolve: {
      item: UsuarioLocalResolver,
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'inserir',
    component: UsuarioFormComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'success',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: '**',
    redirectTo: '',
    pathMatch: 'full'
  },
];

@NgModule({
  imports: [
    RouterModule.forChild(routes),
  ],
  exports: [
    RouterModule,
  ],
})
export class UsuarioRoutingModule { }
