import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';

import { MaterialModule } from '../../material/material.module';
import { DatasusModule } from '../../datasus/datasus.module';
import { SharedModule } from '../shared/shared.module';

import { DadosPessoaisRoutingModule } from './dados-pessoais.routing.module';
import { AlteracaoSenhaComponent } from './pages/alteracao-senha/alteracao-senha.component';
import { AtualizacaoCadastroComponent } from './pages/atualizacao-cadastro/atualizacao-cadastro.component';
import { DadosPessoaisService } from './services/dados-pessoais.service';
import { UserEmailResolver } from './resolvers/user-email.resolver';

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // Dados Pessoais
    DadosPessoaisRoutingModule
  ],
  declarations: [
    AtualizacaoCadastroComponent,
    AlteracaoSenhaComponent
  ],
  providers: [
    DadosPessoaisService,
    UserEmailResolver,
  ],
})
export class DadosPessoaisModule { }
