import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import { NotFoundComponent, guardsDefault } from '@datasus/commons';
import { AtualizacaoCadastroComponent } from './pages/atualizacao-cadastro/atualizacao-cadastro.component';
import { AlteracaoSenhaComponent } from './pages/alteracao-senha/alteracao-senha.component';
import { UserEmailResolver } from './resolvers/user-email.resolver';

const routes: Routes = [
  {
    path: '',
    component: NotFoundComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'error'
    }
  },
  {
    path: 'atualizacao-cadastro',
    component: AtualizacaoCadastroComponent,
    resolve: {
      userEmail: UserEmailResolver,
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'alteracao-senha',
    component: AlteracaoSenhaComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: '**',
    redirectTo: '',
    pathMatch: 'full'
  },
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule]
})
export class DadosPessoaisRoutingModule { }
