import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';

import { Observable } from 'rxjs';
import { pluck } from 'rxjs/operators';

import { AuthService } from '@datasus/core';

@Injectable()
export class UserEmailResolver implements Resolve<string> {

  constructor(
    private authService: AuthService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<string> | Promise<string> | string {
    return this.authService.getUser().pipe(pluck('email'));
  }

}
