import { Injectable } from '@angular/core';

import { Observable } from 'rxjs';

import { BaseService } from '@datasus/core';
import { UsuarioCadastroModel } from '../models/usuario-cadastro.model';


@Injectable( )
export class DadosPessoaisService extends BaseService {
  atualizarCadastro(body: UsuarioCadastroModel): Observable<void> {
    return this.basePost<void>('/usuario-local/cadastro', body);
  }

  alterarSenha(senhaAtual: string, novaSenha: string): Observable<void> {
    return this.basePost<void>('/usuario-local/senha', {
      senhaAtual: senhaAtual,
      novaSenha: novaSenha,
    });
  }
}
