import { Component, OnInit } from '@angular/core';
import { ActivatedRoute, ParamMap } from '@angular/router';
import { trigger, state, style, transition, animate } from '@angular/animations';


@Component({
  selector: 'scodes-menu-hearder',
  templateUrl: './menu-hearder.component.html',
  styleUrls: ['./menu-hearder.component.scss'],
  animations: [
    trigger('fadeInOut', [
      state('void', style({
        opacity: 0
      })),
      transition('void <=> *', animate(1000)),
    ]),
  ],
})
export class MenuHearderComponent implements OnInit {

  routeLinkProtocolo: string;
  routeLinkProcessual: string;
  routeLinkTecnico: string;
  routeLinkAtendimento: string;
  routeLinkDispensacao: string;
  routeLinkHistorico: string;
  routeLinkProntuario: string;

  id: number | string;

  itens: any[];

  constructor(
    private route: ActivatedRoute,
  ) { }

  ngOnInit() {
    this.route.firstChild.paramMap
      .subscribe((params: ParamMap) => this.id = params.get('id'));

    if (this.id) {
      this.montarRouteLinkId();
      this.itens = [
        {titulo: 'PROTOCOLO', icone: 'archive', routeLink: this.routeLinkProtocolo},
        {titulo: 'PROCESSUAL', icone: 'gavel', routeLink: this.routeLinkProcessual},
        {titulo: 'TÉCNICO', icone: 'folder_shared', routeLink: this.routeLinkTecnico},
        {titulo: 'ATENDIMENTO', icone: 'description', routeLink: this.routeLinkAtendimento},
        {titulo: 'DISPENSAÇÃO', icone: 'list_alt', routeLink: this.routeLinkDispensacao},
        {titulo: 'HISTÓRICO', icone: 'history', routeLink: this.routeLinkHistorico},
        {titulo: 'PRONTUÁRIO', icone: 'assignment', routeLink: this.routeLinkProntuario},
      ];
    } else {
      this.montarRouteLinkSemId();
      this.itens = [
        {titulo: 'PROTOCOLO', icone: 'archive', routeLink: this.routeLinkProtocolo},
        // {titulo: 'PROCESSUAL', icone: 'gavel', routeLink: this.routeLinkProcessual},
        // {titulo: 'TÉCNICO', icone: 'folder_shared', routeLink: this.routeLinkTecnico},
        // {titulo: 'ATENDIMENTO', icone: 'description', routeLink: this.routeLinkAtendimento},
        // {titulo: 'DISPENSAÇÃO', icone: 'list_alt', routeLink: this.routeLinkDispensacao},
        // {titulo: 'HISTÓRICO', icone: 'history', routeLink: this.routeLinkHistorico},
        {titulo: 'PRONTUÁRIO', icone: 'assignment', routeLink: this.routeLinkProntuario}
      ];
    }






  }

  private montarRouteLinkId() {
    this.routeLinkProtocolo = `/demanda/menu/protocolo/${this.id}`;
    this.routeLinkProcessual = `/demanda/menu/processual/${this.id}`;
    this.routeLinkTecnico = `/demanda/menu/tecnico/${this.id}`;
    this.routeLinkAtendimento = `/demanda/menu/atendimento/${this.id}`;
    this.routeLinkDispensacao = `/demanda/menu/dispensacao/${this.id}`;
    this.routeLinkHistorico = `/demanda/menu/historico/${this.id}`;
    this.routeLinkProntuario = `/demanda/menu/prontuario/${this.id}`;
  }

  private montarRouteLinkSemId() {
    this.routeLinkProtocolo = '/demanda/menu/protocolo';
      this.routeLinkProcessual = `/demanda/menu/processual`;
      this.routeLinkTecnico = `/demanda/menu/tecnico`;
      this.routeLinkAtendimento = `/demanda/menu/atendimento`;
      this.routeLinkDispensacao = `/demanda/menu/dispensacao`;
      this.routeLinkHistorico = `/demanda/menu/historico`;
      this.routeLinkProntuario = `/demanda/menu/prontuario`;
  }



}
