import { DominioItemModel } from '@datasus/core';
import { TipoAcaoContraModel } from '../../shared/models/tipo-acao-contra.model';
import { TipoProcessoModel } from '../../shared/models/tipo-processo.model';

export class ListaProtocoloUtil {
  
  public static listaDocumentos = [
    { name: 'CPF', value: 1 },
    { name: 'RG', value: 2 },
    { name: 'CNS', value: 3 }
  ];

  public static listaTipoProcesso: TipoProcessoModel[] = [
    { descricao: 'Individual', id: 'I' },
    { descricao: 'Coletivo', id: 'C' }
  ];

  public static listaTipoAcaoContra: TipoAcaoContraModel[] = [
    { id: 'E', descricao: 'Estado' },
    { id: 'M', descricao: 'Município' },
    { id: 'EM', descricao: 'Estado + Município' },
    { id: 'UEM', descricao: 'Estado + Município + União' },
    { id: 'UE', descricao: 'Estado + União' },
    { id: 'UM', descricao: 'Município + União' }
  ];

  public static listaSexos = [
    { label: 'Masculino', value: 'M' },
    { label: 'Feminino', value: 'F' }
  ];

  public static listaPatrono: DominioItemModel[] = [
    { codigo: '4', descricao: 'Advogado' },
    { codigo: '5', descricao: 'Defensor Público' },
    { codigo: '6', descricao: 'Promotor' },
    { codigo: '8', descricao: 'Procurador' },
    { codigo: '88', descricao: 'Jefaz' },
    { codigo: '29', descricao: 'JEC' },
  ];


}