import { Component, OnInit } from '@angular/core';
import { FormGroup, FormBuilder } from '@angular/forms';
import { Observable } from 'rxjs';
import { ActivatedRoute, Router } from '@angular/router';
import { LayoutService, DialogService } from '@datasus/layout';

@Component({
  selector: 'scodes-prontuario-form',
  templateUrl: './prontuario-form.component.html',
  styleUrls: ['./prontuario-form.component.scss']
})
export class ProntuarioFormComponent implements OnInit {

  isSalvo: boolean;
  // Form Group
  formGroup: FormGroup;

  // Viewport Observable
  onMobile$: Observable<boolean>;

  constructor(
    private route: ActivatedRoute,
    private formBuilder: FormBuilder,
    private router: Router,
    private layoutService: LayoutService,
    private dialogService: DialogService,
  ) { }

  ngOnInit() {
    this.layoutService.setTitle('Cadastro de Demanada - Prontuário');
  }

  submit(event: Event) {
    event.preventDefault();
  }

}
