import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';

import { BaseService } from '@datasus/core';

import { ArvoreDemandaModel } from '../models/arvore-demanda.model';
import { ArquivoDemandaModel } from '../models/arquivo-demanda.model';

@Injectable({
  providedIn: 'root'
})
export class ArquivoArvoreService extends BaseService {

  incluir(data: ArquivoDemandaModel): Observable<ArquivoDemandaModel> {
    return this.basePost<ArquivoDemandaModel>(`/arquivo`, data);
  }

  excluirPorId(id: number): Observable<void> {
    return this.baseDelete<void>(`/arquivo/${id}`);
  }

  obterDiretoriosPorAutor(autorDemandaId: number): Observable<ArvoreDemandaModel[]> {
    return this.basePost<ArvoreDemandaModel[]>(`/arquivo/diretorios/${autorDemandaId}`, {});
  }

  obterArquivoPorDiretoriosAutor(diretorioId: number, autorDemandaId: number): Observable<ArquivoDemandaModel[]> {
    return this.basePost<ArquivoDemandaModel[]>(`/arquivo/arquivo-diretorio/${diretorioId}/${autorDemandaId}`, {});
  }


}
