import { Injectable } from '@angular/core';

import { BaseService } from '@datasus/core';
import { AutorModel } from 'src/app/shared/models/autor.model';
import { Observable } from 'rxjs';

@Injectable()
export class AutorService extends BaseService {

  incluir(body: AutorModel[]): Observable<AutorModel[]> {
    return this.basePost<AutorModel[]>('/autor', body);
  }

  alterar(body: AutorModel[], id: number): Observable<AutorModel[]> {
    return this.basePut<AutorModel[]>(`/autor/${id}`, body);
  }

  excluir(id: number): Observable<void> {
    return this.baseDelete<void>(`/autor/${id}`);
  }

}
