import { AlteracaoDataRetornoResolver } from './resolvers/alteracao-data-retorno.resolver';
import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';

import { NotFoundComponent, guardsDefault } from '@datasus/commons';
import { ListComponent } from './pages/list/list.component';
import { AlteracaoDataRetornoFormComponent } from './pages/alteracao-data-retorno-form/alteracao-data-retorno-form.component';


const routes: Routes = [
  { path: '', component: NotFoundComponent, data: { layoutAnimation: true, layoutColor: 'error', } },
  {
    path: 'listar',
    component: ListComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'primary',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'inserir',
    component: AlteracaoDataRetornoFormComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'success',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'editar/:id',
    component: AlteracaoDataRetornoFormComponent,
    resolve: {
      item: AlteracaoDataRetornoResolver,
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'detalhar/:id',
    component: AlteracaoDataRetornoFormComponent,
    resolve: {
      item: AlteracaoDataRetornoResolver,
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },  
  /*path component*/
  { path: '**', redirectTo: '', pathMatch: 'full' },
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule]
})
export class AlteracaoDataRetornoRoutingModule { }
