import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';

import { BaseService, PageableRequestModel, PageableResponseModel } from '@datasus/core';

import { EntradaEstoqueModel } from '../models/entrada-estoque.model';

@Injectable()
export class EntradaEstoqueService extends BaseService {

  obterPorId(id: number): Observable<EntradaEstoqueModel> {
    return this.baseGet<EntradaEstoqueModel>(`/entrada-estoque/${id}`);
  }

  obterTodosPaginado(body: PageableRequestModel<void>): Observable<PageableResponseModel<EntradaEstoqueModel>> {
    return this.basePost<PageableResponseModel<EntradaEstoqueModel>>('/entrada-estoque/paginado', body);
  }

  incluir(body: EntradaEstoqueModel): Observable<EntradaEstoqueModel> {
    return this.basePost<EntradaEstoqueModel>('/entrada-estoque', body);
  }

}
