import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';

import { BaseService, PageableRequestModel, PageableResponseModel } from '@datasus/core';

import { SaidaEstoqueModel } from '../models/saida-estoque.model';

@Injectable()
export class SaidaEstoqueService extends BaseService {

  obterPorId(id: number): Observable<SaidaEstoqueModel> {
    return this.baseGet<SaidaEstoqueModel>(`/saida-estoque/${id}`);
  }

  obterTodosPaginado(body: PageableRequestModel<void>): Observable<PageableResponseModel<SaidaEstoqueModel>> {
    return this.basePost<PageableResponseModel<SaidaEstoqueModel>>('/saida-estoque/paginado', body);
  }

  incluir(body: SaidaEstoqueModel): Observable<SaidaEstoqueModel> {
    return this.basePost<SaidaEstoqueModel>('/saida-estoque', body);
  }

}
