import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import { NotFoundComponent, guardsDefault } from '@datasus/commons';
import { InativarDemandaListComponent } from './page/inativar-demanda-list/inativar-demanda-list.component';
import { InativarDemandaFormComponent } from './page/inativar-demanda-form/inativar-demanda-form.component';


const routes: Routes = [
  {
    path: '',
    component: NotFoundComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'error'
    }
  },
  {
    path: 'listar',
    component: InativarDemandaListComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'primary',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },

  {
    path: 'inserir',
    component: InativarDemandaFormComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'success',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
{
    path: '**',
    redirectTo: '',
    pathMatch: 'full'
  },
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule]
})
export class InativarDemandaRoutingModule { }
