import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';

import { BaseService, PageableRequestModel, PageableResponseModel } from '@datasus/core';

import { InativarDemandaFilterModel } from '../models/inativar-demanda-filter.model';
import { InativarDemandaModel } from '../models/inativar-demanda.model';

@Injectable()
export class InativarDemandaService extends BaseService {

  obterTodosPaginado(body: PageableRequestModel<InativarDemandaFilterModel>): Observable<PageableResponseModel<InativarDemandaModel>> {
    return this.basePost<PageableResponseModel<InativarDemandaModel>>('/inativar-demanda/paginado', body);
  }

  incluir(body: InativarDemandaModel): Observable<InativarDemandaModel> {
    return this.basePost<InativarDemandaModel>('/inativar-demanda', body);
  }

  alterar(id: number, body: InativarDemandaModel): Observable<InativarDemandaModel> {
    return this.basePut<InativarDemandaModel>(`/inativar-demanda/${id}`, body);
  }


}
