import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import { guardsDefault, NotFoundComponent } from '@datasus/commons';

import { InventarioListComponent } from './pages/list/inventario-list.component';
import { InventarioFormComponent } from './pages/inventario-form/inventario-form.component';
import { InventarioResolver } from './resolvers/inventario.resolver';
import { InventarioItemComponent } from './pages/inventario-item/inventario-item.component';

const routes: Routes = [
  {
    path: '',
    component: NotFoundComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'error'
    }
  },
  {
    path: 'listar',
    component: InventarioListComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'primary',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'inserir',
    component: InventarioFormComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'success',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'item/:id',
    component: InventarioItemComponent,
    resolve: {
      inventario: InventarioResolver,
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
 {
    path: '**',
    redirectTo: '',
    pathMatch: 'full'
  },
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule]
})
export class InventarioRoutingModule { }
