import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FlexLayoutModule } from '@angular/flex-layout';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';

import { InventarioRoutingModule } from './inventario-routing.module';
import { MaterialModule } from 'src/material/material.module';
import { DatasusModule } from 'src/datasus/datasus.module';
import { SharedModule } from 'src/app/shared/shared.module';
import { InventarioListComponent } from './pages/list/inventario-list.component';
import { InventarioFormComponent } from './pages/inventario-form/inventario-form.component';
import { InventarioService } from './services/inventario.service';
import { InventarioResolver } from './resolvers/inventario.resolver';
import { InventarioItemComponent } from './pages/inventario-item/inventario-item.component';
import { InventarioItemService } from './services/inventario-item.service';
import { UnidadeDispensadoraService } from 'src/app/shared/services/unidade-dispensadora.service';

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // Inventario
    InventarioRoutingModule
  ],
  declarations: [
    InventarioListComponent,
    InventarioFormComponent,
    InventarioItemComponent,
  ],
  providers: [
    InventarioService,
    InventarioResolver,
    InventarioItemService,
  ],
})
export class InventarioModule { }
