import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';

import { InventarioModel } from '../models/inventario.model';
import { InventarioService } from '../services/inventario.service';

@Injectable()
export class InventarioResolver implements Resolve<InventarioModel> {

  constructor(
    private inventarioService: InventarioService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<InventarioModel> | Promise<InventarioModel> | InventarioModel {
    return this.inventarioService.obterPorId(route.params.id);
  }

}
