import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';

import { MaterialModule } from '../../../../material/material.module';
import { DatasusModule } from '../../../../datasus/datasus.module';
import { SharedModule } from '../../../shared/shared.module';
import { ModeloOficioRoutingModule } from './modelo-oficio-routing.module';
import { ModeloOficioService } from '../../../shared/services/modelo-oficio.service';
import { ModeloOficioResolver } from '../../../shared/resolvers/modelo-oficio.resolver';
import { ModeloOficioListComponent } from './pages/list/modelo-oficio.list.component';
import { ModeloOficioFormComponent } from './pages/form/modelo-oficio.form.component';
import { TipoDemandaService } from 'src/app/shared/services/tipo-demanda.service';
import { ModeloOficioViewComponent } from './pages/view/modelo-oficio.view.component';
/*import*/

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // ModeloOficio
    ModeloOficioRoutingModule,
  ],
  declarations: [
    /*declaration component*/
    ModeloOficioListComponent,
    ModeloOficioFormComponent,
    ModeloOficioViewComponent,
  ],
  providers: [
    /*declaration provider*/
    ModeloOficioResolver,
    ModeloOficioService,
    TipoDemandaService,
  ],
})
export class ModeloOficioModule { }
