import { Component, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { Observable } from 'rxjs';
import { take, map, filter, tap } from 'rxjs/operators';

import { LayoutService } from '@datasus/layout';

import { ModeloOficioModel } from 'src/app/shared/models/modelo-oficio.model';

@Component({
  selector: 'scodes-modelo-oficio-view',
  templateUrl: './modelo-oficio.view.component.html',
  styleUrls: ['./modelo-oficio.view.component.scss'],
})

export class ModeloOficioViewComponent implements OnInit {

  // Viewport Observable
  onMobile$: Observable<boolean>;

  modeloOficio: ModeloOficioModel;

  constructor(
    private route: ActivatedRoute,
    private layoutService: LayoutService,
  ) { }


  ngOnInit(): void {


    this.layoutService.setTitle('Visualizar Modelo Ofício');
    this.layoutService.off();
    this.onMobile$ = this.layoutService.onMobile();

    this.route.data.pipe(
      take(1),
      map((data: { item: ModeloOficioModel }) => data.item),
      filter((item: ModeloOficioModel) => !!item),
      tap((item: ModeloOficioModel) => this.modeloOficio = item),
    ).subscribe();
  }




}
