import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import { NotFoundComponent } from '@datasus/commons';

import { ModeloRelatorioTecnicoResolver } from '../../../shared/resolvers/modelo-relatorio-tecnico.resolver';

import { ModeloRelatorioTecnicoListComponent } from './pages/list/modelo-relatorio-tecnico.list.component';
import { ModeloRelatorioTecnicoFormComponent } from './pages/form/modelo-relatorio-tecnico.form.component';
import { ModeloRelatorioTecnicoViewComponent } from './pages/view/modelo-relatorio-tecnico.view.component';
/*import*/

const routes: Routes = [
  { path: '', component: NotFoundComponent, data: { layoutAnimation: true, layoutColor: 'error', } },
  {
    path: 'listar',
    component: ModeloRelatorioTecnicoListComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'primary',
    }
  },
  {
    path: 'visualizar/:id',
    component: ModeloRelatorioTecnicoViewComponent,
    resolve: {
      item: ModeloRelatorioTecnicoResolver
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    }
  },
  {
    path: 'editar/:id',
    component: ModeloRelatorioTecnicoFormComponent,
    resolve: {
      item: ModeloRelatorioTecnicoResolver
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    }
  },
  {
    path: 'inserir',
    component: ModeloRelatorioTecnicoFormComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'success',
    }
  },
  /*path component*/

  { path: '**', redirectTo: '', pathMatch: 'full' },
];

@NgModule({
  imports: [
    RouterModule.forChild(routes),
  ],
  exports: [
    RouterModule,
  ],
})
export class ModeloRelatorioTecnicoRoutingModule { }
