import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';

import { MaterialModule } from '../../../../material/material.module';
import { DatasusModule } from '../../../../datasus/datasus.module';
import { SharedModule } from '../../../shared/shared.module';
import { ModeloRelatorioTecnicoRoutingModule } from './modelo-relatorio-tecnico-routing.module';
import { ModeloRelatorioTecnicoService } from '../../../shared/services/modelo-relatorio-tecnico.service';
import { ModeloRelatorioTecnicoResolver } from '../../../shared/resolvers/modelo-relatorio-tecnico.resolver';
import { ModeloRelatorioTecnicoListComponent } from './pages/list/modelo-relatorio-tecnico.list.component';
import { ModeloRelatorioTecnicoFormComponent } from './pages/form/modelo-relatorio-tecnico.form.component';
import { TipoDemandaService } from 'src/app/shared/services/tipo-demanda.service';
import { ModeloRelatorioTecnicoViewComponent } from './pages/view/modelo-relatorio-tecnico.view.component';
/*import*/

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // ModeloRelatorioTecnico
    ModeloRelatorioTecnicoRoutingModule,
  ],
  declarations: [
    /*declaration component*/
    ModeloRelatorioTecnicoListComponent,
    ModeloRelatorioTecnicoFormComponent,
    ModeloRelatorioTecnicoViewComponent,
  ],
  providers: [
    /*declaration provider*/
    ModeloRelatorioTecnicoResolver,
    ModeloRelatorioTecnicoService,
    TipoDemandaService,
  ],
})
export class ModeloRelatorioTecnicoModule { }
