import { Component, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { Observable } from 'rxjs';
import { take, map, filter, tap } from 'rxjs/operators';

import { LayoutService } from '@datasus/layout';

import { ModeloRelatorioTecnicoModel } from 'src/app/shared/models/modelo-relatorio-tecnico.model';

@Component({
  selector: 'scodes-modelo-relatorio-tecnico-view',
  templateUrl: './modelo-relatorio-tecnico.view.component.html',
  styleUrls: ['./modelo-relatorio-tecnico.view.component.scss'],
})

export class ModeloRelatorioTecnicoViewComponent implements OnInit {

  // Viewport Observable
  onMobile$: Observable<boolean>;

  modeloRelatorioTecnico: ModeloRelatorioTecnicoModel;

  constructor(
    private route: ActivatedRoute,
    private layoutService: LayoutService,
  ) { }


  ngOnInit(): void {


    this.layoutService.setTitle('Visualizar Relatório Técnico');
    this.layoutService.off();
    this.onMobile$ = this.layoutService.onMobile();

    this.route.data.pipe(
      take(1),
      map((data: { item: ModeloRelatorioTecnicoModel }) => data.item),
      filter((item: ModeloRelatorioTecnicoModel) => !!item),
      tap((item: ModeloRelatorioTecnicoModel) => this.modeloRelatorioTecnico = item),
    ).subscribe();
  }




}
