import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import {guardsDefault, NotFoundComponent} from '@datasus/commons';

import { PlanoSaudeResolver } from './resolvers/plano-saude.resolver';

import { PlanoSaudeListComponent } from './pages/list/plano-saude.list.component';
import { PlanoSaudeFormComponent } from './pages/form/plano-saude.form.component';
/*import*/

const routes: Routes = [
  { path: '', component: NotFoundComponent, data: { layoutAnimation: true, layoutColor: 'error', } },
  {
    path: 'listar',
    component: PlanoSaudeListComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'primary',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'editar/:id',
    component: PlanoSaudeFormComponent,
    resolve: {
      item: PlanoSaudeResolver
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'inserir',
    component: PlanoSaudeFormComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'success',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  /*path component*/

  { path: '**', redirectTo: '', pathMatch: 'full' },
];

@NgModule({
  imports: [
    RouterModule.forChild(routes),
  ],
  exports: [
    RouterModule,
  ],
})
export class PlanoSaudeRoutingModule { }
