import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';

import { ProdutoModel } from '../models/produto.model';
import { ProdutoService } from '../services/produto.service';

@Injectable()
export class ProdutoResolver implements Resolve<ProdutoModel> {

  constructor(
    private produtoService: ProdutoService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<ProdutoModel> | Promise<ProdutoModel> | ProdutoModel {
    return this.produtoService.obterPorId(route.params.idProduto);
  }
}
