import { CommonModule } from '@angular/common';
import { NgModule } from '@angular/core';
import { FlexLayoutModule } from '@angular/flex-layout';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { NgxMaskModule } from 'ngx-mask';
import { TipoDemandaService } from 'src/app/shared/services/tipo-demanda.service';
import { DatasusModule } from '../../../../datasus/datasus.module';
import { MaterialModule } from '../../../../material/material.module';
import { ProfissionalResolver } from '../../../shared/resolvers/profissional.resolver';
import { ProfissionalService } from '../../../shared/services/profissional.service';
import { SharedModule } from '../../../shared/shared.module';
import { ProfissionalListComponent } from './pages/list/profissional.list.component';
import { ProfissionalFormComponent } from './pages/form/profissional.form.component';
import { ProfissionalRoutingModule } from './profissional-routing.module';

/*import*/

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    FlexLayoutModule,
    MaterialModule,
    DatasusModule,
    SharedModule,
    ProfissionalRoutingModule,
    NgxMaskModule,
  ],
  declarations: [
    /*declaration component*/
    ProfissionalListComponent,
    ProfissionalFormComponent,
  ],
  providers: [
    /*declaration provider*/
    ProfissionalResolver,
    ProfissionalService,
    TipoDemandaService,
  ],
})
export class ProfissionalModule { }
