import { ItemModel } from '../../produto/models/item.model';
import { ActivatedRouteSnapshot, RouterStateSnapshot, Resolve } from '@angular/router';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';

import { ItemService } from '../../../../shared/services/item.service';

@Injectable()
export class SimilaridadeResolver implements Resolve<ItemModel> {

  constructor(
    private itemService: ItemService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<ItemModel> | Promise<ItemModel> | ItemModel {
    return this.itemService.obterPorId(route.params.id);
  }
}
