import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import { NotFoundComponent, guardsDefault } from '@datasus/commons';

import { ProdutoListComponent } from './pages/similaridade-list/similaridade-list.component';
import { PesquisaItemComponent } from './pages/pesquisa-item/pesquisa-item.component';
import { SimilaridadeResolver } from './resolvers/similaridade.resolver';

const routes: Routes = [
  { path: '', component: NotFoundComponent, data: { layoutAnimation: true, layoutColor: 'error', } },
  {
    path: 'listar',
    component: ProdutoListComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'primary',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: ':id/item',
    component: PesquisaItemComponent,
    resolve: {
      item: SimilaridadeResolver,
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  /*path component*/
  { path: '**', redirectTo: '', pathMatch: 'full' },
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule]
})
export class SimilaridadeRoutingModule { }
