import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';
import { NgxMaskModule } from 'ngx-mask';
import { NgxCurrencyModule } from 'ngx-currency';

import { SimilaridadeRoutingModule } from './similaridade-routing.module';
import { MaterialModule } from 'src/material/material.module';
import { DatasusModule } from 'src/datasus/datasus.module';
import { SharedModule } from 'src/app/shared/shared.module';
import { ProdutoListComponent } from './pages/similaridade-list/similaridade-list.component';
import { PesquisaItemComponent } from './pages/pesquisa-item/pesquisa-item.component';
import { SimilaridadeResolver } from './resolvers/similaridade.resolver';

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // JSDADDY Ngx Mask
    NgxMaskModule.forChild({ dropSpecialCharacters: true }),
    // Ngx Currency
    NgxCurrencyModule,
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // Item
    SimilaridadeRoutingModule
  ],
  declarations: [
    /*declaration component*/
    ProdutoListComponent,
    PesquisaItemComponent
  ],
  providers: [
    /*declaration provider*/
    SimilaridadeResolver,
  ]
})
export class SimilaridadeModule { }
