import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';

import { TipoAcaoService } from '../services/tipo-acao.service';
import { TipoAcaoModel } from '../models/tipo-acao.model';

@Injectable()
export class TipoAcaoResolver implements Resolve<TipoAcaoModel> {

  constructor(
    private tipoAcaoService: TipoAcaoService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<TipoAcaoModel> | Promise<TipoAcaoModel> | TipoAcaoModel {
    return this.tipoAcaoService.obterPorId(route.params.id);
  }

}
