import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';

import { TipoCobrancaModel } from '../models/tipo-cobranca.model';
import { TipoCobrancaService } from '../services/tipo-cobranca.service';

@Injectable()
export class TipoCobrancaResolver implements Resolve<TipoCobrancaModel> {

  constructor(
    private tipoCobrancaService: TipoCobrancaService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<TipoCobrancaModel> | Promise<TipoCobrancaModel> | TipoCobrancaModel {
    return this.tipoCobrancaService.obterPorId(route.params.id);
  }

}
