import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import {guardsDefault, NotFoundComponent} from '@datasus/commons';

import { TipoCobrancaResolver } from './resolvers/tipo-cobranca.resolver';

import { TipoCobrancaListComponent } from './pages/list/tipo-cobranca.list.component';
import { TipoCobrancaFormComponent } from './pages/form/tipo-cobranca.form.component';
/*import*/

const routes: Routes = [
  { path: '', component: NotFoundComponent, data: { layoutAnimation: true, layoutColor: 'error', } },
  {
    path: 'listar',
    component: TipoCobrancaListComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'primary',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'editar/:id',
    component: TipoCobrancaFormComponent,
    resolve: {
      item: TipoCobrancaResolver
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'inserir',
    component: TipoCobrancaFormComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'success',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  /*path component*/

  { path: '**', redirectTo: '', pathMatch: 'full' },
];

@NgModule({
  imports: [
    RouterModule.forChild(routes),
  ],
  exports: [
    RouterModule,
  ],
})
export class TipoCobrancaRoutingModule { }
