import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';
import { NgxMaskModule } from 'ngx-mask';

import { MaterialModule } from '../../../../material/material.module';
import { DatasusModule } from '../../../../datasus/datasus.module';

import { SharedModule } from '../../../shared/shared.module';

import { TipoCobrancaRoutingModule } from './tipo-cobranca-routing.module';
import { TipoCobrancaService } from './services/tipo-cobranca.service';
import { TipoCobrancaResolver } from './resolvers/tipo-cobranca.resolver';
import { TipoCobrancaListComponent } from './pages/list/tipo-cobranca.list.component';
import { TipoCobrancaFormComponent } from './pages/form/tipo-cobranca.form.component';
/*import*/

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // JSDADDY Ngx Mask
    NgxMaskModule.forChild({ dropSpecialCharacters: true }),
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // TipoCobranca
    TipoCobrancaRoutingModule,
  ],
  declarations: [
    /*declaration component*/
    TipoCobrancaListComponent,
    TipoCobrancaFormComponent,
  ],
  providers: [
    /*declaration provider*/
    TipoCobrancaResolver,
    TipoCobrancaService,
  ],
})
export class TipoCobrancaModule { }
