import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';
import { NgxMaskModule } from 'ngx-mask';

import { MaterialModule } from '../../../../material/material.module';
import { DatasusModule } from '../../../../datasus/datasus.module';
import { SharedModule } from '../../../shared/shared.module';
import { TipoDocumentoRoutingModule } from './tipo-documento-routing.module';
import { TipoDocumentoService } from './services/tipo-documento.service';
import { TipoDocumentoResolver } from './resolvers/tipo-documento.resolver';
import { TipoDocumentoListComponent } from './pages/list/tipo-documento.list.component';
import { TipoDocumentoFormComponent } from './pages/form/tipo-documento.form.component';
/*import*/

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // JSDADDY Ngx Mask
    NgxMaskModule.forChild({ dropSpecialCharacters: true }),
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // TipoDocumento
    TipoDocumentoRoutingModule,
  ],
  declarations: [
    /*declaration component*/
    TipoDocumentoListComponent,
    TipoDocumentoFormComponent,
  ],
  providers: [
    /*declaration provider*/
    TipoDocumentoResolver,
    TipoDocumentoService,
  ],
})
export class TipoDocumentoModule { }
