import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';
import { NgxMaskModule } from 'ngx-mask';

import { MaterialModule } from 'src/material/material.module';
import { DatasusModule } from 'src/datasus/datasus.module';
import { SharedModule } from 'src/app/shared/shared.module';
import { UnidadeTransferenciaRoutingModule } from './unidade-transferencia-routing.module';

import { UnidadeTransferenciaResolver } from './resolvers/unidade-transferencia.resolver';

import { UnidadeTransferenciaListComponent } from './pages/list/unidade-transferencia.list.component';
import { UnidadeTransferenciaFormComponent } from './pages/form/unidade-transferencia.form.component';
/*import*/

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // JSDADDY Ngx Mask
    NgxMaskModule.forChild({ dropSpecialCharacters: true }),
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // UnidadeTransferencia
    UnidadeTransferenciaRoutingModule,
  ],
  declarations: [
    /*declaration component*/
    UnidadeTransferenciaListComponent,
    UnidadeTransferenciaFormComponent,
  ],
  providers: [
    /*declaration provider*/
    UnidadeTransferenciaResolver,
  ],
})
export class UnidadeTransferenciaModule { }
