import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import { NotFoundComponent } from '@datasus/commons';

import { VaraResolver } from '../../../shared/resolvers/vara.resolver';

import { VaraListComponent } from './pages/list/vara.list.component';
import { VaraFormComponent } from './pages/form/vara.form.component';
/*import*/

const routes: Routes = [
  { path: '', component: NotFoundComponent, data: { layoutAnimation: true, layoutColor: 'error', } },
  {
    path: 'listar',
    component: VaraListComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'primary',
    }
  },
  {
    path: 'editar/:id',
    component: VaraFormComponent,
    resolve: {
      item: VaraResolver
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    }
  },
  {
    path: 'inserir',
    component: VaraFormComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'success',
    }
  },
  /*path component*/

  { path: '**', redirectTo: '', pathMatch: 'full' },
];

@NgModule({
  imports: [
    RouterModule.forChild(routes),
  ],
  exports: [
    RouterModule,
  ],
})
export class VaraRoutingModule { }
