import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';

import { ModeloOficioModel } from '../models/modelo-oficio.model';
import { ModeloOficioService } from '../services/modelo-oficio.service';

@Injectable()
export class ModeloOficioResolver implements Resolve<ModeloOficioModel> {

  constructor(
    private modeloOficioService: ModeloOficioService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    _state: RouterStateSnapshot,
  ): Observable<ModeloOficioModel> | Promise<ModeloOficioModel> | ModeloOficioModel {
    return this.modeloOficioService.obterPorId(route.params.id);
  }

}
