import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';

import { ModeloRelatorioTecnicoModel } from '../models/modelo-relatorio-tecnico.model';
import { ModeloRelatorioTecnicoService } from '../services/modelo-relatorio-tecnico.service';

@Injectable()
export class ModeloRelatorioTecnicoResolver implements Resolve<ModeloRelatorioTecnicoModel> {

  constructor(
    private modeloService: ModeloRelatorioTecnicoService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    _state: RouterStateSnapshot,
  ): Observable<ModeloRelatorioTecnicoModel> | Promise<ModeloRelatorioTecnicoModel> | ModeloRelatorioTecnicoModel {
    return this.modeloService.obterPorId(route.params.id);
  }

}
