import { Injectable } from '@angular/core';
import { ActivatedRouteSnapshot, Resolve, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';
import { ProfissionalService } from '../services/profissional.service';
import { ProfissionalModel } from '../models/profissional.model';


@Injectable()
export class ProfissionalResolver implements Resolve<ProfissionalModel> {

  constructor(
    private modeloService: ProfissionalService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    _state: RouterStateSnapshot,
  ): Observable<ProfissionalModel> | Promise<ProfissionalModel> | ProfissionalModel {
    return this.modeloService.obterPorId(route.params.id);
  }

}
