import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';

import { BaseService, DominioItemModel, PageableRequestModel, PageableResponseModel } from '@datasus/core';

import { FornecedorModel } from '../models/fornecedor.model';

@Injectable({
  providedIn: 'root'
})
export class FornecedorService extends BaseService {

  obterPorId(id: number): Observable<FornecedorModel> {
    return this.baseGet<FornecedorModel>(`/fornecedor/${id}`);
  }

  obterTodos(): Observable<FornecedorModel[]> {
    return this.baseGet<FornecedorModel[]>('/fornecedor');
  }

  obterTodosPaginado(body: PageableRequestModel<void>): Observable<PageableResponseModel<FornecedorModel>> {
    return this.basePost<PageableResponseModel<FornecedorModel>>('/fornecedor/paginado', body);
  }

  obterDominio(): Observable<DominioItemModel[]> {
    return this.baseGet<DominioItemModel[]>('/fornecedor/dominio');
  }

}
