import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';

import { BaseService, DominioItemModel, PageableRequestModel, PageableResponseModel } from '@datasus/core';

import { TipoMovimentacaoModel } from '../models/tipo-movimentacao.model';
import { TipoMovimentacaoTipoEnum } from '../enums/tipo-movimentacao-tipo.enum';

@Injectable({
  providedIn: 'root'
})
export class TipoMovimentacaoService extends BaseService {

  obterPorId(id: number): Observable<TipoMovimentacaoModel> {
    return this.baseGet<TipoMovimentacaoModel>(`/tipo-movimentacao/${id}`);
  }

  obterTodos(): Observable<TipoMovimentacaoModel[]> {
    return this.baseGet<TipoMovimentacaoModel[]>('/tipo-movimentacao');
  }

  obterTodosPaginado(body: PageableRequestModel<void>): Observable<PageableResponseModel<TipoMovimentacaoModel>> {
    return this.basePost<PageableResponseModel<TipoMovimentacaoModel>>('/tipo-movimentacao/paginado', body);
  }

  obterDominio(): Observable<DominioItemModel[]> {
    return this.baseGet<DominioItemModel[]>('/tipo-movimentacao/dominio');
  }

  obterDominioPorTipo(tipo: TipoMovimentacaoTipoEnum): Observable<DominioItemModel[]> {
    return this.baseGet<DominioItemModel[]>(`/tipo-movimentacao/dominio/tipo/${tipo}`);
  }

}
